#pragma once

#ifndef TalkyH
#define TalkyH

#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN		 // Exclude rarely-used stuff from Windows headers
#endif

#ifndef _WIN32_WINNT
#define _WIN32_WINNT  0x0500     // For CoInitializeEx support
#endif
//---------------------------------------------------------------------------
#include <Windows.h>
#include <objbase.h>
#include <MemWork.h>
#include "sapi.h"
#include "sapidef.h"

//---------------------------------------------------------------------------
#ifndef DEFCALL
#define DEFCALL __stdcall
#endif
//---------------------------------------------------------------------------
#define SPKTOSNDC 0
#define SPKTOMEMB 1
#define SPKTOWAVF 2
//---------------------------------------------------------------------------
#define  SOAF8kHz8BitM     4
#define  SOAF8kHz8BitS     5
#define  SOAF8kHz16BitM    6
#define  SOAF8kHz16BitS    7
#define  SOAF11kHz8BitM    8
#define  SOAF11kHz8BitS    9
#define  SOAF11kHz16BitM  10
#define  SOAF11kHz16BitS  11
#define  SOAF12kHz8BitM   12
#define  SOAF12kHz8BitS   13
#define  SOAF12kHz16BitM  14
#define  SOAF12kHz16BitS  15
#define  SOAF16kHz8BitM   16
#define  SOAF16kHz8BitS   17
#define  SOAF16kHz16BitM  18
#define  SOAF16kHz16BitS  19
#define  SOAF22kHz8BitM   20
#define  SOAF22kHz8BitS   21
#define  SOAF22kHz16BitM  22
#define  SOAF22kHz16BitS  23
#define  SOAF24kHz8BitM   24
#define  SOAF24kHz8BitS   25
#define  SOAF24kHz16BitM  26
#define  SOAF24kHz16BitS  27
#define  SOAF32kHz8BitM   28
#define  SOAF32kHz8BitS   29
#define  SOAF32kHz16BitM  30
#define  SOAF32kHz16BitS  31
#define  SOAF44kHz8BitM   32
#define  SOAF44kHz8BitS   33
#define  SOAF44kHz16BitM  34
#define  SOAF44kHz16BitS  35
#define  SOAF48kHz8BitM   36
#define  SOAF48kHz8BitS   37
#define  SOAF48kHz16BitM  38
#define  SOAF48kHz16BitS  39

//---------------------------------------------------------------------------
// Used 'Automation' TTS SAPI interface because CPP 'SpVoice' interfece
//   do not have 'GetVoices' method, and it is a bit simplier.
//
struct CTALKY
{
 private:
   DWORD   VConfigSize;
   PVOID   PrevVoiceBuf;
   HANDLE  DefHeapHandle;
   wchar_t VoiceString[256];
   wchar_t VoiceConfig[256]; 
   wchar_t WavFilePath[256];
	 ISpeechVoice        *Voice;    
     ISpeechFileStream   *FileStream;     
	 ISpeechMemoryStream *MemoryStream;
	 ISpeechObjectTokens *VoicesList;
     ISpeechAudioFormat  *AudioFormat;
 public: 
   BOOL    Asynchr;
   DWORD   SpeakTo;
   wchar_t *SVoicesList;
 
   DWORD DEFCALL SpeakText(LPSTR Text);
   DWORD DEFCALL SetVoice(LPSTR VoiceName);
   DWORD DEFCALL SetVoiceConfig(LPSTR Config);
   DWORD DEFCALL SetWavFileName(LPSTR Filename);
   DWORD DEFCALL SetOutputFormat(DWORD OutputFmt);
   DWORD DEFCALL GetSpeechBuffer(PVOID *Buffer, DWORD *Size);
   DWORD DEFCALL GetVoicesList(LPSTR DestBuffer, DWORD BufferSize, PDWORD VCount);
   DWORD DEFCALL GetOutputFormat(DWORD *SamplePerSec, DWORD *BitsPerSample, DWORD *Channels);
   DWORD DEFCALL Initialize(DWORD OutTgt=SPKTOSNDC, BOOL Async=FALSE);
   void  DEFCALL UnInitialize(void);
   void  DEFCALL SetDefaults(void);

   DEFCALL CTALKY(BOOL Init=FALSE);
   DEFCALL ~CTALKY();
};
typedef CTALKY* PCTALKY;
//---------------------------------------------------------------------------
#endif
