//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "CPSMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfMWCPatch *fMWCPatch;
//---------------------------------------------------------------------------
AnsiString __fastcall TfMWCPatch::OptLabelToIniName(AnsiString OptLabel)
{
 AnsiString TempStr;
 char       SingleCh;

 for(int ctr=1;ctr <= OptLabel.Length();ctr++)
  {
   if(!IsCharAlphaNumeric(OptLabel[ctr]))continue;
   if((ctr > 1)&&(!IsCharAlphaNumeric(OptLabel[ctr-1]))){
      SingleCh = OptLabel[ctr];
      SingleCh = (char)CharUpper((LPSTR)((DWORD)SingleCh));
      TempStr = TempStr+SingleCh;}
    else TempStr = TempStr+OptLabel[ctr];
  }
 return TempStr;
}
//---------------------------------------------------------------------------
void __fastcall TfMWCPatch::AddMessage(AnsiString Message)
{
 meMessages->Lines->Add("["+FormatDateTime("hh:nn:ss",Now())+"] "+Message);
}
//---------------------------------------------------------------------------
void __fastcall TfMWCPatch::FindGameInstallation(void)
{
 int CPos;

 GameInstDir = StartUpDir;
 while(GetFileAttributes((GameInstDir+GAMEEXEFILE).c_str()) == INVALID_FILE_ATTRIBUTES)
  {
   GameInstDir = GameInstDir.SetLength(GameInstDir.Length()-1);
   if((CPos = STRWORK::swCharPosFromRight(GameInstDir.c_str(), '\\', 0, 0)) < 0)
	{
	 if(odOpenGameInst->Execute())GameInstDir = ExtractFilePath(odOpenGameInst->FileName);
	   else TerminateProcess(GetCurrentProcess(),0); // This is an only way to break app initialization
	 return;
	}
   GameInstDir = GameInstDir.SetLength(CPos+1);
  }
 GameInstDir = (GameInstDir+GAMEEXEFILE);
}
//---------------------------------------------------------------------------
__fastcall TfMWCPatch::TfMWCPatch(TComponent* Owner) : TForm(Owner)
{
 StartUpDir = ExtractFilePath(Application->ExeName);
 CfgFile    = new TIniFile(StartUpDir+CONFIGINIFILE);
 Describe   = new TStringList();
 Describe->LoadFromFile(StartUpDir+DESCFILENAME);
 PatchData  = NULL;
 PatchSize  = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfMWCPatch::FormCreate(TObject *Sender)
{
 bool       OptState;
 DWORD      Offset;
 DWORD      FileRva;
 LPSTR      CurSignature;
 HANDLE     hDataFile;
 MWPATCH    *CurPatch;
 AnsiString NumID;
 AnsiString TempStr;
 AnsiString NodeName;
 TTreeNode *CurNode = NULL;
 TTreeNode *CurItem = NULL;

 FindGameInstallation();
 hDataFile = CreateFile((StartUpDir+PATCHFILENAME).c_str(),GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
 if(hDataFile == INVALID_HANDLE_VALUE)return;
 PatchSize = GetFileSize(hDataFile,NULL);
 PatchData = HeapAlloc(GetProcessHeap(),0,PatchSize);
 if(PatchData)ReadFile(hDataFile,PatchData,PatchSize,&PatchSize,NULL);
 CloseHandle(hDataFile);

 hDataFile = CreateFile(GameInstDir.c_str(),GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
 if(hDataFile == INVALID_HANDLE_VALUE)return;
 GameSize  = GetFileSize(hDataFile,NULL);
 GameData  = HeapAlloc(GetProcessHeap(),0,GameSize);
 if(GameData)ReadFile(hDataFile,GameData,GameSize,&GameSize,NULL);
 CloseHandle(hDataFile);

 AddMessage("Loading patch descriptions...");
 for(int ctr=0;ctr < Describe->Count;ctr++)
  {
   TempStr = Describe->Strings[ctr].Trim();
     if((ctr < 2) || (!Describe->Strings[ctr].IsEmpty() && Describe->Strings[ctr-1].IsEmpty() && Describe->Strings[ctr-2].IsEmpty()))
      {
       if(TempStr[1] == '-'){CurNode = twOptions->Items->AddObject(NULL,TempStr.Delete(1,TempStr.Pos(" ")),(PVOID)ctr);NodeName = OptLabelToIniName(CurNode->Text.Trim());}
         else
          {
           if(CurNode && (ctr > 2))
            {
             NumID    = TempStr;
             NumID    = NumID.SetLength(TempStr.Pos(" ")-1);
             TempStr  = TempStr.Delete(1,TempStr.Pos(" ")).Trim();
             CurItem  = twOptions->Items->AddChildObject(CurNode,TempStr,(PVOID)ctr);
             CurItem->StateIndex = ((int)CfgFile->ReadBool(NodeName,(IntToHex(StrToInt(NumID),8)+"_"+OptLabelToIniName(TempStr)),true))+1;
            }
          }
      }
  }
 if((twOptions->Items->Count > 0)&&!twOptions->Items->Item[0]->HasChildren){fMWCPatch->Caption = twOptions->Items->Item[0]->Text.Trim();twOptions->Items->Item[0]->Delete();}
 twOptions->FullExpand();
 AddMessage("OK.");

 AddMessage("Enumerating patches...");
 Offset = 0;
 while(Offset < PatchSize)
  {
   CurPatch = (MWPATCH*)&((PBYTE)PatchData)[Offset];
   Offset  += (CurPatch->PatchLength+sizeof(MWPATCH));
   AddMessage((AnsiString)"Found: "+IntToHex((int)CurPatch->PatchID,8)+"-"+IntToHex((int)CurPatch->PatchOffset,8)+"-"+IntToHex((int)CurPatch->PatchLength,8));
  }
 if(PatchSize)AddMessage("OK.");
   else {AddMessage("ERROR: Patch file not found!");return;}

 AddMessage("Rebuilding signatures...");
 CurSignature = (LPSTR)HeapAlloc(GetProcessHeap(),0,512);
 Offset = 0;
 while(Offset < PatchSize)
  {
   CurPatch = (MWPATCH*)&((PBYTE)PatchData)[Offset];
   Offset  += (CurPatch->PatchLength+sizeof(MWPATCH));
   CurSignature = (LPSTR)HeapReAlloc(GetProcessHeap(),0,CurSignature,(CurPatch->PatchLength*2)+32);
   MakeDiffSignature(&((PBYTE)GameData)[CurPatch->PatchOffset], CurPatch->PatchData, CurPatch->PatchLength, CurSignature);
   WritePrivateProfileString(IntToHex((int)CurPatch->PatchID,8).c_str(), IntToHex((int)CurPatch->PatchOffset,8).c_str(), CurSignature, (StartUpDir+SIGNATUREFILE).c_str());
  }

 HeapFree(GetProcessHeap(),0,CurSignature);
 AddMessage("OK.");
}
//---------------------------------------------------------------------------
void __fastcall TfMWCPatch::imgHeaderDblClick(TObject *Sender)
{
 if(imgHeader->Tag)twOptions->FullExpand();
   else twOptions->FullCollapse();
 imgHeader->Tag = !imgHeader->Tag;
}
//---------------------------------------------------------------------------
void __fastcall TfMWCPatch::meMessagesDblClick(TObject *Sender)
{
 meMessages->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TfMWCPatch::FormClose(TObject *Sender, TCloseAction &Action)
{
 AnsiString NumID;
 TTreeNode  *CurNode;

 DeleteFile((StartUpDir+CONFIGINIFILE).c_str());
 for(int ctr=0;ctr < twOptions->Items->Count;ctr++)
  {
   CurNode = twOptions->Items->Item[ctr];
   if(CurNode->StateIndex < 0)continue;   // Not option
   NumID = Describe->Strings[(int)CurNode->Data].Trim();
   NumID = NumID.SetLength(NumID.Pos(" ")-1);
   CfgFile->WriteBool(OptLabelToIniName(CurNode->Parent->Text),(IntToHex(StrToInt(NumID),8)+"_"+OptLabelToIniName(CurNode->Text)),(bool)(CurNode->StateIndex-1));
  }

 CfgFile->UpdateFile();
 fMWCPatch->Hint = AUTHORSTRING;    // My name :)
 delete(CfgFile);
 delete(Describe);
}
//---------------------------------------------------------------------------
void __fastcall TfMWCPatch::twOptionsKeyPress(TObject *Sender, char &Key)
{
 if((Key == 0x20) && twOptions->Selected && (twOptions->Selected->StateIndex >= 0))twOptions->Selected->StateIndex = ((int)(!((bool)(twOptions->Selected->StateIndex-1))))+1;
}
//---------------------------------------------------------------------------
void __fastcall TfMWCPatch::twOptionsClick(TObject *Sender)
{
 POINT     Point;
 TTreeNode *CurNode;

 GetCursorPos(&Point);
 ::ScreenToClient(twOptions->Handle,&Point);
 CurNode = twOptions->GetNodeAt(Point.x, Point.y);
 if(CurNode && (CurNode->StateIndex >= 0) && (Point.x > 35) && (Point.x < 55))twOptions->Selected->StateIndex = ((int)(!((bool)(twOptions->Selected->StateIndex-1))))+1;
}
//---------------------------------------------------------------------------
void __fastcall TfMWCPatch::twOptionsChange(TObject *Sender, TTreeNode *Node)
{
 int LineIndex;

 meDescript->Clear();
 if(Node->StateIndex < 0)return;
 LineIndex = ((int)Node->Data)+1;

 for(;LineIndex < Describe->Count;LineIndex++)
  {
   if(Describe->Strings[LineIndex].IsEmpty() && Describe->Strings[LineIndex-1].IsEmpty())break;
   meDescript->Lines->Add(Describe->Strings[LineIndex]);
   meDescript->SelStart  = 0;
   meDescript->SelLength = 0;
  }
}
//---------------------------------------------------------------------------

