
#include "ExtensionMod.h"
//====================================================================================
//					 
// This unit contains functions, related on global data or other functions addresses
//
//
//====================================================================================
BOOL APIENTRY DLLMain(HMODULE hModule, DWORD ReasonCall, LPVOID lpReserved)
{				           //  Only one thread will execute within DLLMAIN
 PVOID PatchAddr;

 switch(ReasonCall)	    
  {
   case DLL_PROCESS_ATTACH:
     ThisLibBase      = hModule;
     DefHeapHandle    = GetProcessHeap();
	 ExeModuleBase    = GetModuleHandle(NULL);
	 MLDRWriteLogFile = GetProcAddress(GetModuleHandle(MLDRLIBNAME),MLDRLOGPROC);
	 GetModuleFileName(hModule,(LPSTR)&CurrentDir,sizeof(CurrentDir));
	 GetModuleFileName(ExeModuleBase,(LPSTR)&GameCurDir,sizeof(GameCurDir));	     
	 FastZeroMemory(&LogFilePath, sizeof(LogFilePath));	

	 if(MLDRWriteLogFile)lstrcpy((LPSTR)&LogFilePath, ((LPSTR (_stdcall*)(LPSTR,LPSTR))MLDRWriteLogFile)(NULL,NULL));	// Get path of Log file	 
	 for(int ctr=(lstrlen((LPSTR)&CurrentDir)-1);ctr > 0;ctr--){if(CurrentDir[ctr] == '\\'){CurrentDir[ctr+1] = 0;break;}}    
	 for(int ctr=(lstrlen((LPSTR)&GameCurDir)-1);ctr > 0;ctr--){if(GameCurDir[ctr] == '\\'){GameCurDir[ctr+1] = 0;break;}}    	
     if((PatchAddr = GetProcAddress(GetModuleHandle(NULL),MLDRPROCNAME))){ModuleLoader=TRUE;break;}   // Just if the function present   

     LOGMSGOUT("Main EXE module loaded at %08X.", &ModWriteLogFile, (DWORD)ExeModuleBase);     
     if((PatchAddr = GetProcAddress(GetModuleHandle(NULL),MLDRPROCNAME)))break;   // Just if the function present   
      
	 LOGMSGOUT("Starting %s...", &ModWriteLogFile, THISMODNAME);     
     ApplyPatches(CONFIGINIFILE,SIGNATUREFILE,PATCHFILENAME);
	 break;									

   case DLL_THREAD_ATTACH:
     break;

   case DLL_THREAD_DETACH:
     break;

   case DLL_PROCESS_DETACH: 
	 ModEventOnHostExit();
	 break;
   default : return false;  // WRONG REASON CODE !!!!!!
  }
 return true;
}
//====================================================================================
DWORD _stdcall ModEventOnHostExit(void)
{
 LOGMSGOUT("Unloading...", &ModWriteLogFile);
 return 0;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModEventOnHostStart(void)
{
 LOGMSGOUT("Initialized.", &ModWriteLogFile);
 return 0;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModGetVersion(void)
{
 return MOD_VERSION;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModGetParameters(void)
{
 return MOD_PARAMETERS;
}
//------------------------------------------------------------------------------------
LPSTR _stdcall ModGetConfigShellName(void)
{
 return SHELLCFGNAME;
}
//------------------------------------------------------------------------------------
DWORD  _stdcall ModRunConfigShell(DWORD Reserved)
{
 BYTE ShellPath[MAX_PATH];

 lstrcpy((LPSTR)&ShellPath, (LPSTR)&CurrentDir);
 lstrcat((LPSTR)&ShellPath, SHELLCFGNAME);
 if(WinExec((LPSTR)&ShellPath,SW_SHOWNORMAL) > 31)return 0;
 return 1;
}
//------------------------------------------------------------------------------------
void  _stdcall ModWriteLogFile(LPSTR LogMessage)
{
 BYTE DateTimeBuf[64];

 if(LogFilePath[0])
  {
   FormatCurDateTime((LPSTR)&DateTimeBuf);
   WritePrivateProfileString(THISMODNAME,(LPSTR)&DateTimeBuf,LogMessage,(LPSTR)&LogFilePath);
  }
}
//====================================================================================
//
//					                  OTHER FUNCTIONS
//
//====================================================================================
void _stdcall ApplyPatches(LPSTR CfgFileName, LPSTR SigFileName, LPSTR PatFileName)
{
 HANDLE  hDataFile;
 PVOID   PatchData;
 DWORD   PatchSize;
 PVOID   ConfigData;
 DWORD   ConfigSize;
 DWORD   PatchCount;
 PDWORD  PatchTable;
 BYTE    CfgFilePath[MAX_PATH];
 BYTE    SigFilePath[MAX_PATH];
 BYTE    PatFilePath[MAX_PATH];

 LOGMSGOUT("Beginning apply patches...", &ModWriteLogFile); 
 if(CfgFileName[1]!= ':'){lstrcpy((LPSTR)&CfgFilePath,(LPSTR)&CurrentDir);lstrcat((LPSTR)&CfgFilePath, CfgFileName);CfgFileName = (LPSTR)&CfgFilePath;}
 if(SigFileName[1]!= ':'){lstrcpy((LPSTR)&SigFilePath,(LPSTR)&CurrentDir);lstrcat((LPSTR)&SigFilePath, SigFileName);SigFileName = (LPSTR)&SigFilePath;}
 if(PatFileName[1]!= ':'){lstrcpy((LPSTR)&PatFilePath,(LPSTR)&CurrentDir);lstrcat((LPSTR)&PatFilePath, PatFileName);PatFileName = (LPSTR)&PatFilePath;}

 hDataFile = CreateFile(PatFileName,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
 if(hDataFile != INVALID_HANDLE_VALUE)
  {
   PatchSize = GetFileSize(hDataFile,NULL);
   PatchData = HeapAlloc(DefHeapHandle,0,PatchSize);
   if(PatchData)ReadFile(hDataFile,PatchData,PatchSize,&PatchSize,NULL);
   CloseHandle(hDataFile);
  }
   else LOGMSGOUT("Cannot open a patch data file!", &ModWriteLogFile); 

 hDataFile   = CreateFile(CfgFileName,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
 if(hDataFile != INVALID_HANDLE_VALUE)
  {
   ConfigSize  = GetFileSize(hDataFile,NULL);
   ConfigData  = HeapAlloc(DefHeapHandle,0,ConfigSize);
   if(ConfigData)ReadFile(hDataFile,ConfigData,ConfigSize,&ConfigSize,NULL);
   CloseHandle(hDataFile);
  }
   else LOGMSGOUT("Cannot open a configuration file!", &ModWriteLogFile); 

 PatchCount    = GetPatchesCount(PatchData, PatchSize);
 PatchTable    = (PDWORD)HeapAlloc(DefHeapHandle,0,(sizeof(DWORD)*PatchCount));
 PatchCount    = GetEnabledPatches((LPSTR)ConfigData, &PatchTable[1])+1;
 PatchTable[0] = 0;  // Always inject control procedures  (need for some patches)
 for(int ctr=0;(ctr < PatchCount)&&(PatchCount > 1);ctr++)
  { 
   if(!IsPatchSignaturesOk(SigFileName, PatchData, PatchSize, PatchTable[ctr])){LOGMSGOUT("Signature not match for '%08X' patch!", &ModWriteLogFile,PatchTable[ctr]);continue;}
   LOGMSGOUT("Applying patch '%08X'.", &ModWriteLogFile, PatchTable[ctr]);
   if(WritePatches(PatchData, PatchSize, PatchTable[ctr]))LOGMSGOUT("Failed to apply patch '%08X'!", &ModWriteLogFile, PatchTable[ctr]);
 //    else LOGMSGOUT("Patch '%08X' OK.", &ModWriteLogFile, PatchTable[ctr]);
  }

 LOGMSGOUT("Patching finished.", &ModWriteLogFile); 
 HeapFree(DefHeapHandle,0,PatchData);
 HeapFree(DefHeapHandle,0,ConfigData);
 HeapFree(DefHeapHandle,0,PatchTable);
}
//====================================================================================
DWORD _stdcall GetPatchesCount(PVOID PatchBlock, DWORD BlockSize)
{
 MWPATCH *CurPatch;
 DWORD   PatchCount  = 0;
 DWORD   PatchOffset = 0;
 
 while(PatchOffset < BlockSize)
  {
   CurPatch     = (MWPATCH*)&((PBYTE)PatchBlock)[PatchOffset];
   PatchOffset += (CurPatch->PatchLength+sizeof(MWPATCH));
   PatchCount++;
  }
 return PatchCount;
}
//====================================================================================
bool _stdcall IsPatchSignaturesOk(LPSTR SigFileName, PVOID PatchBlock, DWORD BlockSize, DWORD PatchId)
{
 MWPATCH *CurPatch;
 PVOID   PatchAddress; 
 LPSTR   CurSignature;
 DWORD   PatchOffset = 0;
 BOOL    Result      = true;
 BYTE    PatchNumber[10];
 BYTE    PatchOffsEt[10];   // Compiler has a BUG: This name cannot be 'PatchOffset' !!! 
 
 while(Result && (PatchOffset < BlockSize))
  {
   CurPatch     = (MWPATCH*)&((PBYTE)PatchBlock)[PatchOffset];
   PatchOffset += (CurPatch->PatchLength+sizeof(MWPATCH));
   if(CurPatch->PatchID != PatchId)continue;
   PatchAddress = &((PBYTE)ExeModuleBase)[FileOffsetToRva(ExeModuleBase,CurPatch->PatchOffset,NULL)];  
   CurSignature = (LPSTR)HeapAlloc(DefHeapHandle,0,(CurPatch->PatchLength*2)+32);
   ConvertToHexDW(CurPatch->PatchID, 8, (LPSTR)&PatchNumber,true);
   ConvertToHexDW(CurPatch->PatchOffset, 8, (LPSTR)&PatchOffsEt,true);
   GetPrivateProfileString((LPSTR)&PatchNumber,(LPSTR)&PatchOffsEt,"",CurSignature,(CurPatch->PatchLength*2)+16,SigFileName);
   Result = IsMemSignatureMatch(PatchAddress, CurSignature, lstrlen(CurSignature));
   HeapFree(DefHeapHandle,0,CurSignature);
  } 
 return Result;
}
//====================================================================================
DWORD _stdcall WritePatches(PVOID PatchBlock, DWORD BlockSize, DWORD PatchId)
{
 MWPATCH *CurPatch;
 PVOID   PatchAddress; 
 DWORD   PatchOffset = 0;

 while(PatchOffset < BlockSize)
  {
   CurPatch     = (MWPATCH*)&((PBYTE)PatchBlock)[PatchOffset];
   PatchOffset += (CurPatch->PatchLength+sizeof(MWPATCH));
   if(CurPatch->PatchID != PatchId)continue;
   PatchAddress = &((PBYTE)ExeModuleBase)[FileOffsetToRva(ExeModuleBase,CurPatch->PatchOffset,NULL)];  
   if(WriteLocalProtectedMemory(PatchAddress, CurPatch->PatchData, CurPatch->PatchLength, true) < CurPatch->PatchLength)return 1;  
  }
 return 0;
}
//====================================================================================
DWORD _stdcall GetEnabledPatches(LPSTR CfgFile, PDWORD PatchTable)
{
 int   CurPos;
 int   PatchCtr = 0;
 DWORD CurPatchID;
 
 while((CurPos=CharPosFromLeft(CfgFile, '\n', 0, 0)) >= 0)
  {
   CfgFile   += CurPos+1;
   if(CfgFile[0] == '[')continue;
   CurPatchID = HexStrToDW(CfgFile);
   if((CurPos = CharPosFromLeft(CfgFile, '=', 0, 0)) < 0)continue;
   CfgFile   += CurPos;
   if(CfgFile[1] == '0')continue;   // Patch disabled
   PatchTable[PatchCtr] = CurPatchID;
   PatchCtr++;
  }
 return PatchCtr;
}
//====================================================================================

