//---------------------------------------------------------------------------

#ifndef MFormFuncsH
#define MFormFuncsH

//---------------------------------------------------------------------------
#define _LPCWAVEFORMATEX_DEFINED
#define DIRECTSOUND_VERSION  0x0800

#include <Classes.hpp>
#include <Mmreg.h>
#include "MiscFuncs.h"
#include "dsound.h"
#include "Talky.h"
#include "StrWork.h"
#include "FormatPE.h"
#include "RichEdExt.h"
#include "ResourcePE.h"
#include "VclLocalizer.h"
//---------------------------------------------------------------------------
#define AUTHORSTRING "78DA011900E6FFD8C0D5CCC0CDCEC220C2C8CAD2CED020C0CDC4D0C5C5C2C8D7EF121267";
#define GAMEINIFILE  "Morrowind.ini"
#define TALKYLOCFILE "Localize.xml"
#define TALKYINIFILE "TalkyConfig.ini"  
#define MLDRINSTNAME "TargetName"
#define INJLIBNAME   "MWTalkyMod.dll"
#define MLDRLIBNAME  "ModuleLoader.dll"
#define MLDRINIFILE  "ModuleLoader.ini"
#define MLDRSECNAME  "ModulesList"
#define MLDRSECPARAM "Parameters"
#define PITCHMAX     10000
#define PITCHMIN     -10000
//---------------------------------------------------------------------------
// These numbers are related to 'Localize.xml', DO NOT CHANGE them. Just Add/Remove, if needed.
enum OptFlags {ofVoiceFxByRace=1, ofSearchSpeechFile=2, ofFilterSpeechFile=3, ofTTSBoundPitchDS=4, ofStopSpkOnClose=5, ofVDocAutoSpeak=6, ofVDlgAutoSpeak=7, ofVDocEnable=8, ofVDlgEnable=9, ofDlgSwitchToFP=10, ofDlgEnableZoom=11, ofAlwReadOpenJnl=12, ofDocVoiceAsDlg=13, ofMPauseChargen=14, ofMPauseService=15, ofMPauseResting=16, ofMPauseJournal=17, ofMPauseDialogue=18, ofMPauseContainer=19, ofMPauseInventory=20, ofMPauseDocuments=21, ofMPauseMessages=22, ofMPauseOptions=23, ofMKeepAiChargen=24, ofMKeepAiService=25, ofMKeepAiResting=26, ofMKeepAiJournal=27, ofMKeepAiDialogue=28, ofMKeepAiContainer=29, ofMKeepAiInventory=30, ofMKeepAiDocuments=31, ofMKeepAiMessages=32, ofMKeepAiOptions=33, ofMEnableGmChargen=34, ofMEnableGmService=35, ofMEnableGmResting=36, ofMEnableGmJournal=37, ofMEnableGmDialogue=38, ofMEnableGmContainer=39, ofMEnableGmInventory=40, ofMEnableGmDocuments=41, ofMEnableGmMessages=42, ofMEnableGmOptions=43,ofSpkAfterFocusNpc=44};

typedef HRESULT _stdcall (*CREATE_DSOUND8)(LPCGUID pcGuidDevice, LPDIRECTSOUND8 *ppDS8, LPUNKNOWN pUnkOuter);

struct CFGBLOCK
{
 DWORD LangIndex;
 DWORD SpeakKeyCode;    // Speak last sended text (F1) (Four bytes, each = ONE virtual key code; 0 - Not requested)
 DWORD SilenceKeyCode;  // Stop all speaking	  (F2) (Four bytes, each = ONE virtual key code; 0 - Not requested)
 int   MaxDialogueFOV;
 int   MinDialogueFOV;
 int   PickPocketMode;
 bool  VoiceFxByRace;
 bool  SearchSpeechFile;
 bool  FilterSpeechFile;
 bool  TTSBoundPitchDS;
 bool  SpkAfterFocusNpc;
 bool  StopSpkOnClose;  // Stop speaking when menu mode closed
 bool  VDocAutoSpeak;
 bool  VDlgAutoSpeak;
 bool  VDocEnable;
 bool  VDlgEnable;
 bool  DlgSwitchToFP;
 bool  DlgEnableZoom;
 bool  AlwReadOpenJnl;  // Always read text in appeared journal,even if it is was readed before journal was closed
 bool  DocVoiceAsDlg;   // Read journal and documents by Player`s gender voice
 bool  MPauseChargen;
 bool  MPauseService;
 bool  MPauseResting;
 bool  MPauseJournal;
 bool  MPauseDialogue;
 bool  MPauseContainer;
 bool  MPauseInventory;
 bool  MPauseDocuments;
 bool  MPauseMessages;
 bool  MPauseOptions;
 bool  MKeepAiChargen;
 bool  MKeepAiService;
 bool  MKeepAiResting;
 bool  MKeepAiJournal;
 bool  MKeepAiDialogue;
 bool  MKeepAiContainer;
 bool  MKeepAiInventory;
 bool  MKeepAiDocuments;
 bool  MKeepAiMessages;
 bool  MKeepAiOptions;
 bool  MEnableGmChargen;
 bool  MEnableGmService;
 bool  MEnableGmResting;
 bool  MEnableGmJournal;
 bool  MEnableGmDialogue;
 bool  MEnableGmContainer;
 bool  MEnableGmInventory;
 bool  MEnableGmDocuments;
 bool  MEnableGmMessages;
 bool  MEnableGmOptions;
 short VPOrc;
 short VPNord;
 short VPBreton;
 short VPKhajiit;
 short VPDarkElf;
 short VPHighElf;
 short VPWoodElf;
 short VPArgonian;
 short VPImperial;
 short VPRedguard;
 short VPBaseMale;
 short VPBaseFemale;
 short VPBaseCreature;
 AnsiString  VDocName;
 AnsiString  VDlgNameMale;
 AnsiString  VDlgNameFemale;
 AnsiString  VDlgNameCreature;
 AnsiString  VDocConfig;
 AnsiString  VDlgCfgMale;
 AnsiString  VDlgCfgFemale;
 AnsiString  VDlgCfgCreature;
 AnsiString	 GameInstDir;
 AnsiString  ConfigAppName;
};
//---------------------------------------------------------------------------
#endif
