//$$---- Form CPP ----
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfmTCfgMain *fmTCfgMain;

//---------------------------------------------------------------------------
__fastcall TfmTCfgMain::TfmTCfgMain(TComponent* Owner) : TForm(Owner)
{
 fix__fpreset();      // For good of the TTS !!!
 StartUpDir    = ExtractFilePath(Application->ExeName);
 ExeModuleName = ExtractFileName(Application->ExeName);
 IniCfg        = new CFGBLOCK;
 CfgFile       = new TIniFile(StartUpDir+TALKYINIFILE);
 Localizer     = new CLocalizer();
 TestVoice     = new CTALKY(true);
 ZeroMemory(IniCfg,sizeof(CFGBLOCK));
 // Try to find an user`s LOC file
 if(GetFileAttributes((StartUpDir+TALKYLOCFILE).c_str())!=INVALID_FILE_ATTRIBUTES)Localizer->LoadLocFile((StartUpDir+TALKYLOCFILE).c_str());
   else Localizer->SetLocDocument((LPSTR)GetDataFromResource("LOCALIZE"));

 CurLangIndex = Localizer->GetLangIndexByID((GetUserDefaultLangID()&0x00FF));
 CurLangIndex = (CurLangIndex < 0)?(0):(CurLangIndex);
 Application->Title = Localizer->GetLocString(CurLangIndex,"APPTITLE");

 pDSound8        = NULL;
 pDSBuffer       = NULL;
 CurTestMsgIndex = 0;
 cbTestRaceType->ItemIndex = 0;
 ZeroMemory(&WaveFmtx,sizeof(WAVEFORMATEX));
 TfmTCfgMain::ExtractTalkyLib();    // Always refresh for a protection reason !!!
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::FormCreate(TObject *Sender)
{
 BYTE VoiceLst[1024];

 reHelpInfo->Tag        = ((DWORD*)(&(reHelpInfo->WindowProc)))[0];
 reHelpInfo->WindowProc = TfmTCfgMain::HlpRichEdWndProc;

 TestVoice->GetVoicesList((LPSTR)&VoiceLst, sizeof(VoiceLst), NULL);
 cbVoiceDoc->Items->SetText((LPSTR)&VoiceLst);
 cbVDlgCrea->Items->SetText((LPSTR)&VoiceLst);
 cbVDlgMale->Items->SetText((LPSTR)&VoiceLst);
 cbVDlgFemale->Items->SetText((LPSTR)&VoiceLst);

 //SaveAppLangFile((StartUpDir+"Local7ize.xml").c_str(), "ENG", "English", LANG_ENGLISH, "1251", "cbVKeysList,odOpenGameInst,reHelpInfo,meInstMessages,meTestText,cbVDlgMale,cbVDlgFemale,cbVDlgCrea,cbVoiceDoc,sbTstStrPrev,sbTstStrNext,edZoomMinFOV,edZoomMaxFOV");

 TfmTCfgMain::LoadConfiguration();
 TfmTCfgMain::FindGameInstallation();
 TfmTCfgMain::CfgUpdateControls();
 GameIniFile     = new TIniFile(GameInstDir+GAMEINIFILE);
 CurTestMsgIndex = TfmTCfgMain::ShowVTestString(CurTestMsgIndex);

 int InstStatus = TfmTCfgMain::IsTalkyLibInstalled();
 bInstall->Enabled   = (InstStatus == 0);
 bUnInstall->Enabled = (InstStatus == 2);
 TfmTCfgMain::ShowInstStatus();

 pcMainPageCtrl->ActivePage       = tsPageSetup;
 pcVDlgGenderPageCtrl->ActivePage = tsVDlgMale;
 //sclbDSFilters->VertScrollBar->Position = 200;  // Do not work !!!
 twOptionFlags->Items->GetFirstNode()->getNextSibling()->Expand(false);

 WaveFmtx.wFormatTag      = WAVE_FORMAT_PCM;
 WaveFmtx.nChannels       = 1;
 WaveFmtx.nSamplesPerSec  = 44100;
 WaveFmtx.wBitsPerSample  = 16;
 WaveFmtx.nBlockAlign     = (WORD)((WaveFmtx.wBitsPerSample/8)*WaveFmtx.nChannels);
 WaveFmtx.nAvgBytesPerSec = (DWORD)(WaveFmtx.nSamplesPerSec*WaveFmtx.nBlockAlign);
 WaveFmtx.cbSize          = 0;

 DSoundCreate8 = (CREATE_DSOUND8)GetProcAddress(LoadLibrary("dsound.dll"),"DirectSoundCreate8");
 if(DSoundCreate8)DSoundCreate8(NULL,&pDSound8,NULL);
 if(pDSound8)pDSound8->SetCooperativeLevel(fmTCfgMain->Handle, DSSCL_NORMAL);  //   DSSCL_PRIORITY
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::FormClose(TObject *Sender, TCloseAction &Action)
{
 TfmTCfgMain::CfgUpdateConfig();    // From controls to memory
 TfmTCfgMain::SaveConfiguration();  // From memory to file
 TestVoice->UnInitialize();

 fmTCfgMain->Hint = AUTHORSTRING;    // My name :)
 delete(GameIniFile);
 delete(CfgFile);
 delete(IniCfg);
 delete(TestVoice);
 delete(Localizer);
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::sbTstStrPrevClick(TObject *Sender)
{
 CurTestMsgIndex = TfmTCfgMain::ShowVTestString(-CurTestMsgIndex);
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::sbTstStrNextClick(TObject *Sender)
{
 CurTestMsgIndex = TfmTCfgMain::ShowVTestString(CurTestMsgIndex);
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::edKeyA_BSKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
 if(Key == VK_MENU)Key = (GetKeyState(VK_LMENU)&0x8000)?(VK_LMENU):(VK_RMENU);
 if(Key == VK_SHIFT)Key = (GetKeyState(VK_LSHIFT)&0x8000)?(VK_LSHIFT):(VK_RSHIFT);
 if(Key == VK_CONTROL)Key = (GetKeyState(VK_LCONTROL)&0x8000)?(VK_LCONTROL):(VK_RCONTROL);
 ((TEdit*)Sender)->Tag  = Key;
 ((TEdit*)Sender)->Text = cbVKeysList->Items->Strings[Key];
 Key = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::edKeyA_BSDblClick(TObject *Sender)
{
 ((TEdit*)Sender)->Tag = 0;
 ((TEdit*)Sender)->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::bHearTestVoiceClick(TObject *Sender)
{
 DWORD WavDataSize;
 DWORD SBufSize;
 PVOID SBufPtr;
 PWORD WavData;
 DWORD CurFreq   = 0;
 long  FreqShift = 0;
 int   CurRacePitch;

 TfmTCfgMain::CfgUpdateConfig();

 TestVoice->UnInitialize();
 TestVoice->Initialize((pDSound8)?(SPKTOMEMB):(SPKTOSNDC), FALSE);   // Use direct to sound card if no direct sound available
 TestVoice->SetOutputFormat(SOAF44kHz16BitM);
 CurRacePitch = ((TTrackBar*)cbTestRaceType->Items->Objects[cbTestRaceType->ItemIndex])->Position * 100;

 //                               !!! CHECK THESE PARAMETERS !!!
 switch(cbTestVoice->ItemIndex)
  {
   case 0:
	 if(IniCfg->TTSBoundPitchDS)TestVoice->SetVoiceConfig(TfmTCfgMain::ChangeNumberInXml(GetPitchTTSRelativeToDS(CurRacePitch),"PITCH ABSMIDDLE",IniCfg->VDlgCfgMale).c_str());
	   else TestVoice->SetVoiceConfig(IniCfg->VDlgCfgMale.c_str());
	 TestVoice->SetVoice(IniCfg->VDlgNameMale.c_str());
	 break;
   case 1:
	 if(IniCfg->TTSBoundPitchDS)TestVoice->SetVoiceConfig(TfmTCfgMain::ChangeNumberInXml(GetPitchTTSRelativeToDS(CurRacePitch),"PITCH ABSMIDDLE",IniCfg->VDlgCfgFemale).c_str());
	   else TestVoice->SetVoiceConfig(IniCfg->VDlgCfgFemale.c_str());
	 TestVoice->SetVoice(IniCfg->VDlgNameFemale.c_str());
	 break;
   case 2:
     TestVoice->SetVoiceConfig(IniCfg->VDlgCfgCreature.c_str());
	 TestVoice->SetVoice(IniCfg->VDlgNameCreature.c_str());
	 break;
   case 3:
	 TestVoice->SetVoiceConfig(IniCfg->VDocConfig.c_str());
	 TestVoice->SetVoice(IniCfg->VDocName.c_str());
	 break;
   default: return;  // ERROR: List is empty!!!
  }

 TestVoice->SpeakText(meTestText->Text.c_str());
 if(TestVoice->GetSpeechBuffer((PVOID*)&WavData, &WavDataSize))return;
 if(pDSound8)
  {
   DsBufDesc.dwSize          = sizeof(DSBUFFERDESC);
   DsBufDesc.dwFlags         = (DSBCAPS_GLOBALFOCUS|DSBCAPS_CTRLFREQUENCY);
   DsBufDesc.lpwfxFormat     = &WaveFmtx;
   DsBufDesc.dwBufferBytes   = (WavDataSize > DSBSIZE_MAX)?(DSBSIZE_MAX):((WavDataSize < DSBSIZE_MIN)?DSBSIZE_MIN:WavDataSize);
   DsBufDesc.guid3DAlgorithm = DS3DALG_DEFAULT;

   if(pDSBuffer){pDSBuffer->Stop();pDSBuffer->Release();pDSBuffer=NULL;}
   pDSound8->CreateSoundBuffer(&DsBufDesc, &pDSBuffer, 0);
   if(pDSBuffer)
	{
	 pDSBuffer->Lock(0, 0, &SBufPtr, &SBufSize, 0, 0, DSBLOCK_ENTIREBUFFER);
	 CopyMemory(SBufPtr, WavData, SBufSize);
	 pDSBuffer->Unlock(SBufPtr, SBufSize, 0, 0);

	 // Set voice pitch
	 pDSBuffer->GetFrequency(&CurFreq);

	 if(cbTestVoice->ItemIndex == 0)FreqShift = IniCfg->VPBaseMale;
	   else {if(cbTestVoice->ItemIndex == 1)FreqShift = IniCfg->VPBaseFemale;}
     if(cbTestVoice->ItemIndex == 2)FreqShift = IniCfg->VPBaseCreature;
	 if(IniCfg->VoiceFxByRace && (cbTestVoice->ItemIndex < 2))FreqShift += CurRacePitch;   // Not for docs or creatues

	 CurFreq = ((int)CurFreq) + FreqShift;   // + or - results
	 if(CurFreq < 0x00000064)CurFreq = 0x00000064;
	   else {if(CurFreq > 0x000186A0)CurFreq = 0x000186A0;}
	 pDSBuffer->SetFrequency(CurFreq);

	 pDSBuffer->Play(0,0,0);
	}
  }   
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::bInstallClick(TObject *Sender)
{
 TfmTCfgMain::InstallTalkyLib();
 if(TfmTCfgMain::IsTalkyLibInstalled() > 0)
  {
   bInstall->Enabled   = false;
   bUnInstall->Enabled = true;
  }
 TfmTCfgMain::ShowInstStatus();
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::bUnInstallClick(TObject *Sender)
{
 TfmTCfgMain::UnInstallTalkyLib();
 if(TfmTCfgMain::IsTalkyLibInstalled() <= 0)
  {
   bInstall->Enabled   = true;
   bUnInstall->Enabled = false;
  }
 TfmTCfgMain::ShowInstStatus(); 
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::sbLngRusClick(TObject *Sender)
{
 if((int)IniCfg->LangIndex == ((TComponent*)Sender)->Tag)return;
 TfmTCfgMain::CfgUpdateConfig();
 TfmTCfgMain::CfgUpdateControls();
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::cbTestVoiceChange(TObject *Sender)
{
 cbTestRaceType->Enabled = (cbTestVoice->ItemIndex < 2);
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::twOptionFlagsClick(TObject *Sender)
{
 TTreeNode* Node = MouseOnTreeNodeImage((TTreeView*)Sender);
 if(Node && Node->Data)
  {
   (*((bool*)Node->Data)) = !(*((bool*)Node->Data));
   Node->StateIndex = (*((bool*)Node->Data))?(1):(2);
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmTCfgMain::twOptionFlagsKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
 if(Key != VK_SPACE)return;
 TTreeNode* Node = ((TTreeView*)Sender)->Selected;
 if(Node && Node->Data)
  {
   (*((bool*)Node->Data)) = !(*((bool*)Node->Data));
   Node->StateIndex = (*((bool*)Node->Data))?(1):(2);
  }
}
//---------------------------------------------------------------------------


