
#include "ExtensionMod.h"

PCModData   ModInfo;
//====================================================================================
//					             THE EXPORTED FUNCTIONS
//------------------------------------------------------------------------------------
BOOL APIENTRY DLLMain(HMODULE hModule, DWORD ReasonCall, LPVOID lpReserved)
{
 DWORD  Index;
 DWORD  Result;
 PBYTE  PatchBase;
      
 switch(ReasonCall)	    
  {
   case DLL_PROCESS_ATTACH:
     ModInfo = ModInfo->Initialize();
     ModInfo->ThisLibBase      = hModule; 
     ModInfo->hDefHeap         = GetProcessHeap();
	 ModInfo->ExeModuleBase    = GetModuleHandle(NULL);
	 ModInfo->ModWriteLogFile  = &ModWriteLogFile;
	 ModInfo->MLDRWriteLogFile = GetProcAddress(GetModuleHandle(MLDRLIBNAME),MLDRLOGPROC);
	 PatchBase                 = (PBYTE)ModInfo->ExeModuleBase;
	 GetModuleFileName(ModInfo->ThisLibBase,(LPSTR)&ModInfo->CurrentDir,sizeof(ModInfo->CurrentDir));    

	 if(ModInfo->MLDRWriteLogFile)lstrcpy((LPSTR)&ModInfo->LogFilePath, ((LPSTR (_stdcall*)(LPSTR,LPSTR))ModInfo->MLDRWriteLogFile)(NULL,NULL));	// Get path of Log file	 
	 for(int ctr=(lstrlen((LPSTR)&ModInfo->CurrentDir)-1);ctr > 0;ctr--){if(ModInfo->CurrentDir[ctr] == '\\'){ModInfo->CurrentDir[ctr+1] = 0;break;}}    
     GetModuleFileName(ModInfo->ExeModuleBase,(LPSTR)&ModInfo->GameDirectory,sizeof(ModInfo->GameDirectory));	     
     TrimToFilePath((LPSTR)&ModInfo->GameDirectory);
     lstrcpy((LPSTR)&ModInfo->CfgFilePath, (LPSTR)&ModInfo->CurrentDir);
     lstrcat((LPSTR)&ModInfo->CfgFilePath, CfgFileName);
     lstrcpy((LPSTR)&ModInfo->SpeechDirectory, (LPSTR)&ModInfo->GameDirectory); 
     lstrcat((LPSTR)&ModInfo->SpeechDirectory, "Data Files\\Speech\\");                                                     
	 LoadConfiguration((LPSTR)&ModInfo->CfgFilePath);
     
     LOGMSGOUT("DLLMAIN::Main EXE module loaded at %08X.", ModInfo->ModWriteLogFile, (DWORD)ModInfo->ExeModuleBase);     
	 if(GetProcAddress(ModInfo->ExeModuleBase,MLDRPROCNAME)){ModInfo->ModuleLoader=true;break;}   // Just if the function present   
      
	 LOGMSGOUT("DLLMAIN::Starting %s...", ModInfo->ModWriteLogFile, THISMODNAME);  	           
     Result    = Index = 0; 
     PatchBase = (PBYTE)ModInfo->ExeModuleBase;
     //================================================================================
     // TODO: Place hooks into a linked list
     // For making a hook chains in modiles, better DO NOT USE 'SetCmdValue' ans 'SetAddressInVFT'.  TODO: Make fast chaining hooks for 'CALL XXXX' instead of directly setting address
     LOGMSGOUT("DLLMAIN::Setting hook on checking 'MouseLookDisabled' flag.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x00169264],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__CamLookDisabling),"8A85B20500");   
 	
  	 //-------------------------------------------------------------------    
     LOGMSGOUT("DLLMAIN::Setting hook on camera`s vertical delta writing.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x00169148],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__CamLookVertDelta),"84C0895C24");  
  	
  	 //-------------------------------------------------------------------    
     LOGMSGOUT("DLLMAIN::Setting hook on camera`s horizontal delta writing.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x00169120],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__CamLookHortDelta),"894C241C8B");  
  	  	 	  	
   	 //-------------------------------------------------------------------                                      
     LOGMSGOUT("DLLMAIN::Setting hook on locking Player`s sneaking in menu mode.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x00169781],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__PlayerSneakLocking),"8A85B00500");  
 	 	  	          
  	 //-------------------------------------------------------------------                                      
     LOGMSGOUT("DLLMAIN::Setting hook on checking 'GoToJail'.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x00167F9D],GetAddress<PVOID>(&CObjMACP::__GoToJailChecking),"E87E260000"); 
  	      	      
  	 //-------------------------------------------------------------------  
     LOGMSGOUT("DLLMAIN::Setting hook for enabling hints in inventory when no an object focused.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x0001B3D6],GetAddress<PVOID>(&CRenderer::__ProcessPlayerUseAction),"E875160000");  
       
	 //-------------------------------------------------------------------  
     LOGMSGOUT("DLLMAIN::Setting hook on exiting from menu mode.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x001951AB],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__ExitMenuMode),"E8A0020000");  // 0x001951B0 patched by the 'Text.dll' 
              
	 //-------------------------------------------------------------------	
     LOGMSGOUT("DLLMAIN::Setting hook on AI action changing.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x0012EAB5],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__ActorAiActionChanging),"8B86C80000");  
          
	 //-------------------------------------------------------------------          
     LOGMSGOUT("DLLMAIN::Setting hook to changing voice pitch.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x0008C6B6],GetAddress<PVOID>(&CSoundBase::__SetDSBufFrequency),"E8A563F7FF");   
      
     //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook for pausing water riffles in menu mode.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x0011C896],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__MenuFreezingWaterRiffles),"8A88D60000");  
                          
     //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook for pausing doors moving in menu mode.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x000E721C],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__MenuFreezingDoors),"8A88D60000");   
   
     //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook for pausing shadows in menu mode.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x000388D0],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__MenuFreezingShadows),"8A88D60000");   
   
     //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook for pausing compass in menu mode.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x001EB7BC],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__MenuFreezingCompass),"8A88D60000");  
   
     //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook for pausing an active objects in menu mode.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x0000F68D],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__MenuFreezingActiveObjects),"8A86D60000");  
                                                            
     //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook for allowing head tracking in menu mode.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x0006F420],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__DlgAllowingHeadTrack),"8A81D60000");  
                                                                                                         
 	 //-------------------------------------------------------------------  
     LOGMSGOUT("DLLMAIN::Setting hook for DIALOGS and JOURNAL.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x0000BE32],GetAddress<PVOID>(&CTESFont::__PrepareTextDlgJnl),"E8C9F6FFFF");  
                
	 //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook for opening books.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x000A2A15],GetAddress<PVOID>(__OpenBook),"E886981000");  
             
	 //-------------------------------------------------------------------	              
     LOGMSGOUT("DLLMAIN::Setting hook for opening documents.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x002138FB],GetAddress<PVOID>(__OpenDocument),"E860F7FFFF");   
                                                                                                     
	 //-------------------------------------------------------------------	 
     LOGMSGOUT("DLLMAIN::Setting hook for book page changing.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x001AC36B],GetAddress<PVOID>(__ChangeBookPageForward),"6870C95A00"); 
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x001ABE9C],GetAddress<PVOID>(__ChangeBookPageForward),"6870C95A00");   	                      
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x001AC358],GetAddress<PVOID>(__ChangeBookPageBackward),"68C0C85A00");   
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x001ABCBF],GetAddress<PVOID>(__ChangeBookPageBackward),"68C0C85A00");  
	     
	 //-------------------------------------------------------------------	   	 	  	   
     LOGMSGOUT("DLLMAIN::Setting hook on 'SendTextLine' for documents.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x0021375E],GetAddress<PVOID>(&CWindow::__DrawTextLine),"E87D54F7FF");        
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x0021378C],GetAddress<PVOID>(&CWindow::__DrawTextLine),"E84F54F7FF");    
                           
	 //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook for parsing book lines (Hook 'DrawTextLine').",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x001AD9AF],GetAddress<PVOID>(&CWindow::__DrawTextLine),"E82CB2FDFF");   
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x001ADAB3],GetAddress<PVOID>(&CWindow::__DrawTextLine),"E828B1FDFF");   
	     	   	     	     	   	     
	 //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook for finishing journal page.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x001D644E],GetAddress<PVOID>(__MakeJournalPage),"6860725D00"); 
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x001D6377],GetAddress<PVOID>(__MakeJournalPage),"6860725D00");  // Possible this is do not used!
     
	 //-------------------------------------------------------------------	 
     LOGMSGOUT("DLLMAIN::Setting hook for Menu mode animation freezing control.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x0001B3AF],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__MenuModeAnimationFreezing),"8A81D60000");   
	     	   	     	     
	 //-------------------------------------------------------------------	 
     LOGMSGOUT("DLLMAIN::Setting hook on dialogue begin.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x0012935A],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__StartDialogue),"668B154234");  

	 //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook to loading voice file.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x0008C369],GetAddress<PVOID>(&CSoundBase::__OpenVoiceFile),"E8425AF7FF");  // See 'vadefs.h' (Variable argument lists) for more useful code examples           
	                     
	 //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook on head tracking of NPC.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x0016F68B],GetAddress<PVOID>(&CAnimation::__HeadTrack),"E88002F0FF");  
       
	 //-------------------------------------------------------------------
     LOGMSGOUT("DLLMAIN::Setting hook on AI state check.",ModInfo->ModWriteLogFile);  
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x00121D83],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__ControlCurDlgActorAI),"F641240874"); 
  
	 //-------------------------------------------------------------------	  	 
     LOGMSGOUT("DLLMAIN::Setting hook on changing view mode (1st - 3rd Person switch).",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x00143A17],GetAddress<PVOID>(&CCamera::__SwitchViewMode),"E854EBFFFF"); 
                                  
	 //-------------------------------------------------------------------	
     LOGMSGOUT("DLLMAIN::Setting hook on changing dialogue topic.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x001C03F9],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__ChangeDlgTopic),"75108B4770");    
	
	 //-------------------------------------------------------------------	
     LOGMSGOUT("DLLMAIN::Setting hook on open_close any text document.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetFuncHook(&PatchBase[0x001AD630],GetAddress<CODEHOOK32::FUNCHOOKPROC32>(__OpenCloseBookAndDoc),"8B0D??????");   
                    
	 //-------------------------------------------------------------------	
     LOGMSGOUT("DLLMAIN::Setting hook on 'ToggleGodMode'.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x00103D66],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__ToggleGM),"8B89E40200");    

 	 //-------------------------------------------------------------------	
     LOGMSGOUT("DLLMAIN::Setting hook on journal key press checking.",ModInfo->ModWriteLogFile);
     Result += ModInfo->CodeHooks[Index++].SetCodeHook(&PatchBase[0x0001AECB],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__IsJournalAllowed),"85C00F84BA");    

	 //-------------------------------------------------------------------	  	 
 //    LOGMSGOUT("DLLMAIN::Setting hook on changing anim group.",ModInfo->ModWriteLogFile);  // NO USE FOR THIS !
 //    Result += ModInfo->CodeHooks[Index++].SetCmdValue(&PatchBase[0x00140EF9],GetAddress<PVOID>(&CAnimation::__ChangeAnimGroup),"E8E2FBF2FF"); 
                                  
 	 //-------------------------------------------------------------------
	 LOGMSGOUT("DLLMAIN::Setting hook on Player`s scene updating.",ModInfo->ModWriteLogFile);	                                                           
     Result += SetAddressInVFT(&PatchBase[0x0034AE30],1,&CCamera::__UpdatePlayerPositions);
                                                                                                                                                                                                                    
     //================================================================================
     if(Result)
      {
       MessageBox(NULL,(ModInfo->Config.LangIndex)?(SINGERRORMSGEN):SINGERRORMSGRU,THISMODNAME,MB_ICONSTOP|MB_SYSTEMMODAL|MB_OK);
       FreeLibraryAndExitThread(ModInfo->ThisLibBase, 0);  // Finish process
      }
     //================================================================================

	 if(!(ModInfo->hWorkerThread = CreateThread(NULL,0,&WorkerThread,NULL,CREATE_SUSPENDED,&ModInfo->WorkerThreadID))){LOGMSGOUT("DLLMAIN::Failed to create worker thread!",ModInfo->ModWriteLogFile);return false;}	      
	 LOGMSGOUT("DLLMAIN::Worker thread are created successfully.",ModInfo->ModWriteLogFile);
	 ResumeThread(ModInfo->hWorkerThread);     
     break;									

   case DLL_THREAD_ATTACH:
     break;

   case DLL_THREAD_DETACH:
     break;

   case DLL_PROCESS_DETACH:
	 ModEventOnHostExit();
	 break;
   default : return false;  // WRONG REASON CODE !!!!!!
  }
 return true;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModEventOnHostExit(void)
{
 LOGMSGOUT("MLDR::ModEventOnHostExit::Unloading...",ModInfo->ModWriteLogFile);
 FreeResources();
 return 0;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModEventOnHostStart(void)
{
 LOGMSGOUT("MLDR::ModEventOnHostStart::Initialized",ModInfo->ModWriteLogFile);
 return 0;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModGetVersion(void)
{
 return MOD_VERSION;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModGetParameters(void)
{
 return MOD_PARAMETERS;
}
//------------------------------------------------------------------------------------
LPSTR _stdcall ModGetConfigShellName(void)
{
 return SHELLCFGNAME;
}
//------------------------------------------------------------------------------------
DWORD  _stdcall ModRunConfigShell(DWORD Reserved)
{
 BYTE ShellPath[MAX_PATH];

 lstrcpy((LPSTR)&ShellPath, (LPSTR)&ModInfo->CurrentDir);
 lstrcat((LPSTR)&ShellPath, SHELLCFGNAME);
 if(WinExec((LPSTR)&ShellPath,SW_SHOWNORMAL) > 31)return 0;
 return 1;
}
//------------------------------------------------------------------------------------
void  _stdcall ModWriteLogFile(LPSTR LogMessage)
{
 BYTE DateTimeBuf[64];

 if(ModInfo->LogFilePath[0])
  {
   FormatCurDateTime((LPSTR)&DateTimeBuf);
   WritePrivateProfileString(THISMODNAME,(LPSTR)&DateTimeBuf,LogMessage,(LPSTR)&ModInfo->LogFilePath);
  }
}
//====================================================================================
//					          THE MAIN INTERNAL FUNCTIONS
//------------------------------------------------------------------------------------
DWORD WINAPI WorkerThread(LPVOID lpParameter)
{
 MSG        ThNewMsg;
 PVOICEINFO VoiceInf;
                              
 LOGMSGOUT("WRKTHREAD::Entering worker thread...",ModInfo->ModWriteLogFile);
 if((VoiceInf=&ModInfo->VoiceInf[VoiceMale])->VoiceEnabled)
  {
   LOGMSGOUT("WRKTHREAD::Trying to initialize 'VoiceMale'.",ModInfo->ModWriteLogFile);
   VoiceInf->Voice.Initialize(SPKTOMEMB, FALSE);
   VoiceInf->Voice.SetOutputFormat(SOAF44kHz16BitM);
   VoiceInf->Voice.SetVoiceConfig((LPSTR)&VoiceInf->VoiceConfig);
   if(VoiceInf->Voice.SetVoice((LPSTR)&VoiceInf->VoiceName))LOGMSGOUT("WRKTHREAD::'VoiceMale' is failed to initialize.",ModInfo->ModWriteLogFile);
     else LOGMSGOUT("WRKTHREAD::'VoiceMale' is initialized.",ModInfo->ModWriteLogFile);
  }

 if((VoiceInf=&ModInfo->VoiceInf[VoiceFemale])->VoiceEnabled)
  {
   LOGMSGOUT("WRKTHREAD::Trying to initialize 'VoiceFemale'.",ModInfo->ModWriteLogFile);  
   VoiceInf->Voice.Initialize(SPKTOMEMB, FALSE);
   VoiceInf->Voice.SetOutputFormat(SOAF44kHz16BitM);
   VoiceInf->Voice.SetVoiceConfig((LPSTR)&VoiceInf->VoiceConfig);
   if(VoiceInf->Voice.SetVoice((LPSTR)&VoiceInf->VoiceName))LOGMSGOUT("WRKTHREAD::'VoiceFemale' is failed to initialize.",ModInfo->ModWriteLogFile);
     else LOGMSGOUT("WRKTHREAD::'VoiceFemale' is initialized.",ModInfo->ModWriteLogFile);
  }

 if((VoiceInf=&ModInfo->VoiceInf[VoiceCreature])->VoiceEnabled)
  {
   LOGMSGOUT("WRKTHREAD::Trying to initialize 'VoiceCreature'.",ModInfo->ModWriteLogFile);  
   VoiceInf->Voice.Initialize(SPKTOMEMB, FALSE);
   VoiceInf->Voice.SetOutputFormat(SOAF44kHz16BitM);
   VoiceInf->Voice.SetVoiceConfig((LPSTR)&VoiceInf->VoiceConfig);
   if(VoiceInf->Voice.SetVoice((LPSTR)&VoiceInf->VoiceName))LOGMSGOUT("WRKTHREAD::'VoiceCreature' is failed to initialize.",ModInfo->ModWriteLogFile);
     else LOGMSGOUT("WRKTHREAD::'VoiceCreature' is initialized.",ModInfo->ModWriteLogFile);
  }

 if((VoiceInf=&ModInfo->VoiceInf[VoiceDocument])->VoiceEnabled && !ModInfo->Config.DocVoiceAsDlg)
  {
   LOGMSGOUT("WRKTHREAD::Trying to initialize 'VoiceDocument'.",ModInfo->ModWriteLogFile);      
   VoiceInf->Voice.Initialize(SPKTOMEMB, FALSE);
   VoiceInf->Voice.SetOutputFormat(SOAF44kHz16BitM);
   VoiceInf->Voice.SetVoiceConfig((LPSTR)&VoiceInf->VoiceConfig);
   if(VoiceInf->Voice.SetVoice((LPSTR)&VoiceInf->VoiceName))LOGMSGOUT("WRKTHREAD::'VoiceDocument' is failed to initialize.",ModInfo->ModWriteLogFile);
     else LOGMSGOUT("WRKTHREAD::'VoiceDocument' is initialized.",ModInfo->ModWriteLogFile);
  }
   
 LOGMSGOUT("WRKTHREAD::Entering message loop.",ModInfo->ModWriteLogFile);   
 PeekMessage(&ThNewMsg, NULL, 0, MAXDWORD, PM_REMOVE);
 while(1)
  {
   if(ModInfo->GameInMenuMode || ModInfo->CurrentTalker->IsPlaying())PeekMessage(&ThNewMsg, NULL, MSG_START_SPEAK, MSG_THREADEXIT, PM_REMOVE);
     else GetMessage(&ThNewMsg, NULL, MSG_START_SPEAK, MSG_THREADEXIT);
//   LOGMSGOUT("WRKTHREAD::Message received: %08X.",&ModWriteLogFile,ThNewMsg.message);
   if(ThNewMsg.message == MSG_START_SPEAK){(reinterpret_cast<PCTalker>(ThNewMsg.wParam))->SpeakToBuffer();}                     
   if(ThNewMsg.message == MSG_THREADEXIT)break;
   ThNewMsg.message = NULL; 
   ThNewMsg.lParam  = NULL;
   ThNewMsg.wParam  = NULL; 
   Sleep(KEYWAITDEL);
 
   if(ModInfo->GameInMenuMode  && IsKeyCombinationPressed(ModInfo->Config.SpeakKeyCode) && !ModInfo->CurrentTalker->IsPlaying()){ModInfo->CurrentTalker->SendWavDataToObject();continue;}
   if(ModInfo->GameInMenuMode  && IsKeyCombinationPressed(ModInfo->Config.SilenceKeyCode)){ModInfo->CurrentTalker->Silence();continue;}        
   if(!ModInfo->GameInMenuMode && IsKeyCombinationPressed(ModInfo->Config.SilenceKeyCode)){ModInfo->CurrentTalker->SilenceAllTalkers();continue;}        
  }

 // When exiting from a game menu, this code will never be reached! 
 LOGMSGOUT("WRKTHREAD::Exiting TalkyMorrowind...",ModInfo->ModWriteLogFile);
 FreeResources();
 FreeLibraryAndExitThread(ModInfo->ThisLibBase,1);   
 return 0; 
}
//====================================================================================
void _stdcall FreeResources(void)
{
 ModInfo->VoiceInf[VoiceMale].Voice.UnInitialize();
 ModInfo->VoiceInf[VoiceFemale].Voice.UnInitialize();
 ModInfo->VoiceInf[VoiceCreature].Voice.UnInitialize();
 ModInfo->VoiceInf[VoiceDocument].Voice.UnInitialize();
}
//====================================================================================
void _stdcall LoadConfiguration(LPSTR CfgFilePath)    
{
 ModInfo->Config.SpeakKeyCode     = RefreshINIValueInt("BaseConfig","SpeakKeyCode",ModInfo->Config.SpeakKeyCode,CfgFilePath);
 ModInfo->Config.SilenceKeyCode   = RefreshINIValueInt("BaseConfig","SilenceKeyCode",ModInfo->Config.SilenceKeyCode,CfgFilePath);
 ModInfo->Config.DocVoiceAsDlg    = RefreshINIValueInt("BaseConfig","DocVoiceAsDlg",ModInfo->Config.DocVoiceAsDlg,CfgFilePath);
 ModInfo->Config.VoiceFxByRace    = RefreshINIValueInt("BaseConfig","VoiceFxByRace",ModInfo->Config.VoiceFxByRace,CfgFilePath);
 ModInfo->Config.SearchSpeechFile = RefreshINIValueInt("BaseConfig","SearchSpeechFile",ModInfo->Config.SearchSpeechFile,CfgFilePath);
 ModInfo->Config.FilterSpeechFile = RefreshINIValueInt("BaseConfig","FilterSpeechFile",ModInfo->Config.FilterSpeechFile,CfgFilePath);
 ModInfo->Config.TTSBoundPitchDS  = RefreshINIValueInt("BaseConfig","TTSBoundPitchDS",ModInfo->Config.TTSBoundPitchDS,CfgFilePath);
 ModInfo->Config.AlwReadOpenJnl   = RefreshINIValueInt("BaseConfig","AlwReadOpenJnl",ModInfo->Config.AlwReadOpenJnl,CfgFilePath);
 ModInfo->Config.StopSpkOnClose	  = RefreshINIValueInt("BaseConfig","StopSpkOnClose",ModInfo->Config.StopSpkOnClose,CfgFilePath);
 ModInfo->Config.PickPocketMode	  = RefreshINIValueInt("BaseConfig","PickPocketMode",ModInfo->Config.PickPocketMode,CfgFilePath); 
 ModInfo->Config.DlgSwitchToFP	  = RefreshINIValueInt("BaseConfig","DlgSwitchToFP",ModInfo->Config.DlgSwitchToFP,CfgFilePath);
 ModInfo->Config.DlgEnableZoom    = RefreshINIValueInt("BaseConfig","DlgEnableZoom",ModInfo->Config.DlgEnableZoom,CfgFilePath);
 ModInfo->Config.SmoothZooming    = RefreshINIValueInt("BaseConfig","SmoothZooming",ModInfo->Config.SmoothZooming,CfgFilePath);                  
 ModInfo->Config.SpkAfterFocusNpc = RefreshINIValueInt("BaseConfig","SpkAfterFocusNpc",ModInfo->Config.SpkAfterFocusNpc,CfgFilePath);
 ModInfo->Config.ZoomDistNPC      = RefreshINIValueInt("BaseConfig","ZoomDistNPC",ModInfo->Config.ZoomDistNPC,CfgFilePath);
 ModInfo->Config.LangIndex	      = RefreshINIValueInt("BaseConfig","LangIndex",ModInfo->Config.LangIndex,CfgFilePath);
 ModInfo->Config.VPBaseMale	      = RefreshINIValueInt("BaseConfig","VPBaseMale",ModInfo->Config.VPBaseMale,CfgFilePath);
 ModInfo->Config.VPBaseFemale	  = RefreshINIValueInt("BaseConfig","VPBaseFemale",ModInfo->Config.VPBaseFemale,CfgFilePath);
 ModInfo->Config.VPBaseCreature	  = RefreshINIValueInt("BaseConfig","VPBaseCreature",ModInfo->Config.VPBaseCreature,CfgFilePath);

 ModInfo->Config.MPauseChargen      = RefreshINIValueInt("MenuConfig","MPauseChargen",ModInfo->Config.MPauseChargen,CfgFilePath);
 ModInfo->Config.MPauseService      = RefreshINIValueInt("MenuConfig","MPauseService",ModInfo->Config.MPauseService,CfgFilePath);
 ModInfo->Config.MPauseResting      = RefreshINIValueInt("MenuConfig","MPauseResting",ModInfo->Config.MPauseResting,CfgFilePath);
 ModInfo->Config.MPauseJournal      = RefreshINIValueInt("MenuConfig","MPauseJournal",ModInfo->Config.MPauseJournal,CfgFilePath);
 ModInfo->Config.MPauseDialogue     = RefreshINIValueInt("MenuConfig","MPauseDialogue",ModInfo->Config.MPauseDialogue,CfgFilePath);
 ModInfo->Config.MPauseContainer    = RefreshINIValueInt("MenuConfig","MPauseContainer",ModInfo->Config.MPauseContainer,CfgFilePath);   
 ModInfo->Config.MPauseInventory    = RefreshINIValueInt("MenuConfig","MPauseInventory",ModInfo->Config.MPauseInventory,CfgFilePath);
 ModInfo->Config.MPauseDocuments    = RefreshINIValueInt("MenuConfig","MPauseDocuments",ModInfo->Config.MPauseDocuments,CfgFilePath);
 ModInfo->Config.MPauseMessages     = RefreshINIValueInt("MenuConfig","MPauseMessages",ModInfo->Config.MPauseMessages,CfgFilePath); 
 ModInfo->Config.MPauseOptions      = RefreshINIValueInt("MenuConfig","MPauseOptions",ModInfo->Config.MPauseOptions,CfgFilePath);
 ModInfo->Config.MKeepAiChargen     = RefreshINIValueInt("MenuConfig","MKeepAiChargen",ModInfo->Config.MKeepAiChargen,CfgFilePath);
 ModInfo->Config.MKeepAiService	    = RefreshINIValueInt("MenuConfig","MKeepAiService",ModInfo->Config.MKeepAiService,CfgFilePath);
 ModInfo->Config.MKeepAiResting	    = RefreshINIValueInt("MenuConfig","MKeepAiResting",ModInfo->Config.MKeepAiResting,CfgFilePath);
 ModInfo->Config.MKeepAiJournal	    = RefreshINIValueInt("MenuConfig","MKeepAiJournal",ModInfo->Config.MKeepAiJournal,CfgFilePath);
 ModInfo->Config.MKeepAiDialogue    = RefreshINIValueInt("MenuConfig","MKeepAiDialogue",ModInfo->Config.MKeepAiDialogue,CfgFilePath);
 ModInfo->Config.MKeepAiContainer   = RefreshINIValueInt("MenuConfig","MKeepAiContainer",ModInfo->Config.MKeepAiContainer,CfgFilePath);  
 ModInfo->Config.MKeepAiInventory   = RefreshINIValueInt("MenuConfig","MKeepAiInventory",ModInfo->Config.MKeepAiInventory,CfgFilePath);
 ModInfo->Config.MKeepAiDocuments   = RefreshINIValueInt("MenuConfig","MKeepAiDocuments",ModInfo->Config.MKeepAiDocuments,CfgFilePath);
 ModInfo->Config.MKeepAiMessages    = RefreshINIValueInt("MenuConfig","MKeepAiMessages",ModInfo->Config.MKeepAiMessages,CfgFilePath); 
 ModInfo->Config.MKeepAiOptions     = RefreshINIValueInt("MenuConfig","MKeepAiOptions",ModInfo->Config.MKeepAiOptions,CfgFilePath);
 ModInfo->Config.MEnableGmChargen   = RefreshINIValueInt("MenuConfig","MEnableGmChargen",ModInfo->Config.MEnableGmChargen,CfgFilePath);
 ModInfo->Config.MEnableGmService   = RefreshINIValueInt("MenuConfig","MEnableGmService",ModInfo->Config.MEnableGmService,CfgFilePath);
 ModInfo->Config.MEnableGmResting   = RefreshINIValueInt("MenuConfig","MEnableGmResting",ModInfo->Config.MEnableGmResting,CfgFilePath);
 ModInfo->Config.MEnableGmJournal   = RefreshINIValueInt("MenuConfig","MEnableGmJournal",ModInfo->Config.MEnableGmJournal,CfgFilePath);
 ModInfo->Config.MEnableGmDialogue  = RefreshINIValueInt("MenuConfig","MEnableGmDialogue",ModInfo->Config.MEnableGmDialogue,CfgFilePath);
 ModInfo->Config.MEnableGmContainer = RefreshINIValueInt("MenuConfig","MEnableGmContainer",ModInfo->Config.MEnableGmContainer,CfgFilePath);  
 ModInfo->Config.MEnableGmInventory = RefreshINIValueInt("MenuConfig","MEnableGmInventory",ModInfo->Config.MEnableGmInventory,CfgFilePath);
 ModInfo->Config.MEnableGmDocuments = RefreshINIValueInt("MenuConfig","MEnableGmDocuments",ModInfo->Config.MEnableGmDocuments,CfgFilePath);
 ModInfo->Config.MEnableGmMessages  = RefreshINIValueInt("MenuConfig","MEnableGmMessages",ModInfo->Config.MEnableGmMessages,CfgFilePath); 
 ModInfo->Config.MEnableGmOptions   = RefreshINIValueInt("MenuConfig","MEnableGmOptions",ModInfo->Config.MEnableGmOptions,CfgFilePath);

 ModInfo->Config.VPOrc      = RefreshINIValueInt("RaceConfig","VPOrc",ModInfo->Config.VPOrc,CfgFilePath);
 ModInfo->Config.VPNord     = RefreshINIValueInt("RaceConfig","VPNord",ModInfo->Config.VPNord,CfgFilePath);
 ModInfo->Config.VPBreton   = RefreshINIValueInt("RaceConfig","VPBreton",ModInfo->Config.VPBreton,CfgFilePath);
 ModInfo->Config.VPKhajiit  = RefreshINIValueInt("RaceConfig","VPKhajiit",ModInfo->Config.VPKhajiit,CfgFilePath);
 ModInfo->Config.VPDarkElf  = RefreshINIValueInt("RaceConfig","VPDarkElf",ModInfo->Config.VPDarkElf,CfgFilePath);
 ModInfo->Config.VPHighElf  = RefreshINIValueInt("RaceConfig","VPHighElf",ModInfo->Config.VPHighElf,CfgFilePath);
 ModInfo->Config.VPWoodElf  = RefreshINIValueInt("RaceConfig","VPWoodElf",ModInfo->Config.VPWoodElf,CfgFilePath);
 ModInfo->Config.VPArgonian = RefreshINIValueInt("RaceConfig","VPArgonian",ModInfo->Config.VPArgonian,CfgFilePath);
 ModInfo->Config.VPImperial = RefreshINIValueInt("RaceConfig","VPImperial",ModInfo->Config.VPImperial,CfgFilePath);
 ModInfo->Config.VPRedguard = RefreshINIValueInt("RaceConfig","VPRedguard",ModInfo->Config.VPRedguard,CfgFilePath);

 RefreshINIValueStr("BaseConfig","ConfigAppName",(LPSTR)&ModInfo->Config.ConfigAppName,(LPSTR)&ModInfo->Config.ConfigAppName,sizeof(ModInfo->Config.ConfigAppName),CfgFilePath);
  
 ModInfo->VoiceInf[VoiceMale].VoiceEnabled = ModInfo->VoiceInf[VoiceFemale].VoiceEnabled = ModInfo->VoiceInf[VoiceCreature].VoiceEnabled = RefreshINIValueInt("TalkyDlg","VoiceEnable",0,CfgFilePath);
 ModInfo->VoiceInf[VoiceMale].AutoSpeak    = ModInfo->VoiceInf[VoiceFemale].AutoSpeak    = ModInfo->VoiceInf[VoiceCreature].AutoSpeak    = RefreshINIValueInt("TalkyDlg","AutoSpeak",1,CfgFilePath);
 RefreshINIValueStr("TalkyDlg","VoiceMaleName","?",(LPSTR)&ModInfo->VoiceInf[VoiceMale].VoiceName,sizeof(ModInfo->VoiceInf[VoiceMale].VoiceName),CfgFilePath);
 RefreshINIValueStr("TalkyDlg","VoiceFemaleName","?",(LPSTR)&ModInfo->VoiceInf[VoiceFemale].VoiceName,sizeof(ModInfo->VoiceInf[VoiceFemale].VoiceName),CfgFilePath);
 RefreshINIValueStr("TalkyDlg","VoiceCreatureName","?",(LPSTR)&ModInfo->VoiceInf[VoiceCreature].VoiceName,sizeof(ModInfo->VoiceInf[VoiceCreature].VoiceName),CfgFilePath);
 RefreshINIValueStr("TalkyDlg","VoiceMaleConfig","",(LPSTR)&ModInfo->VoiceInf[VoiceMale].VoiceConfig,sizeof(ModInfo->VoiceInf[VoiceMale].VoiceConfig),CfgFilePath);
 RefreshINIValueStr("TalkyDlg","VoiceFemaleConfig","",(LPSTR)&ModInfo->VoiceInf[VoiceFemale].VoiceConfig,sizeof(ModInfo->VoiceInf[VoiceFemale].VoiceConfig),CfgFilePath);
 RefreshINIValueStr("TalkyDlg","VoiceCreatureConfig","",(LPSTR)&ModInfo->VoiceInf[VoiceCreature].VoiceConfig,sizeof(ModInfo->VoiceInf[VoiceCreature].VoiceConfig),CfgFilePath);

 ModInfo->VoiceInf[VoiceDocument].VoiceEnabled = RefreshINIValueInt("TalkyDoc","VoiceEnable",0,CfgFilePath);
 ModInfo->VoiceInf[VoiceDocument].AutoSpeak    = RefreshINIValueInt("TalkyDoc","AutoSpeak",1,CfgFilePath);
 RefreshINIValueStr("TalkyDoc","VoiceName","?",(LPSTR)&ModInfo->VoiceInf[VoiceDocument].VoiceName,sizeof(ModInfo->VoiceInf[VoiceDocument].VoiceName),CfgFilePath);
 RefreshINIValueStr("TalkyDoc","VoiceConfig","",(LPSTR)&ModInfo->VoiceInf[VoiceDocument].VoiceConfig,sizeof(ModInfo->VoiceInf[VoiceDocument].VoiceConfig),CfgFilePath);
}
//====================================================================================
