#pragma once

#ifndef ExtensionModH
#define ExtensionModH
//====================================================================================
#include "MWDerived.h"
#include "TalkyFuncs.h"
#include "TalkyHooks.h"
//--------------------------------------------------------------------------- 
#define MAXHOOKS         40
#define FMODHIGHPRI      0x80000000
#define	MOD_VERSION		 0x0001020B
#define	MOD_PARAMETERS   0x00000000
#define MSG_START_SPEAK  0x00000400
#define MSG_THREADEXIT   0x00000409
#define MLDRLIBNAME      "MLDRLib.dll"
#define MLDRLOGPROC      "WriteLogFile"
#define THISMODNAME      "TalkyMorrowind"
#define MLDRPROCNAME     "IsModuleLoader"
#define SHELLCFGNAME     "MWTalkyCfg.exe"		// For call from Moduleloader
#define SINGERRORMSGRU   "    .\r\n   'Morrowind.exe'? (: 1.6.1820).\r\n  !"
#define SINGERRORMSGEN   "One of a signatures is differs.\r\nWrong version of 'Morrowind.exe'? (Need: 1.6.1820).\r\nCONTINUE IS IMPOSSIBLE!"

const LPSTR AuthorString   = "78DA011900E6FFD8C0D5CCC0CDCEC220C2C8CAD2CED020C0CDC4D0C5C5C2C8D7EF121267";
const LPSTR CfgFileName    = "TalkyConfig.ini"; 
const LPSTR CfgAppName     = "MWTalkyCfg.exe";
const float TgtObjMoveDist = 15.0;  // If target Actor will move to dist mote than this, his menus must be closed

//---------------------------------------------------------------------------
struct  MODCONFIG;
class   CModData;
typedef CModData*  PCModData;
typedef MODCONFIG* PMODCONFIG;

enum PPModes {ppmDoNothing, ppmLockActor, ppmCloseMenu};
enum Voices  {VoiceMale, VoiceFemale, VoiceCreature, VoiceDocument};

struct MODCONFIG   // Readed from the configuration file
{
 short VPOrc;
 short VPNord;
 short VPBreton;
 short VPKhajiit;
 short VPDarkElf;
 short VPHighElf;
 short VPWoodElf;
 short VPArgonian;
 short VPImperial;
 short VPRedguard;

 short VPBaseMale;
 short VPBaseFemale;
 short VPBaseCreature;

 bool  MPauseChargen;
 bool  MPauseService;
 bool  MPauseResting;
 bool  MPauseJournal;
 bool  MPauseDialogue;
 bool  MPauseContainer;
 bool  MPauseInventory;
 bool  MPauseDocuments;
 bool  MPauseMessages;
 bool  MPauseOptions;
 bool  MKeepAiChargen;
 bool  MKeepAiService;
 bool  MKeepAiResting;
 bool  MKeepAiJournal;
 bool  MKeepAiDialogue;
 bool  MKeepAiContainer;
 bool  MKeepAiInventory;
 bool  MKeepAiDocuments;
 bool  MKeepAiMessages;
 bool  MKeepAiOptions;
 bool  MEnableGmChargen;
 bool  MEnableGmService;
 bool  MEnableGmResting;
 bool  MEnableGmJournal;
 bool  MEnableGmDialogue;
 bool  MEnableGmContainer;
 bool  MEnableGmInventory;
 bool  MEnableGmDocuments;
 bool  MEnableGmMessages;
 bool  MEnableGmOptions;
 
 bool  AlwReadOpenJnl;   // Always read text in appeared journal,even if it is was readed before journal was closed
 bool  DocVoiceAsDlg;    // Read journal and documents by Player`s gender voice
 bool  VoiceFxByRace;
 bool  StopSpkOnClose;   // Stop speaking when menu mode closed
 bool  DlgSwitchToFP;
 bool  DlgEnableZoom;
 bool  SmoothZooming;
 bool  SpkAfterFocusNpc;
 bool  TTSBoundPitchDS;
 bool  SearchSpeechFile;
 bool  FilterSpeechFile;
 
 long  PickPocketMode;
 long  ZoomDistNPC;
 DWORD LangIndex;     
 DWORD SpeakKeyCode;     // Speak last sended text (F1) (Four bytes, each = ONE virtual key code; 0 - Not requested)
 DWORD SilenceKeyCode;   // Stop all speaking	  (F2) (Four bytes, each = ONE virtual key code; 0 - Not requested)
 BYTE  ConfigAppName[64];
 
 PMODCONFIG DEFCALL SetDefaults(void)
  {
   FastZeroMemory(this,sizeof(MODCONFIG));
   lstrcpy((LPSTR)&ConfigAppName, CfgAppName); 
 
   VPOrc      = -8000;
   VPNord     = -6000;
   VPBreton   = -2000;
   VPKhajiit  = 4000;
   VPDarkElf  = 0;
   VPHighElf  = 1000;
   VPWoodElf  = 8000;
   VPArgonian = -1000;
   VPImperial = -3000;
   VPRedguard = -4000;

   VPBaseMale     = 0;
   VPBaseFemale   = 0;
   VPBaseCreature = 0;

   MPauseChargen    = true;
   MPauseService    = true;
   MPauseResting    = true;
   MPauseJournal    = true;
   MPauseDialogue   = false;
   MPauseContainer  = false;
   MPauseInventory  = false;
   MPauseDocuments  = true;
   MPauseMessages   = true;
   MPauseOptions    = true;
   MKeepAiChargen   = false;
   MKeepAiService   = false;
   MKeepAiResting   = false;
   MKeepAiJournal   = false;
   MKeepAiDialogue  = false;
   MKeepAiContainer = false;
   MKeepAiInventory = false;
   MKeepAiDocuments = false;
   MKeepAiMessages  = false;
   MKeepAiOptions   = false;
   MEnableGmChargen   = true;
   MEnableGmService   = true;
   MEnableGmResting   = true;
   MEnableGmJournal   = false;
   MEnableGmDialogue  = true;
   MEnableGmContainer = false;
   MEnableGmInventory = false;
   MEnableGmDocuments = false;
   MEnableGmMessages  = true;
   MEnableGmOptions   = true;
    
   AlwReadOpenJnl   = false;  
   DocVoiceAsDlg    = true;   
   VoiceFxByRace    = true;
   StopSpkOnClose   = true;   
   DlgSwitchToFP    = true;
   DlgEnableZoom    = true;
   SmoothZooming    = true;
   SpkAfterFocusNpc = false; 
   TTSBoundPitchDS  = true;
   SearchSpeechFile = true;
   FilterSpeechFile = false;
 
   LangIndex      = 1;
   PickPocketMode = ppmLockActor;
   SpeakKeyCode   = VK_F3;    // Speak last sended text (F1) (Four bytes, each = ONE virtual key code; 0 - Not requested)
   SilenceKeyCode = VK_F4;	  // Stop all speaking	    (F2) (Four bytes, each = ONE virtual key code; 0 - Not requested)
   return this;
  }
};
//---------------------------------------------------------------------------
class CModData
{
public:
 MODCONFIG          Config;
 MORROWIND::GLOBALS MWGlobals;
       
 float FltCamBIG;        // Taked from Morrowind.exe [9.9999997e-6]
 float FltCamSMALL;      // Taked from Morrowind.exe [1.0]
 float CamRotDeltaX;    
 float CamRotDeltaY;  
 long  ZoomDistNPC;      // 60 is minimal
 long  LastFOV;        
 long  CurrentFOV;     
 long  StartingFOV;    
 bool  ModuleLoader;     // True, if module loaded into ModuleLoader`s space
 bool  LastCamCtrl;   
 bool  LastKeyCtrl; 
 bool  LastGodMode; 
 bool  PrevPViewMode;    // First\Third person view
 bool  GameInMenuMode;   // For title screen menu state initial=TRUE
 bool  PausedMenuMode;  
 bool  EnabledAiMenuM;
 bool  PCSneakBefore;   
 bool  ZoomingInProces; 
 bool  CamTrackingActive; 

 BYTE       MenuModeResult;   // For initial menu mode=1
 WORD       LastMenuID;
 DWORD      LastJnlCS;    
 DWORD      WorkerThreadID; 
 PVOID      MLDRWriteLogFile;
 HANDLE     hWorkerThread;   
 HANDLE     hDefHeap;       
 HMODULE    ThisLibBase;     
 HMODULE    ExeModuleBase;  
 PCTalker   CurrentTalker;      
 VECTOR3    PlayerTgtPos;

 MORROWIND::PNiNode     pTrkTarget;  
 MORROWIND::PNiCamera   pTrkCamera;
 MORROWIND::PCObjREFR   TgtObjectRef; 
                 MORROWIND::PCObjREFR   TestObjectRef; 
 void (_stdcall *ModWriteLogFile)(LPSTR);

 BYTE        CurrentDir[MAX_PATH];
 BYTE        CfgFilePath[MAX_PATH];
 BYTE        LogFilePath[MAX_PATH];
 BYTE        GameDirectory[MAX_PATH];
 BYTE        SpeechDirectory[MAX_PATH];

 QWORD       SinCosTable[360];
 VOICEINFO   VoiceInf[4];              // Male, Female, Creature, Document 
 CODEHOOK32  CodeHooks[MAXHOOKS];
 
 PCModData DEFCALL UnInitialize(void){MEMWORK::FreeMemoryBlock(this);return this;}
 PCModData DEFCALL Initialize(void){return ((PCModData)MEMWORK::GetMemoryBlock(sizeof(CModData)))->SetDefaults();}
 PCModData DEFCALL SetDefaults(void)
  {
   FastZeroMemory(this,sizeof(CModData));
   Config.SetDefaults();
   MWGlobals.Initialize();
   FillSinCosTable((QWORD*)SinCosTable);
   for(int ctr=0;ctr<(sizeof(VoiceInf)/sizeof(VOICEINFO));ctr++)VoiceInf[ctr].VoiceEnabled = VoiceInf[ctr].AutoSpeak = true;
        
   FltCamBIG         = 9.9999997e-6;  
   FltCamSMALL       = 1.0;           
   CamRotDeltaX      = 0;
   CamRotDeltaY      = 0;
   ZoomDistNPC       = 60;     
   LastFOV           = -1;
   CurrentFOV        = -1;
   StartingFOV       = -1;
   ModuleLoader      = true;   
   LastCamCtrl       = false;
   LastKeyCtrl       = false;
   LastGodMode       = false;
   PrevPViewMode     = false;   
   GameInMenuMode    = false;   
   PausedMenuMode    = false;
   EnabledAiMenuM    = false;
   PCSneakBefore     = false;
   ZoomingInProces   = false;
   CamTrackingActive = false; 
   MenuModeResult    = 2;
   return this;	     
  }
};
//---------------------------------------------------------------------------
DWORD WINAPI   WorkerThread(LPVOID lpParameter);
DWORD _stdcall ModGetVersion(void);
DWORD _stdcall ModGetParameters(void);        
DWORD _stdcall ModEventOnHostExit(void);       // Call this internally from DLL_PROCESS_DETACH
DWORD _stdcall ModEventOnHostStart(void);
LPSTR _stdcall ModGetConfigShellName(void);
DWORD _stdcall ModRunConfigShell(DWORD Reserved);
void  _stdcall ModWriteLogFile(LPSTR LogMessage);
void  _stdcall LoadConfiguration(LPSTR CfgFilePath);
long  _stdcall ConfigureModule(long Param);
void  _stdcall FreeResources(void);
//====================================================================================
#endif
