
#include "ExtensionMod.h"
//====================================================================================
//					 
// This unit contains functions, related on global data or other functions addresses
//
//
//====================================================================================
BOOL APIENTRY DLLMain(HMODULE hModule, DWORD ReasonCall, LPVOID lpReserved)
{				           //  Only one thread will execute within DLLMAIN
 DWORD Result;
 PVOID PatchAddr;

 switch(ReasonCall)	    
  {
   case DLL_PROCESS_ATTACH:
     ThisLibBase      = hModule;
     DefHeapHandle    = GetProcessHeap();
	 ExeModuleBase    = GetModuleHandle(NULL);
	 MLDRWriteLogFile = GetProcAddress(GetModuleHandle(MLDRLIBNAME),MLDRLOGPROC);
	 GetModuleFileName(hModule,(LPSTR)&CurrentDir,sizeof(CurrentDir));
	 GetModuleFileName(ExeModuleBase,(LPSTR)&GameCurDir,sizeof(GameCurDir));	     
	 FastZeroMemory(&LogFilePath, sizeof(LogFilePath));	

	 if(MLDRWriteLogFile)lstrcpy((LPSTR)&LogFilePath, ((LPSTR (_stdcall*)(LPSTR,LPSTR))MLDRWriteLogFile)(NULL,NULL));	// Get path of Log file	 
	 for(int ctr=(lstrlen((LPSTR)&CurrentDir)-1);ctr > 0;ctr--){if(CurrentDir[ctr] == '\\'){CurrentDir[ctr+1] = 0;break;}}    
	 for(int ctr=(lstrlen((LPSTR)&GameCurDir)-1);ctr > 0;ctr--){if(GameCurDir[ctr] == '\\'){GameCurDir[ctr+1] = 0;break;}}    		
	 lstrcpy((LPSTR)&CfgFilePath, (LPSTR)&CurrentDir);
     lstrcat((LPSTR)&CfgFilePath, CONFIGINIFILE);

	 LoadConfiguration((LPSTR)&CfgFilePath);
     if((PatchAddr = GetProcAddress(GetModuleHandle(NULL),MLDRPROCNAME))){ModuleLoader=TRUE;break;}   // Just if the function present   

     LOGMSGOUT("DLLMAIN::Main EXE module loaded at %08X.", &ModWriteLogFile, (DWORD)ExeModuleBase);     
     if((PatchAddr = GetProcAddress(GetModuleHandle(NULL),MLDRPROCNAME)))break;   // Just if the function present   
      
	 LOGMSGOUT("DLLMAIN::Starting %s...", &ModWriteLogFile, THISMODNAME);     
     //================================================================================ 

	 if(FixRequestCD){LOGMSGOUT("DLLMAIN::Disabling a game CD request.", &ModWriteLogFile);     
	    if(SetFunctionPatch(ExeModuleBase,0x00016E6B,(PVOID)0x00417041,0xE9,0,"745DA0????????84C075"))LOGMSGOUT("Patch failed!", &ModWriteLogFile);}   
     //================================================================================ 
	 if(FixLevUpText){LOGMSGOUT("DLLMAIN::Restoring Level Up commentaries in russian version.", &ModWriteLogFile);   
	    if(SetFunctionPatch(ExeModuleBase,0x001D9281,&((PBYTE)ExeModuleBase)[0x003A0E38],0xB8,5,"68AB020000E8A566E3FF")||
	      SetFunctionPatch(ExeModuleBase,0x001D929D,&((PBYTE)ExeModuleBase)[0x0039357C],0xB8,5,"689D030000E88966E3FF"))LOGMSGOUT("DLLMAIN::Patch failed!", &ModWriteLogFile);}
     //================================================================================   
     if(FixBikSearch){LOGMSGOUT("DLLMAIN::Setting hook on opening a BIK file to search it properly.", &ModWriteLogFile);        
        if(HookBinkOpen.SetHook(&ProcHookBinkOpen,"binkw32.dll","_BinkOpen@8",ExeModuleBase,TRUE))LOGMSGOUT("DLLMAIN::Setting a hook FAILED!", &ModWriteLogFile);} 	
     //================================================================================ 
     if(FixMGraphExt){LOGMSGOUT("DLLMAIN::Setting hook on state of menu to fix MGE.", &ModWriteLogFile);        
       if(MgeFixHook.SetCodeHook(&((PBYTE)ExeModuleBase)[0x0018E1FB],GetAddress<CODEHOOK32::CODEHOOKPROC32>(__PickMenuMode),"C6475A018B"))LOGMSGOUT("DLLMAIN::Setting a hook FAILED!", &ModWriteLogFile);} 	
 	 //================================================================================
	  	 	  	     
     // Add a new fixes here
                
	 //================================================================================
	 if(FixRusTexDll){LOGMSGOUT("DLLMAIN::Setting hook to catch loading of a 'text.dll'", &ModWriteLogFile);  
	    HookGetVersionExA.SetHook(&ProcHookGetVersionExA, "Kernel32.dll", "GetVersionExA", TRUE);}
	 break;									

   case DLL_THREAD_ATTACH:
     break;

   case DLL_THREAD_DETACH:
     break;

   case DLL_PROCESS_DETACH: 
	 ModEventOnHostExit();
	 break;
   default : return false;  // WRONG REASON CODE !!!!!!
  }
 return true;
}
//====================================================================================
DWORD _stdcall ModEventOnHostExit(void)
{
 LOGMSGOUT("MLDR::ModEventOnHostExit::Unloading...", &ModWriteLogFile);
 return 0;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModEventOnHostStart(void)
{
 LOGMSGOUT("MLDR::ModEventOnHostStart::Initialized.", &ModWriteLogFile);
 LOGMSGOUT("MLDR::ModEventOnHostStart::Removing hook of 'Kernel32.dll::GetVersionExA' for a 'text.dll'", &ModWriteLogFile);  
 HookGetVersionExA.RemoveHook();
 return 0;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModGetVersion(void)
{
 return MOD_VERSION;
}
//------------------------------------------------------------------------------------
DWORD _stdcall ModGetParameters(void)
{
 return MOD_PARAMETERS;
}
//------------------------------------------------------------------------------------
LPSTR _stdcall ModGetConfigShellName(void)
{
 return SHELLCFGNAME;
}
//------------------------------------------------------------------------------------
DWORD  _stdcall ModRunConfigShell(DWORD Reserved)
{
 BYTE ShellPath[MAX_PATH];

 lstrcpy((LPSTR)&ShellPath, (LPSTR)&CurrentDir);
 lstrcat((LPSTR)&ShellPath, SHELLCFGNAME);
 if(WinExec((LPSTR)&ShellPath,SW_SHOWNORMAL) > 31)return 0;
 return 1;
}
//------------------------------------------------------------------------------------
void  _stdcall ModWriteLogFile(LPSTR LogMessage)
{
 BYTE DateTimeBuf[64];

 if(LogFilePath[0])
  {
   FormatCurDateTime((LPSTR)&DateTimeBuf);
   WritePrivateProfileString(THISMODNAME,(LPSTR)&DateTimeBuf,LogMessage,(LPSTR)&LogFilePath);
  }
}
//====================================================================================
//
//					                  OTHER FUNCTIONS
//
//====================================================================================
void _stdcall LoadConfiguration(LPSTR CfgFileName)
{
 LangIndex    = RefreshINIValueInt(INISECCONFIG,"LangIndex",LangIndex,CfgFileName);
 FixRequestCD = RefreshINIValueInt(INISECFIXES,"FixRequestCD",FixRequestCD,CfgFileName);
 FixRusTexDll = RefreshINIValueInt(INISECFIXES,"FixRusTexDll",FixRusTexDll,CfgFileName);
 FixLevUpText = RefreshINIValueInt(INISECFIXES,"FixLevUpText",FixLevUpText,CfgFileName); 
 FixBikSearch = RefreshINIValueInt(INISECFIXES,"FixBikSearch",FixBikSearch,CfgFileName);
 FixMGraphExt = RefreshINIValueInt(INISECFIXES,"FixMGraphExt",FixMGraphExt,CfgFileName);     
}
//====================================================================================
//
//					                   HOOKS
//
//====================================================================================
DWORD _stdcall ProcHookGetVersionExA(LPOSVERSIONINFO lpVersionInfo)
{
 HMODULE RusTextDll;
 DWORD   Result = 0;

 if((RusTextDll = GetModuleHandle(RUSTEXTMODN)) && FixRusTexDll)
  {
   FixRusTexDll = FALSE;    // Make this only once
   LOGMSGOUT("TEXTDLL::Russian game version detected...", &ModWriteLogFile);
   LOGMSGOUT("TEXTDLL::Removing integrity check of 'Morrowind.exe' in 'Text.dll' ...", &ModWriteLogFile);
   // Trying to patch 'Text.dll 3.000, version 2.050 do not supported anymore. Use a patched file, if needed.'
   Result += (bool)SetFunctionPatch(RusTextDll,0x000071BC,(PVOID)0x00000001,0xB8,0,"E86F9FFFFF84C074F4E8");  // Remove CD check
   Result += (bool)SetFunctionPatch(RusTextDll,0x00007B00,(PVOID)0x385688AF,0xB8,0,"E84BFFFFFF3DAF885638");  // Set 'RIGHT' checksum [1.6.0.1820] and fix problem with MGE-MWSE
   Result += (bool)SetFunctionPatch(RusTextDll,0x00007B05,&((PBYTE)RusTextDll)[0x0001DAA0],0xA3,2,"3DAF8856387515E80FFE");  // Set 'RIGHT' checksum [1.6.0.1820] and fix problem with MGE-MWSE 
   if(Result)LOGMSGOUT("TEXTDLL::Failed to patch 'Text.dll' - a signature not found!", &ModWriteLogFile);  
   
   LOGMSGOUT("TEXTDLL::Setting hook to work with INI file of a 'text.dll' on full path.", &ModWriteLogFile);  
   if(UpdateModuleImports(GetProcAddress(GetModuleHandle("Kernel32.dll"),"GetPrivateProfileIntA"), &ProcHookGetPrivateProfileIntA, RusTextDll))LOGMSGOUT("TEXTDLL::Setting a hook FAILED!", &ModWriteLogFile); 	
   
   GetModuleFileName(RusTextDll,(LPSTR)&AngelIniPath,sizeof(AngelIniPath));
   AngelIniPath[CharPosFromRight((LPSTR)&AngelIniPath, '\\', 0, 0)+1] = 0;
   lstrcat((LPSTR)&AngelIniPath,"Angel.ini");
  }
 return GetVersionEx(lpVersionInfo);
}
//====================================================================================
DWORD _stdcall ProcHookGetPrivateProfileIntA(LPSTR lpAppName, LPSTR lpKeyName, DWORD nDefault, LPSTR lpFileName)
{
 return GetPrivateProfileIntA(lpAppName, lpKeyName, nDefault, (LPSTR)&AngelIniPath);
}
//====================================================================================
DWORD _stdcall ProcHookBinkOpen(LPSTR FilePath, DWORD Unknown)
{
 int   Offset;
 LPSTR FileName = FilePath;
 BYTE  BikFilePath[MAX_PATH];
  
 LOGMSGOUT("GAMETHREAD::Trying to open a BIK file: %s", &ModWriteLogFile, FilePath);  
 if((Offset = CharPosFromRight(FilePath, '\\', 0, 0)) >=0 )FileName += (Offset+1);
 lstrcpy((LPSTR)&BikFilePath,(LPSTR)&GameCurDir);
 lstrcat((LPSTR)&BikFilePath,"Data Files\\Video\\");
 lstrcat((LPSTR)&BikFilePath, FileName);
 if(GetFileAttributes((LPSTR)&BikFilePath)==INVALID_FILE_ATTRIBUTES) // If file on hard drive
  {
   lstrcpy((LPSTR)&BikFilePath,"Z:\\Video\\"); 
   lstrcat((LPSTR)&BikFilePath, FileName);
   for(int ctr=0;ctr < 26;ctr++)
    {
     if(GetFileAttributes((LPSTR)&BikFilePath)!=INVALID_FILE_ATTRIBUTES){FileName = (LPSTR)&BikFilePath;break;} // File on CD
     BikFilePath[0]--;
    }            
  }
   else FileName = (LPSTR)&BikFilePath;   
 return ((DWORD (_stdcall*)(LPSTR,DWORD))HookBinkOpen.OriginalAddr)(FileName, Unknown);
}
//====================================================================================
BOOL _cdecl __PickMenuMode(DWORD Reg_EIP,DWORD Reg_EFL,MORROWIND::PCMenu Menu,MORROWIND::PCCursor Cursor,DWORD Reg_EBP,DWORD Reg_ESP,MORROWIND::PCGameScene GameSceneIn,DWORD Reg_EDX,MORROWIND::PCGameScene GameSceneOut,DWORD Reg_EAX,...)
{
 Menu->Activated = false;        // Always reset - MGE have a water problems, when paused 
 GameSceneOut    = GameSceneIn;  // Assertion, removed by this hook
 return false;
}
//====================================================================================

