
#ifndef MLDRLibH
#define MLDRLibH
//====================================================================================
#pragma once
#define WIN32_LEAN_AND_MEAN		 // Exclude rarely-used stuff from Windows headers
#define _WIN32_WINNT  0x0500     // For CoInitializeEx support

#include <windows.h>
#include <CommonFuncs.h>
#include <Morrowind.h>
//--------------------------------------------------------------------------- 
#define FMODHIGHPRI      0x80000000
#define	MOD_VERSION		 0x0001010A
#define	MOD_PARAMETERS   FMODHIGHPRI
#define RUSTEXTMODN      "Text.dll"
#define	INISECCONFIG	 "BaseConfig"
#define	INISECFIXES		 "UsedFixes"
#define MLDRLIBNAME      "MLDRLib.dll"
#define MLDRLOGPROC      "WriteLogFile"
#define THISMODNAME      "TroubleFixer"
#define MLDRPROCNAME     "IsModuleLoader"
#define CONFIGINIFILE    "TrFixerCfg.ini"
#define SHELLCFGNAME     ""		// For call from Moduleloader
#define SINGERRORMSGRU   "    .\r\n   'Morrowind.exe'? (: 1.6.1820).\r\n  !"
#define SINGERRORMSGEN   "One of a signatures is differs.\r\nWrong version of 'Morrowind.exe'? (Need: 1.6.1820).\r\nCONTINUE IS IMPOSSIBLE!"

// Ini file Options
DWORD        LangIndex        = 1;
BOOL         FixRequestCD     = TRUE;
BOOL         FixRusTexDll     = TRUE;
BOOL         FixLevUpText     = TRUE;
BOOL         FixBikSearch     = TRUE;
BOOL         FixMGraphExt     = TRUE;

const LPSTR  AuthorString     = "78DA011900E6FFD8C0D5CCC0CDCEC220C2C8CAD2CED020C0CDC4D0C5C5C2C8D7EF121267";
HMODULE      ExeModuleBase    = NULL;
HMODULE      ThisLibBase      = NULL;
HANDLE       DefHeapHandle    = NULL;
PVOID        MLDRWriteLogFile = NULL;
BOOL         ModuleLoader     = FALSE;
PVOID        ProcBinkOpen     = NULL;
CODEHOOK32   MgeFixHook;
CODEHOOK	 HookGetVersionExA;
IMPORTHOOK   HookBinkOpen;
BYTE         AngelIniPath[MAX_PATH];
BYTE         GameCurDir[MAX_PATH];
BYTE         CurrentDir[MAX_PATH];
BYTE         LogFilePath[MAX_PATH];
BYTE         CfgFilePath[MAX_PATH];
BYTE         ConfigAppName[64];

DWORD _stdcall ModGetVersion(void);
DWORD _stdcall ModGetParameters(void);        
DWORD _stdcall ModEventOnHostExit(void);       // Call this internally from DLL_PROCESS_DETACH
DWORD _stdcall ModEventOnHostStart(void);
LPSTR _stdcall ModGetConfigShellName(void);
DWORD _stdcall ModRunConfigShell(DWORD Reserved);
void  _stdcall ModWriteLogFile(LPSTR LogMessage);

void  _stdcall LoadConfiguration(LPSTR CfgFileName);

DWORD _stdcall ProcHookGetVersionExA(LPOSVERSIONINFO lpVersionInfo);
DWORD _stdcall ProcHookGetPrivateProfileIntA(LPSTR lpAppName, LPSTR lpKeyName, DWORD nDefault, LPSTR lpFileName);
DWORD _stdcall ProcHookBinkOpen(LPSTR FilePath, DWORD Unknown);
BOOL  _cdecl   __PickMenuMode(DWORD Reg_EIP,DWORD Reg_EFL,MORROWIND::PCMenu Menu,MORROWIND::PCCursor Cursor,DWORD Reg_EBP,DWORD Reg_ESP,MORROWIND::PCGameScene GameSceneIn,DWORD Reg_EDX,MORROWIND::PCGameScene GameSceneOut,DWORD Reg_EAX,...);

//====================================================================================
#endif
