//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "InstAll.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfmModInstaller *fmModInstaller;
//---------------------------------------------------------------------------
__fastcall TfmModInstaller::TfmModInstaller(TComponent* Owner) : TForm(Owner)
{
 BYTE Buffer[MAX_PATH];
 StartUpDir = ExtractFilePath(Application->ExeName);
 if(!FindDirectoryPath(StartUpDir.c_str(), (LPSTR)&Buffer, "Data Files\\"))TargetRootDir=StartUpDir;
   else
    {
     TargetRootDir = (LPSTR)&Buffer;
     TargetRootDir = TargetRootDir.SetLength(TargetRootDir.Length()-1);
     TargetRootDir = ExtractFilePath(TargetRootDir);
    }
 ModulesCfg = new TIniFile(TargetRootDir+MLDRINIFILE);

 InstTargetName = GetCommandLine();
 Autoinstall    = (InstTargetName.LowerCase()).Pos("-autoinst");
 if(Autoinstall){fmModInstaller->Width = 1;fmModInstaller->Height = 1;}
}
//---------------------------------------------------------------------------
void __fastcall TfmModInstaller::FormCreate(TObject *Sender)
{
 UseRelPaths    = ModulesCfg->ReadBool(INISECPARAMS,"UseRelPaths",true);
 InstTargetName = ModulesCfg->ReadString(INISECPARAMS,"TargetName","");
 InstTargetPath = ModulesCfg->ReadString(INISECPARAMS,"TargetPath","");
 FullTargetPath = (InstTargetPath.IsEmpty())?(TargetRootDir+InstTargetName):(InstTargetPath+InstTargetName);
 AddMessage((AnsiString)"Root directory is '"+TargetRootDir+"'");
}
//---------------------------------------------------------------------------
void __fastcall TfmModInstaller::FormShow(TObject *Sender)
{
 if(Autoinstall)
  {
   Autoinstall = false;
   bbInstallClick(NULL);
   fmModInstaller->Close();
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmModInstaller::FormClose(TObject *Sender, TCloseAction &Action)
{
 ModulesCfg->UpdateFile();
}
//---------------------------------------------------------------------------
void __fastcall TfmModInstaller::bbInstallClick(TObject *Sender)
{
 DWORD Result;

 bbUnInstallClick(NULL);

 if(GetFileAttributes((TargetRootDir+"MLShell.exe").c_str()) == INVALID_FILE_ATTRIBUTES){AddMessage("A MLShell.exe not found! Aborting operation...");return;}
 if(GetFileAttributes((TargetRootDir+"MLDRLib.dll").c_str()) == INVALID_FILE_ATTRIBUTES)
  {
   AddMessage("MLDRLib.dll not found! Executing MLShell.exe...");
   if(WinExec((TargetRootDir+"MLShell.exe").c_str(),SW_SHOWNORMAL) <= 31){AddMessage("Failed to run A MLShell.exe! Aborting operation...");return;}
   for(int ctr=4;(ctr > 0)&&(GetFileAttributes((TargetRootDir+"MLDRLib.dll").c_str()) == INVALID_FILE_ATTRIBUTES);ctr--)Sleep(1000);
   KillProcessByID(GetProcessIdByName("MLShell.exe"));
   if(GetFileAttributes((TargetRootDir+"MLDRLib.dll").c_str()) == INVALID_FILE_ATTRIBUTES){AddMessage("Failed to find 'MLDRLib.dll'! Aborting operation...");return;}
  }

 AddMessage("Installing the 'ModuleLoader' into a 'binkw32.dll'...");
 if(IsLoaderInstalled((TargetRootDir+"binkw32.dll").c_str()) == 2){if(UnInstallLoader((TargetRootDir+"binkw32.dll").c_str())){AddMessage("Failed to uninstall a wrong loader! Aborting operation...");return;}}
 CopyFile((TargetRootDir+"binkw32.dll").c_str(), (TargetRootDir+"binkw32.dll.bak").c_str(), true);
 if(IsLoaderInstalled((TargetRootDir+"binkw32.dll").c_str()) <= 0){if(InstallLoader((TargetRootDir+"binkw32.dll").c_str())){AddMessage("Failed to install the 'ModuleLoader into a 'binkw32.dll'! Aborting operation...");return;}}

 ModulesCfg->WriteString(INISECPARAMS,"TargetName","binkw32.dll");
 ModulesCfg->WriteString(INISECPARAMS,"TargetPath","");    // 'binkw32.dll' in current dir
 ModulesCfg->EraseSection(INISECMODLIST); // Remove all modules from ini file
 ModulesCfg->UpdateFile();
 AddMessage("Installing a modules...");
 EnumFiles(TargetRootDir.c_str(), false);
}
//---------------------------------------------------------------------------
void __fastcall TfmModInstaller::bbUnInstallClick(TObject *Sender)
{
 meMessages->Clear();
 AddMessage("UnInstalling a modules...");
 ModulesCfg->WriteString(INISECPARAMS,"TargetName","");
 ModulesCfg->WriteString(INISECPARAMS,"TargetPath","");
 ModulesCfg->EraseSection(INISECMODLIST); // Remove all modules from ini file
 ModulesCfg->UpdateFile();
 EnumFiles(TargetRootDir.c_str(), true);
}
//---------------------------------------------------------------------------
void _stdcall TfmModInstaller::AddMessage(AnsiString Message)
{
 meMessages->Lines->Add(Message);
}
//---------------------------------------------------------------------------
bool _stdcall TfmModInstaller::EnumFiles(LPSTR FolderPath, bool UnInst)
{
 DWORD  PathLen;
 HANDLE hSearch;
 WIN32_FIND_DATA fdat;
 char   PathBuffer[MAX_PATH];

 PathBuffer[0] = 0;
 lstrcat(PathBuffer,FolderPath);
 PathLen = lstrlen(PathBuffer);
 if(PathBuffer[PathLen-1] == '\\')PathLen--;
 PathBuffer[PathLen+0] = '\\';
 PathBuffer[PathLen+1] = '*';
 PathBuffer[PathLen+2] = 00;
 hSearch = FindFirstFile(PathBuffer,&fdat);
 if(hSearch != INVALID_HANDLE_VALUE)
  {
   do
	{
	 if(!((fdat.cFileName[0] == 0x2E)&&(fdat.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)))
	  {
       PathBuffer[PathLen+1] = 0;
       lstrcat(PathBuffer,fdat.cFileName);
	   if(fdat.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)EnumFiles(PathBuffer, UnInst);
		 else
		  {
		   if(UnInst)
			{
			 // Uninstall all loaders
			 if((ExtractFileExt((LPSTR)&PathBuffer).AnsiCompareIC(".DLL") == 0)||(ExtractFileExt((LPSTR)&PathBuffer).AnsiCompareIC(".EXE") == 0))
			  {
			   if(fdat.dwFileAttributes & FILE_ATTRIBUTE_READONLY)SetFileAttributes(PathBuffer, FILE_ATTRIBUTE_NORMAL);
			   switch(UnInstallLoader(PathBuffer))
				{
				 case 0:
				   AddMessage((AnsiString)"Uninstalled from: "+ExtractFileName((LPSTR)&PathBuffer));
				   break;
				 case 3:
				   AddMessage((AnsiString)"Nothing found in: "+ExtractFileName((LPSTR)&PathBuffer));
				   break;
				 default:
				   AddMessage((AnsiString)"Error on: "+ExtractFileName((LPSTR)&PathBuffer));
				}
			  }
			}
			 else
			  {
			   // Find and install modules
			   if(ExtractFileExt((LPSTR)&PathBuffer).AnsiCompareIC(".DLL") == 0)
				{
			  	 if(!RegisterModule((LPSTR)&PathBuffer))AddMessage((AnsiString)"Registering a module: "+ExtractFileName((LPSTR)&PathBuffer));
				}
			  }
		  }
	  }
    }
     while(FindNextFile(hSearch,&fdat));
   FindClose(hSearch);
   return RemoveDirectory(FolderPath);
  }
   else return 0;
}
//---------------------------------------------------------------------------
int _stdcall TfmModInstaller::RegisterModule(LPSTR ModulePath)
{
 DWORD      Result;
 DWORD      VerSize;
 PVOID      VerBuff;
 PVOID      ParamProc;
 HMODULE    hCurLib;
 DWORD      IsTextDll;
 AnsiString FileDescription;
 AnsiString ProductVersion;
 AnsiString ProductName;
 AnsiString CompanyName;
 AnsiString ModuleDesc;
 AnsiString ModuleFile;
 AnsiString ModDstPath;
 StringFileInfo *DataEntry;

 hCurLib   = LoadLibraryEx(ModulePath, NULL, DONT_RESOLVE_DLL_REFERENCES);
 ParamProc = GetProcAddress(hCurLib,MODCHECKPROC);
 FreeLibrary(hCurLib);
 IsTextDll = (ExtractFileName(ModulePath).AnsiCompareIC("Text.DLL") == 0);
 if(!ParamProc && !IsTextDll)return 1;

 ModuleFile = ExtractFileName(ModulePath);
 if(!ModulesCfg->ReadString(INISECMODLIST,ModuleFile,"").IsEmpty())return 2;  // Do not overwrite if exist
 if(UseRelPaths)ModDstPath = ExtractFilePath(ExtractRelativePath(ExtractFilePath(FullTargetPath),ModulePath));
   else ModDstPath = ExtractFilePath(ModulePath);

 VerSize = GetFileVersionInfoSize(ModulePath,&Result);
 if(VerSize)
  {
   VerBuff = HeapAlloc(GetProcessHeap(),0,VerSize+32);
   GetFileVersionInfo(ModulePath,0,VerSize,VerBuff);
   FileDescription = WideCharToString((PWSTR)GetVersionData("FileDescription",VerBuff)).Trim();
   ProductVersion  = WideCharToString((PWSTR)GetVersionData("ProductVersion",VerBuff)).Trim();
   ProductName     = WideCharToString((PWSTR)GetVersionData("ProductName",VerBuff)).Trim();
   CompanyName     = WideCharToString((PWSTR)GetVersionData("CompanyName",VerBuff)).Trim();
   if(FileDescription.IsEmpty())FileDescription = WideCharToString((PWSTR)GetVersionData("Comments",VerBuff));
   if(ProductVersion.IsEmpty())ProductVersion = WideCharToString((PWSTR)GetVersionData("FileVersion",VerBuff));
   if(ProductName.IsEmpty())ProductName = WideCharToString((PWSTR)GetVersionData("InternalName",VerBuff));
   if(CompanyName.IsEmpty())CompanyName = WideCharToString((PWSTR)GetVersionData("LegalCopyright",VerBuff));
   ModuleDesc = ProductName;
   if(!ProductVersion.IsEmpty())ModuleDesc  += " (ver: "+ProductVersion;
   if(!CompanyName.IsEmpty())ModuleDesc     += ") by "+CompanyName;
   if(!FileDescription.IsEmpty())ModuleDesc += " - [ "+FileDescription+" ]";
   HeapFree(GetProcessHeap(),0,VerBuff);
  }

 Result    = 0;
 if(!IsTextDll)
  {
   ParamProc = GetProcAddress(LoadLibrary(ModulePath),MODPARPROCN);
   if(ParamProc)Result = (bool)(((unsigned long _stdcall (*)(void))ParamProc)() & FMODHIGHPRI);
  }
 ModulesCfg->WriteString(INISECMODLIST,ModuleFile.Trim(),(IntToStr(Result+1)+'<'+ModDstPath.Trim()+'>'+ModuleDesc).Trim());
 return 0;
}
//---------------------------------------------------------------------------
DWORD _stdcall UnInstallLoader(LPSTR HostPath)
{
 HANDLE hFile;
 DWORD  Result;
 DWORD  ErrCode;
 DWORD  FileSize;
 PVOID  FileInBuf;
 PVOID  InstAddr;
 DOS_HEADER     *DosHdr;
 WIN_HEADER     *WinHdr;
 SECTION_HEADER *CurSection;

 hFile = CreateFile(HostPath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 if(hFile == INVALID_HANDLE_VALUE)return 1;
 ErrCode   = 0;
 FileSize  = GetFileSize(hFile, NULL);
 FileInBuf = HeapAlloc(GetProcessHeap(),0,FileSize+256);
 ReadFile(hFile,FileInBuf,FileSize,&Result,NULL);
 if(Result != FileSize){ErrCode=2;goto Exit;}
 if(!IsValidPEHeader(FileInBuf)){ErrCode=2;goto Exit;}

 DosHdr    = (DOS_HEADER*)FileInBuf;
 WinHdr    = (WIN_HEADER*)&((BYTE*)FileInBuf)[DosHdr->OffsetHeaderPE];
 Result    = (RvaToFileOffset(FileInBuf,WinHdr->OptionalHeader.EntryPointRVA,&CurSection)-INJEXTRAB);
 InstAddr  = &((PBYTE)FileInBuf)[Result];
 if((((PDWORD)InstAddr)[0] != TLKYFLAG)&&(((PDWORD)InstAddr)[0] != MLDRFLAG)){ErrCode=3;goto Exit;}
 WinHdr->OptionalHeader.EntryPointRVA = ((PDWORD)InstAddr)[4];
 ZeroMemory(InstAddr,INSTBYTES);
 CurSection->VirtualSize -= INSTBYTES+4;
 SetFilePointer(hFile,0,NULL,FILE_BEGIN);
 WriteFile(hFile,FileInBuf,FileSize,&Result,NULL);

Exit:
 HeapFree(GetProcessHeap(),0,FileInBuf);
 CloseHandle(hFile);
 return ErrCode;
}
//---------------------------------------------------------------------------
DWORD _stdcall InstallLoader(LPSTR HostPath)
{
 HANDLE hFile;
 DWORD  Result;
 DWORD  ErrCode;
 DWORD  K32Offs;
 DWORD  InstOffs;
 DWORD  FileSize;
 PVOID  InstAddr;
 PVOID  FileInBuf;
 LPSTR  TmpName;
 DOS_HEADER     *DosHdr;
 WIN_HEADER     *WinHdr;
 IMPORT_DESC    *Import;
 DATA_DIRECTORY *ImportDir;
 SECTION_HEADER *CurSection;

 hFile = CreateFile(HostPath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 if(hFile == INVALID_HANDLE_VALUE)return 1;
 ErrCode   = 0;
 FileSize  = GetFileSize(hFile, NULL);
 FileInBuf = HeapAlloc(GetProcessHeap(),0,FileSize+256);
 ReadFile(hFile,FileInBuf,FileSize,&Result,NULL);
 if(Result != FileSize){ErrCode=2;goto Exit;}
 if(!IsValidPEHeader(FileInBuf)){ErrCode=3;goto Exit;}

 DosHdr    = (DOS_HEADER*)FileInBuf;
 WinHdr    = (WIN_HEADER*)&((BYTE*)FileInBuf)[DosHdr->OffsetHeaderPE];
 ImportDir = &WinHdr->OptionalHeader.DataDirectories.ImportTable;
 Import    = (IMPORT_DESC*)&((BYTE*)FileInBuf)[RvaToFileOffset(FileInBuf,ImportDir->DirectoryRVA,NULL)];
 K32Offs   = 0;
 while(Import->ModuleNameRVA) // Last will be empty
  {
   TmpName = ((LPSTR)&((BYTE*)FileInBuf)[RvaToFileOffset(FileInBuf,Import->ModuleNameRVA,NULL)]);
   if(lstrcmpi("Kernel32.dll",TmpName)==0){K32Offs = Import->AddressTabRVA;break;}
   Import++;
  }
 if(!K32Offs){ErrCode=4;goto Exit;}

 CurSection = (SECTION_HEADER*)&((BYTE*)FileInBuf)[(DosHdr->OffsetHeaderPE+sizeof(WIN_HEADER))];
 for(int ctr = 0;ctr < WinHdr->FileHeader.SectionsNumber;ctr++,CurSection++)
  {
   if((CurSection->VirtualSize < CurSection->PhysicalSize)&&((CurSection->PhysicalSize-CurSection->VirtualSize) >= INSTBYTES))
	{
	 InstOffs = (CurSection->PhysicalOffset+(CurSection->VirtualSize&0xFFFFFFFC)+4); // make aligned to DWORD
	 InstAddr = &((BYTE*)FileInBuf)[InstOffs];
	 ((PDWORD)InstAddr)[0] = INSTFLAG;
	 ((PDWORD)InstAddr)[1] = INSTBYTES;
	 ((PDWORD)InstAddr)[2] = K32Offs;         // Some import from kernel32
	 ((PDWORD)InstAddr)[3] = (CurSection->SectionRva+(InstOffs-CurSection->PhysicalOffset)+INJEXTRAB);  // new EP
	 ((PDWORD)InstAddr)[4] = WinHdr->OptionalHeader.EntryPointRVA;  // Save original EP
	 lstrcpy((LPSTR)&((PDWORD)InstAddr)[5],INJLIBNAME);
	 CurSection->VirtualSize += INSTBYTES+4;
	 WinHdr->OptionalHeader.EntryPointRVA = ((PDWORD)InstAddr)[3];   // Set new EP
	 CopyMemory(&((PBYTE)InstAddr)[INJEXTRAB],&BeginInstEntry,INJPREPLEN);
	 CopyMemory(&((PBYTE)InstAddr)[INJEXTRAB+INJPREPLEN],&InjLoadLibraryA,INJPROCLEN);
	 SetFilePointer(hFile,0,NULL,FILE_BEGIN);
	 WriteFile(hFile,FileInBuf,FileSize,&Result,NULL);
	 break;
	}
  }

Exit:
 HeapFree(GetProcessHeap(),0,FileInBuf);
 CloseHandle(hFile);
 return ErrCode;
}
//---------------------------------------------------------------------------
int _stdcall IsLoaderInstalled(LPSTR HostPath)
{
 HANDLE     hFile;
 DWORD      Result;
 DWORD      Value;
 DOS_HEADER DOSHeader;
 WIN_HEADER WINHeader;
 BYTE       NameBuf[32];

 hFile = CreateFile(HostPath,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 Result = GetLastError();
 if(hFile == INVALID_HANDLE_VALUE)return -1;
 SetFilePointer(hFile,0,NULL,FILE_BEGIN);
 ReadFile(hFile,&DOSHeader,sizeof(DOS_HEADER),&Result,NULL);
 if(Result != sizeof(DOS_HEADER)){CloseHandle(hFile);return -2;}   //  cannot read file
 if(DOSHeader.FlagMZ != SIGN_MZ){CloseHandle(hFile);return -3;}
 SetFilePointer(hFile,DOSHeader.OffsetHeaderPE,NULL,FILE_BEGIN);
 ReadFile(hFile,&WINHeader,sizeof(WIN_HEADER),&Result,NULL);
 if(Result != sizeof(WIN_HEADER)){CloseHandle(hFile);return -4;}   //  cannot read file
 if(WINHeader.FlagPE != SIGN_PE){CloseHandle(hFile);return -5;}
 Result = (RvaToFileOffsetF(hFile,WINHeader.OptionalHeader.EntryPointRVA,NULL)-INJEXTRAB);
 SetFilePointer(hFile,Result,NULL,FILE_BEGIN);
 ReadFile(hFile,&Value,sizeof(DWORD),&Result,NULL);
 CloseHandle(hFile);
 if(Value == MLDRFLAG)return 1;
 if(Value == TLKYFLAG)return 2;
 return 0;
}
//---------------------------------------------------------------------------
PVOID _stdcall GetVersionData(LPSTR StringName, PVOID VerBufer)
{
 DWORD BufferSize;
 PWSTR NameStr;
 PWSTR DataStr;
 WCHAR Buffer[128];

 // What a STUPID format of resource structure? I don`t know how to parse it, and use brute force instead.
 NameStr    = (PWSTR)&Buffer;
 DataStr    = (PWSTR)VerBufer;
 BufferSize = ((PWORD)VerBufer)[0];
 MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,StringName,-1,NameStr,sizeof(Buffer));
 for(DWORD ctr=0;ctr < (BufferSize-lstrlenW(NameStr));ctr++,DataStr++)
  {
   if(lstrcmpW(NameStr,DataStr)==0)
	{
	 DataStr += lstrlenW(DataStr);
	 DataStr  = (PWSTR)(((DWORD)DataStr & 0xFFFFFFFC)+4); // Align to DWORD
	 return DataStr;   // Return some resource data
	}
  }
 return NULL;
}
//---------------------------------------------------------------------------
DWORD _stdcall GetProcessIdByName(LPSTR StringName)
{
 PROCESSENTRY32 pent32;
 HANDLE         hProcessSnap;

 pent32.dwSize = sizeof(PROCESSENTRY32);
 hProcessSnap  = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
 if(Process32First(hProcessSnap, &pent32))
  {
   do
	{
	 if(lstrcmpi(ExtractFileName((LPSTR)&pent32.szExeFile).c_str(), StringName) == 0)
	  {
	   CloseHandle(hProcessSnap);
	   return pent32.th32ProcessID;
	  }
	}
   while(Process32Next(hProcessSnap, &pent32));
  }
 CloseHandle(hProcessSnap);
 return NULL;
}
//---------------------------------------------------------------------------
bool _stdcall KillProcessByID(DWORD ProcessID)
{
 HANDLE hProcess;

 hProcess = OpenProcess(PROCESS_TERMINATE,false,ProcessID);
 if(hProcess){TerminateProcess(hProcess, 1);CloseHandle(hProcess);return true;}
 return false;
}
//---------------------------------------------------------------------------
DWORD __stdcall IsModuleLoader(void)
{
 return 1;
}
//---------------------------------------------------------------------------
bool _stdcall FindDirectoryPath(LPSTR InitialPath, LPSTR OutputPath, LPSTR NameToFind)
{
 int   PathLen = lstrlen(InitialPath);
 bool  NeedDir = false;   // If 'NameToFind' ends with PathDelimiter or 'NameToFind' and 'InitialPath' ends with PathDelimiter - search for directory, else for path
 LPSTR NamePtr = NULL;
 BYTE  PathBuffer[MAX_PATH];

 lstrcpy((LPSTR)&PathBuffer, InitialPath);
 if(NameToFind)
  {      // If 'NameToFind' begins with PathDelimiter or  'NameToFind' = PathDelimiter - search for directory
   if((((DWORD)NameToFind == PATHDLML)||((DWORD)NameToFind == PATHDLMR))||((NameToFind[0] == PATHDLML)||(NameToFind[0] == PATHDLMR))){NeedDir = true;NameToFind=NULL;}
   if(!NeedDir && NameToFind && NameToFind[0]){int NameLen = lstrlen(NameToFind);NeedDir = (PathLen && ((NameToFind[NameLen-1]==PATHDLML)||(NameToFind[NameLen-1]==PATHDLMR)));}
   if(NeedDir && ((PathBuffer[PathLen-1] != PATHDLML)&&(PathBuffer[PathLen-1] != PATHDLMR))){PathBuffer[PathLen]=PATHDLML;PathLen++;}
  }
 if(!OutputPath)OutputPath = InitialPath;   // If 'OutputDir' is NULL result saved to 'InitialPath'
   else OutputPath[0] = 0;
 if((PathBuffer[PathLen-1] == PATHDLML)||(PathBuffer[PathLen-1] == PATHDLMR))   // if 'NameToFind' is NULL or empty, name assumed at end of 'InitialPath'
  {
   if(NameToFind && NameToFind[0])NamePtr=NameToFind;
     else
      {
       NeedDir = true;
       PathLen--;
       while((PathBuffer[PathLen-1]!=PATHDLML)&&(PathBuffer[PathLen-1]!=PATHDLMR)&&(PathLen > 0))PathLen--;
      }
  }
    else
     {
      if(NameToFind && NameToFind[0]){PathBuffer[PathLen]=PATHDLML;NamePtr=NameToFind;}
        else {while((PathBuffer[PathLen-1]!=PATHDLML)&&(PathBuffer[PathLen-1]!=PATHDLMR)&&(PathLen > 0))PathLen--;}
     }
 while(PathLen > 0)
  {
   if(NamePtr)lstrcat((LPSTR)&PathBuffer, NamePtr);
   NamePtr = &PathBuffer[PathLen];
   DWORD Attrs = GetFileAttributes((LPSTR)&PathBuffer);
   if((Attrs != INVALID_FILE_ATTRIBUTES)&&((FILE_ATTRIBUTE_DIRECTORY & Attrs)&&NeedDir)||(!(FILE_ATTRIBUTE_DIRECTORY & Attrs)&&!NeedDir)){lstrcpy(OutputPath,(LPSTR)&PathBuffer);return true;}
   PathLen--;
   while((PathBuffer[PathLen-1]!=PATHDLML)&&(PathBuffer[PathLen-1]!=PATHDLMR)&&(PathLen > 0))PathLen--;
   PathBuffer[PathLen] = 0;
  }
 return false;
}
//---------------------------------------------------------------------------
__declspec(naked) void _stdcall BeginInstEntry(void) // Size=64
{
 __asm
 {
  DB 0xE8,0x00,0x00,0x00,0x00  // CALL next  //push AddrInKernel
  push 0      // addr of lib name
  push 0      // Real EP
  push EAX
  push ECX
  mov  EAX,[ESP+16]
  lea  ECX,[EAX-5]
  sub  EAX,(5+INJEXTRAB)   // EAX = Data Base
  sub  ECX,[EAX+12]        // ECX = Module Base
  mov  [ESP+16],ECX
  mov  [ESP+12],EAX
  mov  [ESP+ 8],ECX
  add  DWORD PTR [ESP+12],20
  mov  ECX,[EAX+16]
  add  [ESP+8],ECX
  mov  ECX,[ESP+16]
  add  ECX,[EAX+8]
  mov  ECX,[ECX]
  mov  [ESP+16],ECX
  pop  ECX
  pop  EAX
  nop
 }
}
//---------------------------------------------------------------------------


