//---------------------------------------------------------------------------

#ifndef InstAllH
#define InstAllH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <XPMan.hpp>
#include <IniFiles.hpp>
#include <Buttons.hpp>
#include <tlhelp32.h>

#include "FormatPE.h"

#define PATHDLML 0x5C
#define PATHDLMR 0x2F

#define FMODHIGHPRI   0x80000000
#define TLKYFLAG      0x594B4C54         //TLKY
#define MLDRFLAG      0x52444C4D         //MLDR
#define INSTFLAG      MLDRFLAG
#define MODCHECKPROC  "ModGetVersion"
#define MODPARPROCN   "ModGetParameters"
#define INJLIBNAME    "MLDRLib.dll"
#define MLDRINIFILE   "ModuleLoader.ini"
#define INISECPARAMS  "Parameters"
#define INISECMODLIST "ModulesList"
#define INJNAMELEN    20          // Maximal
#define INJPROCLEN    119
#define INJPREPLEN    64
#define INJEXTRAB     (20+INJNAMELEN)
#define INSTBYTES     (INJEXTRAB+INJPREPLEN+INJPROCLEN)

extern "C" DWORD __export __stdcall IsModuleLoader(void);

bool   _stdcall FindDirectoryPath(LPSTR InitialPath, LPSTR OutputPath, LPSTR NameToFind);
int    _stdcall IsLoaderInstalled(LPSTR HostPath);
DWORD  _stdcall InstallLoader(LPSTR HostPath);
DWORD  _stdcall UnInstallLoader(LPSTR HostPath);
PVOID  _stdcall GetVersionData(LPSTR StringName, PVOID VerBufer);
DWORD  _stdcall GetProcessIdByName(LPSTR StringName);
bool   _stdcall KillProcessByID(DWORD ProcessID);
void   _stdcall BeginInstEntry(void);
//---------------------------------------------------------------------------
struct String
{
 WORD   wLength;
 WORD   wValueLength;
 WORD   wType;
 WCHAR  szKey[];
 WORD   Padding[];
 WORD   Value[]; 
};
//---------------------------------------------------------------------------
struct StringTable
{
 WORD   wLength;
 WORD   wValueLength;
 WORD   wType;
 WCHAR  szKey[];
 WORD   Padding[];
 ::String Children[];
};
//---------------------------------------------------------------------------
struct StringFileInfo
{
 WORD        wLength;
 WORD        wValueLength;
 WORD        wType;
 WCHAR       szKey[];
 WORD        Padding[];
 StringTable Children[];
};
//---------------------------------------------------------------------------
class TfmModInstaller : public TForm
{
__published:	// IDE-managed Components
	TXPManifest *XPManifest1;
	TMemo *meMessages;
	TBitBtn *bbInstall;
	TBitBtn *bbUnInstall;
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall bbInstallClick(TObject *Sender);
	void __fastcall bbUnInstallClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
private:	// User declarations
public:		// User declarations
 AnsiString StartUpDir;
 AnsiString TargetRootDir;
 AnsiString InstTargetName;
 AnsiString InstTargetPath;
 AnsiString FullTargetPath;
 bool       UseRelPaths;
 bool       Autoinstall;
 TIniFile   *ModulesCfg;

 bool  _stdcall EnumFiles(LPSTR FolderPath, bool UnInst);
 int   _stdcall RegisterModule(LPSTR ModulePath);
 void  _stdcall AddMessage(AnsiString Message);

	__fastcall TfmModInstaller(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmModInstaller *fmModInstaller;
//---------------------------------------------------------------------------
#endif
