//---------------------------------------------------------------------------
#pragma hdrstop

#include "fMainForm.h"
#include "HelperFuncs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
int _stdcall UpdateActorsList(TStrings *List, CObjItem *StartItem, DWORD CSProcessID)
{
 if(!List || !StartItem)return 0;
 int Count = 0;
 CActorItem *PrevActor = NULL;
 CObjItem   ActorObject;

 CopyMemory(&ActorObject,StartItem,sizeof(CObjItem));
 if(List->Count > 0)PrevActor = (CActorItem*)List->Objects[List->Count-1];
 while(PrevActor && PrevActor->GetNext())PrevActor = PrevActor->GetNext();
 do
  {
   if(ActorObject.Object)
    {
     CActorItem *NewActor = new CActorItem(PrevActor,ActorObject.Object,CSProcessID);
     if(NewActor->GetObjectID()){List->AddObject(NewActor->GetObjectID(),(TObject*)NewActor);PrevActor=NewActor;Count++;}
       else delete(NewActor);
    }
  }
   while(ActorObject.Next && Toolhelp32ReadProcessMemory(CSProcessID,ActorObject.Next,&ActorObject,sizeof(CObjItem),NULL));
 return Count;
}
//------------------------------------------------------------------------------------
int _stdcall LoadActorsList(TStrings *List, DWORD CSProcessID)
{
 int        Count = 0;
 PBYTE      CSBaseAddress;
 CActorItem *PrevActor = NULL;
 CObjType   ActorType;
 CObjList   ActorList;
 CObjItem   ActorObject;
 CObjType   *CSTypesTable[23];

 if(!List)return 0;
 CSBaseAddress = (PBYTE)GetProcessExeBase(CSProcessID);
 if(!Toolhelp32ReadProcessMemory(CSProcessID,&CSBaseAddress[TypeTableOff],&CSTypesTable,sizeof(CSTypesTable),NULL))return 0;

 // Load all 'NPC_' from Construction Set
 ZeroMemory(&ActorObject,sizeof(CObjItem));
 if(Toolhelp32ReadProcessMemory(CSProcessID,CSTypesTable[16],&ActorType,sizeof(CObjType),NULL)&&
    Toolhelp32ReadProcessMemory(CSProcessID,ActorType.Objects,&ActorList,sizeof(CObjList),NULL)&&
	Toolhelp32ReadProcessMemory(CSProcessID,ActorList.FirstObject,&ActorObject,sizeof(CObjItem),NULL))Count += UpdateActorsList(List, &ActorObject, CSProcessID);

 // Load all 'CREA' from Construction Set
 ZeroMemory(&ActorObject,sizeof(CObjItem));
 if(Toolhelp32ReadProcessMemory(CSProcessID,CSTypesTable[17],&ActorType,sizeof(CObjType),NULL)&&
    Toolhelp32ReadProcessMemory(CSProcessID,ActorType.Objects,&ActorList,sizeof(CObjList),NULL)&&
	Toolhelp32ReadProcessMemory(CSProcessID,ActorList.FirstObject,&ActorObject,sizeof(CObjItem),NULL))Count += UpdateActorsList(List, &ActorObject, CSProcessID);

 return Count;
}
//------------------------------------------------------------------------------------
int _stdcall LoadRacesList(TStrings *List, DWORD CSProcessID)
{
 int        Count = 0;
 PBYTE      CSBaseAddress;
 DWORD      PropTablePtr;
 DWORD      PropTableAddr;
 CRaceItem  *PrevRace = NULL;
 CObjList   RaceList;
 CObjItem   RaceObject;
 CObjTable  ObjTable;

 if(!List)return 0;
 ZeroMemory(&RaceObject,sizeof(CObjItem));
 CSBaseAddress = (PBYTE)GetProcessExeBase(CSProcessID);
 if(Toolhelp32ReadProcessMemory(CSProcessID,&CSBaseAddress[PObjTableOff],&PropTablePtr,sizeof(DWORD),NULL)&&
    Toolhelp32ReadProcessMemory(CSProcessID,(PVOID)PropTablePtr,&PropTableAddr,sizeof(DWORD),NULL)&&
    Toolhelp32ReadProcessMemory(CSProcessID,(PVOID)PropTableAddr,&ObjTable,sizeof(CObjTable),NULL)&&
    Toolhelp32ReadProcessMemory(CSProcessID,ObjTable.ObjListRACE,&RaceList,sizeof(CObjList),NULL)&&
    Toolhelp32ReadProcessMemory(CSProcessID,RaceList.FirstObject,&RaceObject,sizeof(CObjItem),NULL))
  {
   do
    {
     if(RaceObject.Object)
      {
       CRaceItem *NewRace = new CRaceItem(PrevRace,RaceObject.Object,CSProcessID);
	   if(NewRace->GetRaceID()){List->AddObject(NewRace->GetRaceID(),(TObject*)NewRace);PrevRace=NewRace;Count++;}
         else delete(NewRace);
      }
    }
     while(RaceObject.Next && Toolhelp32ReadProcessMemory(CSProcessID,RaceObject.Next,&RaceObject,sizeof(CObjItem),NULL));
  }
 return Count;
}
//---------------------------------------------------------------------------
void _stdcall NormalizeTextString(LPSTR DstTextStr, LPSTR SrcTextStr)
{
 bool SecSpace  = false;
 bool SkipChars = false;
 while(SrcTextStr[0])
  {
   if(((BYTE)SrcTextStr[0]) == '>'){SkipChars = false;SrcTextStr++;continue;}
   if(((BYTE)SrcTextStr[0]) == '<'){SkipChars = true;SrcTextStr++;continue;}
   if(SkipChars){SrcTextStr++;continue;}
   if((((BYTE)SrcTextStr[0] == '@')||((BYTE)SrcTextStr[0] == '#')||((BYTE)SrcTextStr[0] == 0x7F))&&SrcTextStr[0]){SrcTextStr++;continue;}
   if((BYTE)SrcTextStr[0] <= 0x20){if(SecSpace){SrcTextStr++;continue;}DstTextStr[0] = 0x20;SecSpace=true;}  // Replace all special symbols with space
     else
      {
       SecSpace=false;
       if(SrcTextStr[0] == '%')
        {
         SrcTextStr++;
         for(int ctr=0;ctr<(sizeof(DlgReplacers)/sizeof(LPSTR));ctr++)
          {
           int SLen = lstrlen(DlgReplacers[ctr]);
           if(CompareString(LOCALE_USER_DEFAULT,NORM_IGNORECASE,SrcTextStr,SLen,DlgReplacers[ctr],SLen)==CSTR_EQUAL){SrcTextStr += SLen;break;}
          }
         continue;
        }
       DstTextStr[0] = SrcTextStr[0];
      }
   SrcTextStr++;  
   DstTextStr++;
  } 
 DstTextStr[0] = 0;
}
//------------------------------------------------------------------------------------
void _stdcall LoadSpeechTree(LPSTR Path, TTreeView *Tree, TTreeNode* CurNode)
{
 DWORD  PathLen;
 HANDLE hSearch;
 WIN32_FIND_DATA fdat;
 BYTE  PathBuffer[MAX_PATH];

 if(CurNode)
  {
   SetSpeechNodeID(CurNode);
   if(!Tree)if(!IsDirectoryEmpty(Path)){((TTreeView*)CurNode->TreeView)->Items->AddChildObject(CurNode,DUMMYNODE,NULL);return;}
  }
 lstrcpy((LPSTR)&PathBuffer, Path);
 PathLen = lstrlen(PathBuffer);
 if((PathBuffer[PathLen-1] == PATHDLML)||(PathBuffer[PathLen-1] == PATHDLMR))PathLen--;
 PathBuffer[PathLen+0] = PATHDLML;
 PathBuffer[PathLen+1] = '*';
 PathBuffer[PathLen+2] = 00;
 hSearch = FindFirstFile((LPSTR)&PathBuffer, &fdat);
 if(hSearch == INVALID_HANDLE_VALUE)return;
 do
  {
   if(IsDirectPath((LPSTR)&fdat.cFileName)&&(fdat.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
    {
     PathBuffer[PathLen+1] = 0;
     lstrcat(PathBuffer,fdat.cFileName);
     TTreeNode* ChildNode  = GetChildNode(CurNode, (LPSTR)&fdat.cFileName);
     if(!ChildNode)ChildNode = Tree->Items->AddChildObject(CurNode,(LPSTR)&fdat.cFileName,NULL);
     LoadSpeechTree((LPSTR)&PathBuffer, NULL, ChildNode);
    }
  }
   while(FindNextFile(hSearch, &fdat));
 FindClose(hSearch);

 PathBuffer[PathLen+1] = 0;
 lstrcat(PathBuffer, SPEECHFMASK);

 hSearch = FindFirstFile((LPSTR)&PathBuffer, &fdat);
 if(hSearch == INVALID_HANDLE_VALUE)return;
 do
  {
   if(IsDirectPath((LPSTR)&fdat.cFileName)&&!(fdat.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)&&(fdat.cFileName[8]=='.'))
	{
     PathBuffer[PathLen+1] = 0;
     lstrcat(PathBuffer,fdat.cFileName);
     fdat.cFileName[8]     = 0;
     if(!GetChildNode(CurNode, (LPSTR)&fdat.cFileName))
      {
       CSpeechFile* Speech = fmMainForm->GetSafeAudioFormat((LPSTR)&PathBuffer);
	   if(Speech)Tree->Items->AddChildObject(CurNode,(LPSTR)&fdat.cFileName,(TObject*)Speech)->StateIndex = 1;   // Load MP3 Info here
         else Tree->Items->AddChildObject(CurNode,"ERROR",NULL)->StateIndex = 8;
      }
    }
  }
   while(FindNextFile(hSearch, &fdat));
 FindClose(hSearch);
}
//------------------------------------------------------------------------------------
void _stdcall SetSpeechNodeID(TTreeNode* SpeechNode)
{
 if(!SpeechNode)return;
 if(lstrcmpi(SpeechNode->Text.c_str(),SDIR_NPC)==0)SpeechNode->StateIndex = 2;
   else
    {
 if((lstrcmpi(SpeechNode->Text.c_str(),SDIR_CREATURE)==0)&&(!SpeechNode->Parent||(lstrcmpi(SpeechNode->Parent->Text.c_str(),SDIR_CREATURE)!=0)))SpeechNode->StateIndex = 5;
   else
    {
 if(lstrcmpi(SpeechNode->Text.c_str(),SDIR_MALE)==0)SpeechNode->StateIndex = 3;
   else
    {
 if(lstrcmpi(SpeechNode->Text.c_str(),SDIR_FEMALE)==0)SpeechNode->StateIndex = 4;
   else
    {
 if((SpeechNode->Text[1]=='_')&&(SpeechNode->Text[2]=='_'))SpeechNode->StateIndex = 6;
   else SpeechNode->StateIndex = 7;
    }}}}
}
//---------------------------------------------------------------------------
DWORD _stdcall MakeRawTextAndCRC(LPSTR TextString)
{
 bool  SkipChars  = false;
 LPSTR SrcPointer = TextString;
 LPSTR DstPointer = TextString;
 while(SrcPointer[0])
  {
   if(((BYTE)SrcPointer[0]) == '>'){SkipChars = false;SrcPointer++;continue;}
   if(((BYTE)SrcPointer[0]) == '<'){SkipChars = true;SrcPointer++;continue;}
   if(SkipChars){SrcPointer++;continue;}
   if((((BYTE)SrcPointer[0]) < 0x21)||(((BYTE)SrcPointer[0]) == 0x7F)||(((BYTE)SrcPointer[0]) == '#')||(((BYTE)SrcPointer[0]) == '@')){SrcPointer++;continue;}   // Remove spaces and special symbols
   if(SrcPointer[0] == '%')
    {                                                                    
     SrcPointer++;
     for(int ctr=0;ctr<(sizeof(DlgReplacers)/sizeof(LPSTR));ctr++)
      {
       int SLen = lstrlen(DlgReplacers[ctr]);
       if(CompareString(LOCALE_USER_DEFAULT,NORM_IGNORECASE,SrcPointer,SLen,DlgReplacers[ctr],SLen)==CSTR_EQUAL){SrcPointer += SLen;break;}
      }   
     continue;
    }
   DstPointer[0] = SrcPointer[0];
   DstPointer++;
   SrcPointer++; 
  }
 DstPointer[0] = 0; 
 return ComputeCRC32(TextString, lstrlen(TextString));
}
//---------------------------------------------------------------------------
TTreeNode* _stdcall CreateNodeForPath(LPSTR Path, TTreeView *Tree, TTreeNode* CurNode)
{
 TTreeNode* NextNode;

 if(!Path || !Path[0])return CurNode;
 AnsiString CurName  = ExtractRootDir(ExtractFilePath(Path).c_str());
 AnsiString NextPath = ExtractFilePath(Path);
 NextPath = NextPath.Delete(1,CurName.Length()+1);
 if(CurName.IsEmpty())return NULL;
 if(Tree)
  {
   if(!(NextNode = GetSiblingNode(CurNode, CurName.c_str()))){SetSpeechNodeID(NextNode = Tree->Items->Add(CurNode, CurName.c_str()));Tree=NULL;} // From this poina - all nodes are new
     else {if(!NextPath.IsEmpty())NextNode = NextNode->getFirstChild();}
  }
   else
    {
     if(!(NextNode = GetChildNode(CurNode, CurName.c_str())))SetSpeechNodeID(NextNode = CurNode->Owner->AddChild(CurNode, CurName.c_str()));
    }
 if(!NextNode){Tree = NULL;NextNode=CurNode;}
 return CreateNodeForPath(NextPath.c_str(), Tree, NextNode);
}
//---------------------------------------------------------------------------
AnsiString _stdcall GetPathForNode(TTreeNode *FolderNode)
{
 AnsiString NPath;
 AnsiString temps;

 do
  {
   temps = FolderNode->Text;
   if(!temps.IsPathDelimiter(temps.Length()))temps = temps+"\\";
   NPath.Insert(temps, 0);
   FolderNode = FolderNode->Parent;
  }
   while(FolderNode);
 return NPath;
}
//---------------------------------------------------------------------------
AnsiString _stdcall ExtractActorValue(LPSTR TypeString, BYTE Value)
{
 int Counter=0;
 while(TypeString[0]&&((TypeString[0]!=Value)||(TypeString[1]!=':')))TypeString++;
 if(!TypeString[0])return "";
 TypeString += 2;
 AnsiString temps = TypeString;
 while(TypeString[Counter]&&((TypeString[Counter]!=',')||(TypeString[Counter+1]!=0x20)))Counter++;    // AINFODELIM
 temps = temps.SetLength(Counter);
 return temps;
}
//---------------------------------------------------------------------------
TWinControl* _stdcall FindControlUnderMouse(TComponent *Component)
{
 RECT  CRect;
 POINT MPoint;

 GetCursorPos(&MPoint);
 for(int ctr=0;ctr < Component->ComponentCount;ctr++)
  {
   TComponent* Comp = Component->Components[ctr];
   if(!Comp->InheritsFrom(__classid(TWinControl)))continue;
   TWinControl* Control = (TWinControl*)Comp;
   GetWindowRect(Control->Handle,&CRect);
   if(::PtInRect(&CRect,MPoint))
	{
	 if(!Control->HelpKeyword.IsEmpty())return Control;
	}
  }
 return NULL;
}
//---------------------------------------------------------------------------


