//---------------------------------------------------------------------------

#ifndef HelperFuncsH
#define HelperFuncsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "MiscFuncs.h"
#include "ResourcePE.h"

//---------------------------------------------------------------------------
#define LOGLINEDEL    "--------------------------------------------------------------"
#define DUMMYNODE     "::: DUMMY :::"
#define AINFODELIM    ", "
#define CFGFILENAME   "SpeechTool.ini"
#define CFGSECBASE    "BASE"
#define CFGSECFILE    "FILE"
#define SPEECHFEXT    ".mp3"           // !!!!!!!!!!!!
#define SPEECHFMASK   "????????.???"   // Ogg or MP3
#define SDIR_PREFIX   "__"             // For Race detection
#define SDIR_NPC      "__NPC__"
#define SDIR_CREATURE "__CREATURE__"
#define SDIR_MALE     "__MALE__"
#define SDIR_FEMALE   "__FEMALE__"

// 'WEAPNPC_CREALEVCSPELENCHALCHLEVI'
// 'ACTIAPPAARMOBODYBOOKCLOTCONTDOORINGRLIGHLOCKMISCPROBREPASTAT'

//---------------------------------------------------------------------------
const DWORD TypeTableOff    = 0x002CEF38;
const DWORD PObjTableOff    = 0x002CE8F0;
const LPSTR CreatureTypes[] = {"Creature","Deadra","Undead","Humanoid"};
const LPSTR BaseRaces[]     = {"Dark Elf","High Elf","Wood Elf","Redguard","Imperial","Argonian","Khajiit","Breton","Nord","Orc"};
const LPSTR DlgReplacers[]  = {"Name","Race","Class","Faction","Rank","Cell","PCName","PCRace","PCClass","PCRank","NextPCRank","PCCrimeLevel","ActionForward","ActionBack","ActionSlideLeft","ActionSlideRight","ActionUse","ActionActivate","ActionReadyItem","ActionReadyMagic","ActionCrouch","ActionRun","ActionToggleRun","ActionAutoRun","ActionJump","ActionNextWeapon","ActionPrevWeapon","ActionNextSpell","ActionPrevSpell","ActionTogglePOV","ActionMenuMode","ActionJournal","ActionRestMenu"};
enum  MWObjects {otACTI=_REVERSE('ACTI'),otAPPA=_REVERSE('APPA'),otARMO=_REVERSE('ARMO'),otBODY=_REVERSE('BODY'),otBOOK=_REVERSE('BOOK'),otCLOT=_REVERSE('CLOT'),otCONT=_REVERSE('CONT'),otDOOR=_REVERSE('DOOR'),otINGR=_REVERSE('INGR'),otLIGH=_REVERSE('LIGH'),otLOCK=_REVERSE('LOCK'),otMISC=_REVERSE('MISC'),otPROB=_REVERSE('PROB'),otREPA=_REVERSE('REPA'),otSTAT=_REVERSE('STAT'),otWEAP=_REVERSE('WEAP'),otNPC_=_REVERSE('NPC_'),otCREA=_REVERSE('CREA'),otLEVC=_REVERSE('LEVC'),otSPEL=_REVERSE('SPEL'),otENCH=_REVERSE('ENCH'),otALCH=_REVERSE('ALCH'),otLEVI=_REVERSE('LEVI')};
enum  MWRecords {otMACR=_REVERSE('MACR'),otMACH=_REVERSE('MACH'),otMACP=_REVERSE('MACP'),otREFR=_REVERSE('REFR'),otRACE=_REVERSE('RACE'),otCLAS=_REVERSE('CLAS'),otFACT=_REVERSE('FACT')};
enum  CSObjTypeTableIndex {liACTI,liAPPA,liARMO,liBODY,liBOOK,liCLOT,liCONT,liDOOR,liINGR,liLIGH,liLOCK,liMISC,liPROB,liREPA,liSTAT,liWEAP,liNPC_,liCREA,liLEVC,liSPEL,liENCH,liALCH,liLEVI};
enum  CreatureTypeIDs {ctCreature,ctDeadra,ctUndead,ctHumanoid};
//---------------------------------------------------------------------------
class CObjItem     // Size = 0x0C
{
public:
/*0000*/ CObjItem *Prev;
/*0004*/ CObjItem *Next;
/*0008*/ PVOID    Object;
};
//-------------------------------------
class CObjList  // Size = 0x14,  "lvo collection List", 00490150 CObjList_Constr,  0490180 CObjList_VDestr, 004901B0 CObjList_Destr, 00673598 CObjList_VFT
{
public:
/*0000*/ PVOID    (*pVFTable)[1];  // VDestructor
/*0004*/ DWORD    ObjCount;
/*0008*/ CObjItem *FirstObject;
/*000C*/ CObjItem *LastObject;
/*0010*/ CObjItem *Unkn00;
};
//-------------------------------------
class CObjType    // Size=0x10
{
public:
/*0000*/ DWORD    Type;
/*0004*/ DWORD    Unkn00;
/*0008*/ DWORD    Unkn01;
/*000C*/ CObjList *Objects;
};
//---------------------------------------------------------------------------
class CObjTable    // Size = 0x48  ???
{
public:
/*0000*/ DWORD Unk00;
/*0004*/ DWORD Unk01;
/*0008*/ PVOID ObjListCONT;
/*000C*/ PVOID ObjListSPEL;
/*0010*/ PVOID ObjListSTAT;
/*0014*/ PVOID ObjListGMST;
/*0018*/ CObjList* ObjListRACE;
/*001C*/ CObjList* ObjListLTEX;
/*0020*/ CObjList* ObjListCLAS;
/*0024*/ CObjList* ObjListFACT;
/*0028*/ CObjList* ObjListSCPT;
/*002C*/ CObjList* ObjListSOUN;
/*0030*/ CObjList* ObjListSNDG;
/*0034*/ CObjList* ObjListGLOB;
/*0038*/ CObjList* ObjListDIAL;
/*003C*/ CObjList* ObjListREGN;
/*0040*/ CObjList* ObjListBSGN;
/*0044*/ CObjList* ObjEndEmpty;     // For list end detection ?
};
//---------------------------------------------------------------------------
enum MP3_BitRates
{
  MP3BITRATE_FALSE = -1,
  MP3BITRATE_NONE  = 0,
  MP3BITRATE_8K    = 8000,
  MP3BITRATE_16K   = 16000,
  MP3BITRATE_24K   = 24000,
  MP3BITRATE_32K   = 32000,
  MP3BITRATE_40K   = 40000,
  MP3BITRATE_48K   = 48000,
  MP3BITRATE_56K   = 56000,
  MP3BITRATE_64K   = 64000,
  MP3BITRATE_80K   = 80000,
  MP3BITRATE_96K   = 96000,
  MP3BITRATE_112K  = 112000,
  MP3BITRATE_128K  = 128000,
  MP3BITRATE_144K  = 144000,
  MP3BITRATE_160K  = 160000,
  MP3BITRATE_176K  = 176000,
  MP3BITRATE_192K  = 192000,
  MP3BITRATE_224K  = 224000,
  MP3BITRATE_256K  = 256000,
  MP3BITRATE_288K  = 288000,
  MP3BITRATE_320K  = 320000,
  MP3BITRATE_352K  = 352000,
  MP3BITRATE_384K  = 384000,
  MP3BITRATE_416K  = 416000,
  MP3BITRATE_448K  = 448000
};
//---------------------------------------------------------------------------
enum Mp3_Frequencies
{
  MP3FREQUENCIES_FALSE    = -1,
  MP3FREQUENCIES_Reserved = 0,
  MP3FREQUENCIES_8000HZ   = 8000,
  MP3FREQUENCIES_11025HZ  = 11025,
  MP3FREQUENCIES_12000HZ  = 12000,
  MP3FREQUENCIES_16000HZ  = 16000,
  MP3FREQUENCIES_22050HZ  = 22050,
  MP3FREQUENCIES_24000HZ  = 24000,
  MP3FREQUENCIES_32000HZ  = 32000,
  MP3FREQUENCIES_48000HZ  = 48000,
  MP3FREQUENCIES_44100HZ  = 44100,
};
//---------------------------------------------------------------------------
enum Mpeg_Layers
{
  MPEGLAYER_FALSE = -1,
  MPEGLAYER_UNDEFINED,
  MPEGLAYER_III,
  MPEGLAYER_II,
  MPEGLAYER_I
};
enum Mpeg_Version
{
  MPEGVERSION_FALSE = -1,
  MPEGVERSION_2_5,
  MPEGVERSION_Reserved,
  MPEGVERSION_2,
  MPEGVERSION_1
};
enum Mp3_ChannelMode
{
  MP3CHANNELMODE_FALSE = -1,
  MP3CHANNELMODE_STEREO,
  MP3CHANNELMODE_JOINT_STEREO,
  MP3CHANNELMODE_DUAL_CHANNEL,
  MP3CHANNELMODE_SINGLE_CHANNEL
};
enum Mp3_ModeExt
{
  MP3MODEEXT_FALSE = -1,
  MP3MODEEXT_0,
  MP3MODEEXT_1,
  MP3MODEEXT_2,
  MP3MODEEXT_3
};
//---------------------------------------------------------------------------
// Ordered from top-down = low-high for each byte
struct MP3_Header //http://www.mp3-tech.org/programmer/frame_header.html
{
//byte 1
 BYTE frame_sync_a   : 8; // All bits should be set
//byte 2
 BYTE protection_bit : 1;
 BYTE layer          : 2;
 BYTE id             : 2;
 BYTE frame_sync_b   : 3; // All bits should be set
//byte 3
 BYTE private_bit    : 1;
 BYTE padding_bit    : 1;
 BYTE frequency      : 2;
 BYTE bitrate_index  : 4;
//byte 4
 BYTE emphasis       : 2;
 BYTE original       : 1;
 BYTE copyright      : 1;
 BYTE mode_ext       : 2; // Only used in joint stereo
 BYTE mode           : 2;
};
//---------------------------------------------------------------------------
int          _stdcall UpdateActorsList(TStrings *List, CObjItem *StartItem, DWORD CSProcessID);
int          _stdcall LoadActorsList(TStrings *List, DWORD CSProcessID);
int          _stdcall LoadRacesList(TStrings *List, DWORD CSProcessID);
void         _stdcall NormalizeTextString(LPSTR DstTextStr, LPSTR SrcTextStr);
void         _stdcall LoadSpeechTree(LPSTR Path, TTreeView *Tree, TTreeNode* CurNode);
void         _stdcall SetSpeechNodeID(TTreeNode* SpeechNode);
DWORD        _stdcall MakeRawTextAndCRC(LPSTR TextString);
TTreeNode*   _stdcall CreateNodeForPath(LPSTR Path, TTreeView *Tree, TTreeNode* CurNode);
AnsiString   _stdcall GetPathForNode(TTreeNode *FolderNode);
AnsiString   _stdcall ExtractActorValue(LPSTR TypeString, BYTE Value);
TWinControl* _stdcall FindControlUnderMouse(TComponent *Component);

//---------------------------------------------------------------------------
__inline void* operator new(size_t, void* p){return p;}
__inline template<class T> T* CONSTRUCT(T *Type){return new (Type)T();}  // Stupid c++ syntax don`t allow calling constructors :(

//---------------------------------------------------------------------------
__inline bool  ID3_IsValidSize(DWORD Size){return ((((PBYTE)&Size)[0] < 0x80)&&(((PBYTE)&Size)[1] < 0x80)&&(((PBYTE)&Size)[2] < 0x80)&&(((PBYTE)&Size)[3] < 0x80));}
__inline bool  ID3_IsValidSymbol(BYTE Symbol){return (((Symbol>=0x30)&&(Symbol<=0x39))||((Symbol>=0x41)&&(Symbol<=0x5A)));}
__inline DWORD ID3_PackSize(DWORD Size)
{
 BYTE PSizes[4];
 PSizes[3]=(Size&0x0000007F);PSizes[2]=((Size>>7)&0x0000007F);PSizes[1]=((Size>>14)&0x0000007F);PSizes[0]=((Size>>21)&0x0000007F);
 return *((DWORD*)&PSizes);
}
//---------------------------------------------------------------------------
__inline DWORD ID3_UnPackSize(DWORD Size)
{
 PBYTE Sizes = (PBYTE)&Size;
 return ((Sizes[3]|(Sizes[2]<<7))|(((Sizes[2]>>1)|(Sizes[1]<<6))<<8)|(((Sizes[1]>>2)|(Sizes[0]<<5))<<16)|((Sizes[0]>>3)<<24));
}
//---------------------------------------------------------------------------
#pragma pack( push, 1 )
struct MP3TagID3v10
{
 BYTE ID_T;
 BYTE ID_A;
 BYTE ID_G;
 BYTE Title[30];
 BYTE Artist[30];
 BYTE Album[30];
 BYTE Year[4];
 BYTE Comment[30];
 BYTE Genre;

        MP3TagID3v10(void){FillMemory(this,sizeof(MP3TagID3v10),0x20);ID_T='T';ID_A='A';ID_G='G';}
  bool  IsValidHeader(void){return ((ID_T=='T')&&(ID_A=='A')&&(ID_G=='G'));}
};
//---------------------------------------------------------------------------
struct MP3TagID3v11
{
 BYTE ID_T;
 BYTE ID_A;
 BYTE ID_G;
 BYTE Title[30];
 BYTE Artist[30];
 BYTE Album[30];
 BYTE Year[4];
 BYTE Comment[29];
 BYTE Track;
 BYTE Genre;

        MP3TagID3v11(void){FillMemory(this,sizeof(MP3TagID3v10),0x20);ID_T='T';ID_A='A';ID_G='G';}
  bool  IsValidHeader(void){return ((ID_T=='T')&&(ID_A=='A')&&(ID_G=='G'));}
};
//---------------------------------------------------------------------------
struct MP3FrameID3v2
{
 union{DWORD FrameID;BYTE FrameIDs[4];};
 union{DWORD Size;BYTE Sizes[4];};
 WORD  Flags;
 BYTE  Data[0];   // Following data

       MP3FrameID3v2(void){ZeroMemory(this,sizeof(MP3FrameID3v2));}

 bool  IsValidHeader(void){return (this&&!IsBadReadPtr(this,4)&&ID3_IsValidSymbol(FrameIDs[0])&&ID3_IsValidSymbol(FrameIDs[1])&&ID3_IsValidSymbol(FrameIDs[2])&&ID3_IsValidSymbol(FrameIDs[3])&&ID3_IsValidSize(Size));}
 bool  IsMatchID(LPSTR FrID){return ((FrameIDs[0]==FrID[0])&&(FrameIDs[1]==FrID[1])&&(FrameIDs[2]==FrID[2])&&(FrameIDs[3]==FrID[3]));}
 bool  IsMatchID(DWORD FrID){return ((FrameIDs[3]==((PBYTE)&FrID)[0])&&(FrameIDs[2]==((PBYTE)&FrID)[1])&&(FrameIDs[1]==((PBYTE)&FrID)[2])&&(FrameIDs[0]==((PBYTE)&FrID)[3]));}
 void  SetID(LPSTR FrID){FrameIDs[0]=FrID[0];FrameIDs[1]=FrID[1];FrameIDs[2]=FrID[2];FrameIDs[3]=FrID[3];}
 void  SetID(DWORD FrID){FrameIDs[3]=((PBYTE)&FrID)[0];FrameIDs[2]=((PBYTE)&FrID)[1];FrameIDs[1]=((PBYTE)&FrID)[2];FrameIDs[0]=((PBYTE)&FrID)[3];}
 void  SetSize(DWORD NewSize){Size = ID3_PackSize(NewSize);}
 DWORD GetSize(void){return ID3_UnPackSize(Size);}
 DWORD GetFullSize(void){return ID3_UnPackSize(Size)+sizeof(MP3FrameID3v2);}
 PVOID AddData(PVOID Block, DWORD Length){int len=GetSize();CopyMemory(&Data[len],Block,Length);SetSize(len+Length);return &Data[len];}

 MP3FrameID3v2* GetNext(void){return (IsValidHeader()&&((MP3FrameID3v2*)&Data[GetSize()])->IsValidHeader())?(((MP3FrameID3v2*)&Data[GetSize()])):(NULL);}
};
//---------------------------------------------------------------------------
struct MP3TagID3v2
{
 BYTE  ID_I;
 BYTE  ID_D;
 BYTE  ID_3;
 union{WORD Version;BYTE Versions[2];};
 BYTE  Flags;
 union{DWORD Size;BYTE Sizes[4];};
 BYTE  Data[0];  // Following data

       MP3TagID3v2(void){ZeroMemory(this,sizeof(MP3TagID3v2));ID_I='I';ID_D='D';ID_3='3';Version=3;}

 bool  IsValidHeader(void){return (this&&!IsBadReadPtr(this,4)&&(ID_I=='I')&&(ID_D=='D')&&(ID_3=='3')&&(Versions[0]!=0xFF)&&(Versions[1]!=0xFF)&&ID3_IsValidSize(Size));}
 void  SetSize(DWORD NewSize){Size = ID3_PackSize(NewSize);}
 DWORD GetSize(void){return ID3_UnPackSize(Size);}
 DWORD GetFullSize(void){return ID3_UnPackSize(Size)+sizeof(MP3TagID3v2);}
 MP3FrameID3v2* GetFirstFrame(void){return (((MP3FrameID3v2*)&Data)->IsValidHeader())?((MP3FrameID3v2*)&Data):(NULL);}
 MP3FrameID3v2* AddNewFrame(void){int len=GetSize();MP3FrameID3v2* Frame = CONSTRUCT((MP3FrameID3v2*)&Data[len]);SetSize(len+sizeof(MP3FrameID3v2));return Frame;}

//-------------------------------------
 template<class T> MP3FrameID3v2* FindFrame(T Type)
  {
   MP3FrameID3v2* Frame = GetFirstFrame();
   while(Frame->IsValidHeader())
    {
     if(Frame->IsMatchID(Type))return Frame;
     Frame = Frame->GetNext();
    }
   return NULL;
  }
//-------------------------------------
 template<class T> MP3FrameID3v2* AddTextFrame(T Type, LPSTR Text, BYTE Encoding)
  {
   if(!Text || !Text[0] || FindFrame(Type))return NULL;
   MP3FrameID3v2* Frame = AddNewFrame();
   Frame->SetID(Type);
   Frame->AddData(&Encoding, sizeof(BYTE));
   Frame->AddData(Text, lstrlen(Text)+1);  // Some players may want ZERO
   SetSize(GetSize()+Frame->GetSize());
   return Frame;
  }
//-------------------------------------
 template<class T> MP3FrameID3v2* AddTextFrame(T Type, LPSTR Text, LPSTR Description, LPSTR Language, BYTE Encoding)
  {
   if(!Text || !Text[0])return NULL;
   //MP3FrameID3v2* Frame = GetFirstFrame();
   //while(Frame){Frame = Frame->GetNext();} // TODO: Checkif frame exist
   MP3FrameID3v2* Frame = AddNewFrame();
   Frame->SetID(Type);
   Frame->AddData(&Encoding, sizeof(BYTE));
   if(Language&&Language[0])Frame->AddData(Language, 3);
     else Frame->AddData("eng", 3);
   if(Description&&Description[0])Frame->AddData(Description, lstrlen(Text)+1);
     else {BYTE dummy=0;Frame->AddData(&dummy, 1);}
   Frame->AddData(Text, lstrlen(Text)+1); // Windows media player wants a ZERO at end of text, byt it is NO standart demanded - just allowed
   SetSize(GetSize()+Frame->GetSize());
   return Frame;
  }
//-------------------------------------
};
#pragma pack( pop )
//---------------------------------------------------------------------------
class CRaceItem
{
private:
 CRaceItem *Prev;
 CRaceItem *Next;
 PVOID CSObjPtr;       // Address of object in CS memory space
 BYTE  RaceID[32];
 BYTE  RaceName[32];

 public:
 LPSTR GetRaceID(void){return (this)?((LPSTR)&this->RaceID):(NULL);}
 LPSTR GetRaceName(void){return (this)?((LPSTR)&this->RaceName):(NULL);}
 PVOID      GetCSAddress(void){return (this)?(this->CSObjPtr):(NULL);}
 CRaceItem* GetNext(void){return (this)?(this->Next):(NULL);}
 CRaceItem* GetPrev(void){return (this)?(this->Prev):(NULL);}

 CRaceItem(CRaceItem *Parent, PVOID ObjAddr, DWORD CSProcessID)
  {
   DWORD DataBuf[128];

   ZeroMemory(this, sizeof(CRaceItem));
   while(Parent && Parent->Next)Parent = Parent->Next; // Parent can be only last item in list
   if(Parent)Parent->Next = this;
   this->Prev     = Parent;
   this->CSObjPtr = ObjAddr;
   Toolhelp32ReadProcessMemory(CSProcessID,ObjAddr,&DataBuf,sizeof(DataBuf),NULL);
   if(DataBuf[1] != otRACE){Beep(100,100);return;}     // Must NEVER happen !
   lstrcpy((LPSTR)&this->RaceID,(LPSTR)&DataBuf[4]);
   lstrcpy((LPSTR)&this->RaceName,(LPSTR)&DataBuf[12]);
  }
//-------------------------------------
 ~CRaceItem(void)
  {
   if(this->Prev)this->Prev->Next = this->Next;
   if(this->Next)this->Next->Prev = this->Prev;
  }
};
//---------------------------------------------------------------------------
class CActorItem
{
private:
 CActorItem *Prev;
 CActorItem *Next;
 bool  Female;
 bool  Creature;
 PVOID CSObjPtr;         // Address of object in CS memory space
 BYTE  ObjectID[32];
 BYTE  ObjectName[32];
 BYTE  RaceID[32];       // TypeName for 'CREA'
 BYTE  RaceName[32];     // Only for 'NPC_'
 BYTE  ClassID[32];      // Only for 'NPC_'
 BYTE  ClassName[32];    // Only for 'NPC_'
 BYTE  FactionID[32];    // Only for 'NPC_'
 BYTE  FactionName[32];  // Only for 'NPC_'
 BYTE  FactionRank[32];  // Only for 'NPC_'
 BYTE  CellID[32];       // Only from CS dialogue window
 BYTE  CellName[32];     // ????

 public:
 bool  IsFemale(void){return (this && !this->Creature && this->Female);}
 bool  IsCreature(void){return (this && this->Creature);}
 LPSTR GetObjectID(void){return (this)?((LPSTR)&this->ObjectID):(NULL);}
 LPSTR GetObjectName(void){return (this)?((LPSTR)&this->ObjectName):(NULL);}
 LPSTR GetRaceID(void){return (this && !this->Creature)?((LPSTR)&this->RaceID):(NULL);}
 LPSTR GetRaceName(void){return (this && !this->Creature)?((LPSTR)&this->RaceName):(NULL);}
 LPSTR GetCreatureType(void){return (this && this->Creature)?((LPSTR)&this->RaceID):(NULL);}
 LPSTR GetClassID(void){return (this && !this->Creature)?((LPSTR)&this->ClassID):(NULL);}
 LPSTR GetClassName(void){return (this && !this->Creature)?((LPSTR)&this->ClassName):(NULL);}
 LPSTR GetFactionID(void){return (this && !this->Creature)?((LPSTR)&this->FactionID):(NULL);}
 LPSTR GetFactionName(void){return (this && !this->Creature)?((LPSTR)&this->FactionName):(NULL);}
 LPSTR GetFactionRank(void){return (this && !this->Creature)?((LPSTR)&this->FactionRank):(NULL);}
 LPSTR GetCellID(void){return (this && !this->Creature)?((LPSTR)&this->CellID):(NULL);}
 LPSTR GetCellName(void){return (this && !this->Creature)?((LPSTR)&this->CellName):(NULL);}

 void  SetFemale(bool State){if(this && !this->Creature)this->Female = State;}
 void  SetCreature(bool State){if(this)this->Creature = State;if(State)this->Female = false;}
 void  SetObjectID(LPSTR NewID){if(this)lstrcpy((LPSTR)&this->ObjectID, NewID);}
 void  SetObjectName(LPSTR NewName){if(this)lstrcpy((LPSTR)&this->ObjectName, NewName);}
 void  SetRaceID(LPSTR NewID){if(this)lstrcpy((LPSTR)&this->RaceID, NewID);}
 void  SetRaceName(LPSTR NewName){if(this)lstrcpy((LPSTR)&this->RaceName, NewName);}
 void  SetCreatureType(LPSTR NewType){if(this)lstrcpy((LPSTR)&this->RaceID, NewType);}
 void  SetClassID(LPSTR NewID){if(this)lstrcpy((LPSTR)&this->ClassID, NewID);}
 void  SetClassName(LPSTR NewName){if(this)lstrcpy((LPSTR)&this->ClassName, NewName);}
 void  SetFactionID(LPSTR NewID){if(this)lstrcpy((LPSTR)&this->FactionID, NewID);}
 void  SetFactionName(LPSTR NewName){if(this)lstrcpy((LPSTR)&this->FactionName, NewName);}
 void  SetFactionRank(LPSTR NewRank){if(this)lstrcpy((LPSTR)&this->FactionRank, NewRank);}
 void  SetCellID(LPSTR NewID){if(this)lstrcpy((LPSTR)&this->CellID, NewID);}
 void  SetCellName(LPSTR NewName){if(this)lstrcpy((LPSTR)&this->CellName, NewName);}

 PVOID       GetCSAddress(void){return (this)?(this->CSObjPtr):(NULL);}
 CActorItem* GetNext(void){return (this)?(this->Next):(NULL);}
 CActorItem* GetPrev(void){return (this)?(this->Prev):(NULL);}

 CActorItem(void){ZeroMemory(this, sizeof(CActorItem));}
 CActorItem(CActorItem *Parent, PVOID ObjAddr, DWORD CSProcessID)
  {
   DWORD DataBuf[128];

   ZeroMemory(this, sizeof(CActorItem));
   while(Parent && Parent->Next)Parent = Parent->Next; // Parent can be only last item in list
   if(Parent)Parent->Next = this;
   this->Prev     = Parent;
   this->CSObjPtr = ObjAddr;
   Toolhelp32ReadProcessMemory(CSProcessID,ObjAddr,&DataBuf,sizeof(DataBuf),NULL);
   if((DataBuf[1] != otNPC_)&&(DataBuf[1] != otCREA)){Beep(100,100);return;}     // Must NEVER happen !

   Toolhelp32ReadProcessMemory(CSProcessID,(PVOID)DataBuf[17],&this->ObjectID,sizeof(this->ObjectID),NULL);
   Toolhelp32ReadProcessMemory(CSProcessID,(PVOID)DataBuf[34],&this->ObjectName,sizeof(this->ObjectName),NULL);

   this->Creature = (DataBuf[1] == otCREA);
   if(!this->Creature)
    {
     PVOID Race     = (PVOID)DataBuf[50];
     PVOID Class    = (PVOID)DataBuf[51];
     PVOID Faction  = (PVOID)DataBuf[52];
     BYTE  FactRank = DataBuf[0xC2];
     this->Female   = (DataBuf[19] & 1);

     // Read Race information
     if(Race){Toolhelp32ReadProcessMemory(CSProcessID,Race,&DataBuf,sizeof(DataBuf),NULL);
     if(DataBuf[1] != otRACE){Beep(100,100);return;}    // Must NEVER happen !
     lstrcpy((LPSTR)&this->RaceID,(LPSTR)&DataBuf[4]);
     lstrcpy((LPSTR)&this->RaceName,(LPSTR)&DataBuf[12]);}

     // Read Class information
     if(Class){Toolhelp32ReadProcessMemory(CSProcessID,Class,&DataBuf,sizeof(DataBuf),NULL);
     if(DataBuf[1] != otCLAS){Beep(100,100);return;}    // Must NEVER happen !
     lstrcpy((LPSTR)&this->ClassID,(LPSTR)&DataBuf[4]);
     lstrcpy((LPSTR)&this->ClassName,(LPSTR)&DataBuf[12]);}

     // Read Faction information  (MAY NOt PRESENT)
     if(Faction){Toolhelp32ReadProcessMemory(CSProcessID,Faction,&DataBuf,sizeof(DataBuf),NULL);
     if(DataBuf[1] != otFACT){Beep(100,100);return;}    // Must NEVER happen !
     lstrcpy((LPSTR)&this->FactionID,(LPSTR)&DataBuf[4]);
     lstrcpy((LPSTR)&this->FactionName,(LPSTR)&DataBuf[12]);
     lstrcpy((LPSTR)&this->FactionRank,(LPSTR)&DataBuf[20+(FactRank*8)]);}
    }
     else lstrcpy((LPSTR)&this->RaceID, CreatureTypes[DataBuf[37]]);
  }
//-------------------------------------
 ~CActorItem(void)
  {
   if(this->Prev)this->Prev->Next = this->Next;
   if(this->Next)this->Next->Prev = this->Prev;
  }
};
//---------------------------------------------------------------------------
class CSpeechFile
{
private:
 bool  FileIsOK;
 DWORD ABitRate;
 DWORD AChannels;
 DWORD AFrequency;
 DWORD TxtLangInd;
 DWORD FileFormat;
 DWORD DataOffset;
 DWORD DataLength;
 DWORD FileSize;
 PBYTE FileData;    // May Be NULL
 LPSTR FTitle;
 LPSTR FAlbum;
 LPSTR FArtist;
 LPSTR FLyrics;
 LPSTR FComments;
 LPSTR FCopyRight;
 BYTE  Year[8];
 BYTE  FullPath[MAX_PATH];

 bool  CheckFileMP3(void){return (((MP3TagID3v2*)FileData)->IsValidHeader()||((MP3TagID3v11*)&FileData[FileSize-sizeof(MP3TagID3v11)])->IsValidHeader());}  // One of TAGs MUST exist
 bool  CheckFileOGG(void){return false;}

public:
  LPSTR  GetFileTitle(void){return (this && IsFileValid())?(FTitle):(NULL);}
  LPSTR  GetFileAlbum(void){return (this && IsFileValid())?(FAlbum):(NULL);}
  LPSTR  GetFileArtist(void){return (this && IsFileValid())?(FArtist):(NULL);}
  LPSTR  GetFileLyrics(void){return (this && IsFileValid())?(FLyrics):(NULL);}
  LPSTR  GetFileComments(void){return (this && IsFileValid())?(FComments):(NULL);}
  LPSTR  GetFileCopyRight(void){return (this && IsFileValid())?(FCopyRight):(NULL);}
  LPSTR  GetFileYear(void){return (this && IsFileValid())?((LPSTR)&Year):(NULL);}
  LPSTR  GetFileExt(void){return (this && FullPath[0])?((LPSTR)&FullPath[CharPosFromRight((LPSTR)&FullPath,'.',0,0)]):(NULL);}
  LPSTR  GetFilePath(void){return (this && FullPath[0])?((LPSTR)&FullPath):(NULL);}
  bool   IsFileValid(void){return (this && FileFormat && FileIsOK && AChannels && ABitRate && AFrequency);}
  bool   IsFileFormatMP3(void){return (this && IsFileValid() && (FileFormat==1));}
  bool   IsFileFormatOGG(void){return (this && IsFileValid() && (FileFormat==2));}
  void   SetTextLngIndex(DWORD Index){if(this)TxtLangInd = Index;}
//-------------------------------------
  bool   GetFileInfo(DWORD *BitRate, DWORD *Frequency, DWORD *Channels)
   {
    if(BitRate)(*BitRate)=ABitRate;
    if(Channels)(*Channels)=AChannels;
    if(Frequency)(*Frequency)=AFrequency;
    return IsFileValid();
   }
//-------------------------------------
  void   ChangeInformation(LPSTR Title, LPSTR Album, LPSTR Artist, LPSTR Lyrics, LPSTR Comments, LPSTR CopyRight)
   {
    HANDLE hDefHeap = GetProcessHeap();
    if(Title)
     {
      if(FTitle)FTitle = (LPSTR)HeapReAlloc(hDefHeap,HEAP_ZERO_MEMORY,FTitle,(lstrlen(Title)+8));
        else FTitle = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,(lstrlen(Title)+8));
      lstrcpy(FTitle, Title);
     }
    if(Album)
     {
      if(FAlbum)FAlbum = (LPSTR)HeapReAlloc(hDefHeap,HEAP_ZERO_MEMORY,FAlbum,(lstrlen(Album)+8));
        else FAlbum = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,(lstrlen(Album)+8));
      lstrcpy(FAlbum, Album);
     }
    if(Artist)
     {
      if(FArtist)FArtist = (LPSTR)HeapReAlloc(hDefHeap,HEAP_ZERO_MEMORY,FArtist,(lstrlen(Artist)+8));
        else FArtist = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,(lstrlen(Artist)+8));
      lstrcpy(FArtist, Artist);
     }
    if(Lyrics)
     {
      if(FLyrics)FLyrics = (LPSTR)HeapReAlloc(hDefHeap,HEAP_ZERO_MEMORY,FLyrics,(lstrlen(Lyrics)+8));
        else FLyrics = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,(lstrlen(Lyrics)+8));
      lstrcpy(FLyrics, Lyrics);
     }
    if(Comments)
     {
      if(FComments)FComments = (LPSTR)HeapReAlloc(hDefHeap,HEAP_ZERO_MEMORY,FComments,(lstrlen(Comments)+8));
        else FComments = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,(lstrlen(Comments)+8));
      lstrcpy(FComments, Comments);
     }
    if(CopyRight)
     {
      if(FCopyRight)FCopyRight = (LPSTR)HeapReAlloc(hDefHeap,HEAP_ZERO_MEMORY,FCopyRight,(lstrlen(CopyRight)+8));
        else FCopyRight = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,(lstrlen(CopyRight)+8));
      lstrcpy(FCopyRight, CopyRight);
     }
   }
//-------------------------------------
  DWORD LoadInfoMP3(void)
   {
    bool          OldHdr;
    bool          NewHdr;
    DWORD         HeadersLen = 0;
    HANDLE        hDefHeap   = GetProcessHeap();
    MP3TagID3v2   *MP3Tag2;
    MP3TagID3v11  *MP3Tag1;
    MP3FrameID3v2 *Frame;

    MP3Tag2 = (MP3TagID3v2*)FileData;
    MP3Tag1 = (MP3TagID3v11*)&FileData[FileSize-sizeof(MP3TagID3v11)];

    OldHdr  = MP3Tag1->IsValidHeader();
    NewHdr  = MP3Tag2->IsValidHeader();

    while(!FileData[HeadersLen])HeadersLen++;  // Some soft leaves only an empty padding on beginning of the file
    DataOffset = HeadersLen;
    if(NewHdr)
     {
      HeadersLen += MP3Tag2->GetFullSize();
      DataOffset += HeadersLen;   // Offset of audio data

      Frame = MP3Tag2->FindFrame('TYER');  // BYTE Enc, BYTE Text[] - Year: 2009 - just for information
      if(Frame)CopyMemory(&Year,&Frame->Data[1],4);

      Frame = MP3Tag2->FindFrame('TIT2');  // BYTE Enc, BYTE Text[] - Title:  NPC \ Nord \ MALE \ fargot  - used by editor
      if(Frame){int dsize=Frame->GetSize();FTitle = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,dsize);CopyMemory(FTitle,&Frame->Data[1],dsize-1);}

      Frame = MP3Tag2->FindFrame('TPE1');  // BYTE Enc, BYTE Text[] - Artist: Fargot, Nord  - just for information
      if(Frame){int dsize=Frame->GetSize();FArtist = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,dsize);CopyMemory(FArtist,&Frame->Data[1],dsize-1);}

      Frame = MP3Tag2->FindFrame('TALB');  // BYTE Enc, BYTE Text[] - 'TES 3: Morrowind' Speech file. Prepared by X - just for information
      if(Frame){int dsize=Frame->GetSize();FAlbum = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,dsize);CopyMemory(FAlbum,&Frame->Data[1],dsize-1);}

      Frame = MP3Tag2->FindFrame('TCOP');  // BYTE Enc, BYTE Text[] - Copyright: - just for information
      if(Frame){int dsize=Frame->GetSize();FCopyRight = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,dsize);CopyMemory(FCopyRight,&Frame->Data[1],dsize-1);}

      Frame = MP3Tag2->FindFrame('USLT');  // BYTE Enc, BYTE Text[] - Lyrics     - used by editor for information
      if(Frame){int dsize=Frame->GetSize();int elen=lstrlen((LPSTR)&Frame->Data[4])+1;FLyrics = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,(dsize-elen));CopyMemory(FLyrics,&Frame->Data[4+elen],(dsize-elen-4));}

      Frame = MP3Tag2->FindFrame('COMM');  // BYTE Enc, BYTE Text[] - Comments   - just for information
      if(Frame){int dsize=Frame->GetSize();int elen=lstrlen((LPSTR)&Frame->Data[4])+1;FComments = (LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,(dsize-elen));CopyMemory(FComments,&Frame->Data[4+elen],(dsize-elen-4));}
     }

    if(OldHdr)
     {
      HeadersLen += sizeof(MP3TagID3v11);
      if(!Year[0])CopyMemory(&Year,&MP3Tag1->Year,4);
      if(!FTitle){FTitle=(LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,40);CopyMemory(FTitle,&MP3Tag1->Title,30);}
      if(!FArtist){FArtist=(LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,40);CopyMemory(FArtist,&MP3Tag1->Artist,30);}
      if(!FAlbum){FAlbum=(LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,40);CopyMemory(FAlbum,&MP3Tag1->Album,30);}
      if(!FComments){FComments=(LPSTR)HeapAlloc(hDefHeap,HEAP_ZERO_MEMORY,40);CopyMemory(FComments,&MP3Tag1->Title,29);}
     }
    while(!FileData[DataOffset])DataOffset++;   // If header size not contains a padding (First byte of MP3 file is always 0xFF)
    GetAudioInfoMP3(&FileData[DataOffset]);
    return HeadersLen;
   }
//-------------------------------------
  DWORD LoadInfoOGG(void)
   {
    return 1;
   }
//-------------------------------------
  DWORD SaveFileMP3(LPSTR DstPath)
   {
    BYTE   Lang[4] = {'e','n','g',0};
    DWORD  Result;
    HANDLE hSpeechFile;

    int          YearLen     = lstrlen((LPSTR)&Year);
    int          TitleLen    = lstrlen(FTitle);
    int          AlbumLen    = lstrlen(FAlbum);
    int          ArtistLen   = lstrlen(FArtist);
    int          LyricsLen   = lstrlen(FLyrics);
    int          CommentsLen = lstrlen(FComments);
    DWORD        HeaderSize  = (YearLen+TitleLen+AlbumLen+ArtistLen+LyricsLen+CommentsLen+(sizeof(MP3FrameID3v2)*8))*2;
    MP3TagID3v2* HeaderNew   = CONSTRUCT((MP3TagID3v2*)VirtualAlloc(NULL,HeaderSize,MEM_COMMIT,PAGE_EXECUTE_READWRITE));
    MP3TagID3v11 HeaderOld;

    if(TxtLangInd == 0x19){Lang[0]='r';Lang[1]='u';Lang[2]='s';}

    // Create new header
    HeaderNew->AddTextFrame('TYER',(LPSTR)&Year,0);
    HeaderNew->AddTextFrame('TIT2',FTitle,0);
    HeaderNew->AddTextFrame('TPE1',FArtist,0);
    HeaderNew->AddTextFrame('TALB',FAlbum,0);
    HeaderNew->AddTextFrame('USLT',FLyrics,NULL,(LPSTR)&Lang,0);
    HeaderNew->AddTextFrame('COMM',FComments,NULL,(LPSTR)&Lang,0);
    if(FCopyRight && FCopyRight[0])HeaderNew->AddTextFrame('TCOP',((AnsiString)(LPSTR)&Year+" "+FCopyRight).c_str(),0);

    HeaderSize = HeaderNew->GetFullSize();
    HeaderSize = ((HeaderSize/256)+((bool)(HeaderSize%256)))*256; // Padding is alignment to 256 bytes
    HeaderNew->SetSize(HeaderSize-sizeof(MP3TagID3v2));   // Demanded by standart, but can cause some problems (Most players can work without this)

    // Fill old header
    HeaderOld.Track = 0;
    HeaderOld.Genre = 12;   // Other
    CopyMemory(&HeaderOld.Year, &Year, _MINIMAL(sizeof(HeaderOld.Year), YearLen));
    if(FTitle    && FTitle[0])   CopyMemory(&HeaderOld.Title,   FTitle,    _MINIMAL(sizeof(HeaderOld.Title),   TitleLen));
    if(FArtist   && FArtist[0])  CopyMemory(&HeaderOld.Artist,  FArtist,   _MINIMAL(sizeof(HeaderOld.Artist),  ArtistLen));
    if(FAlbum    && FAlbum[0])   CopyMemory(&HeaderOld.Album,   FAlbum,    _MINIMAL(sizeof(HeaderOld.Album),   AlbumLen));
    if(FComments && FComments[0])CopyMemory(&HeaderOld.Comment, FComments, _MINIMAL(sizeof(HeaderOld.Comment), CommentsLen));

    Result = 4;
    SetFileAttributes(DstPath,FILE_ATTRIBUTE_NORMAL);
    DeleteFile(DstPath);
    if((hSpeechFile = CreateFile(DstPath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,NULL))!=INVALID_HANDLE_VALUE)
     {
      Result--;
      Result -= (bool)WriteFile(hSpeechFile,HeaderNew,HeaderSize,&HeaderSize,NULL);
      Result -= (bool)WriteFile(hSpeechFile,FileData,DataLength,&HeaderSize,NULL);
      Result -= (bool)WriteFile(hSpeechFile,&HeaderOld,sizeof(MP3TagID3v11),&HeaderSize,NULL);
      CloseHandle(hSpeechFile);
     }
    VirtualFree(HeaderNew,0,MEM_RELEASE);
    return Result;
   }
//-------------------------------------
  DWORD SaveFileOGG(LPSTR DstPath)
   {
    return 1;
   }
//-------------------------------------
  DWORD SaveFile(LPSTR DstPath)
   {
    DWORD      Result;
    HANDLE     hDefHeap;
    HANDLE     hSpeechFile;
    SYSTEMTIME stime;

    if(!FileFormat)return 1;
    if((hSpeechFile = CreateFile((LPSTR)&this->FullPath,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL))==INVALID_HANDLE_VALUE)return 2;
    hDefHeap = GetProcessHeap();
    FileData = (PBYTE)VirtualAlloc(NULL,DataLength,MEM_COMMIT,PAGE_EXECUTE_READWRITE);
    SetFilePointer(hSpeechFile,DataOffset,NULL,FILE_BEGIN);
    ReadFile(hSpeechFile,FileData,DataLength,&Result,NULL);
    CloseHandle(hSpeechFile);
    if(Result == DataLength)
     {
      Result = 3;
      GetLocalTime(&stime);
      lstrcpy((LPSTR)&Year,IntToStr(stime.wYear).c_str());
      if(FileFormat == 1)Result = SaveFileMP3(DstPath);
      if(FileFormat == 2)Result = SaveFileOGG(DstPath);
     }
      else Result = 2;
    VirtualFree(FileData,0,MEM_RELEASE);
    return Result;
   }
//-------------------------------------
  void GetAudioInfoMP3(PVOID AudioData)
   {
    MP3_Header *Header    = (MP3_Header*)AudioData;;
    int        FreqIndex  = 0;
    int        BRateIndex = 0;

    DWORD MP3_Freqs[4][4] =
     {
      {MP3FREQUENCIES_11025HZ, MP3FREQUENCIES_12000HZ, MP3FREQUENCIES_8000HZ,MP3FREQUENCIES_Reserved },      // MPEGVERSION_2_5
      {MP3FREQUENCIES_Reserved, MP3FREQUENCIES_Reserved, MP3FREQUENCIES_Reserved, MP3FREQUENCIES_Reserved},  // MPEGVERSION_Reserved
      {MP3FREQUENCIES_22050HZ, MP3FREQUENCIES_24000HZ, MP3FREQUENCIES_16000HZ, MP3FREQUENCIES_Reserved },    // MPEGVERSION_2
      {MP3FREQUENCIES_44100HZ, MP3FREQUENCIES_48000HZ, MP3FREQUENCIES_32000HZ, MP3FREQUENCIES_Reserved }     // MPEGVERSION_1
     };
    DWORD MP3_BRate[2][3][16] =
     {{
       {MP3BITRATE_NONE,MP3BITRATE_32K,MP3BITRATE_64K,MP3BITRATE_96K,MP3BITRATE_128K,MP3BITRATE_160K,MP3BITRATE_192K,MP3BITRATE_224K,MP3BITRATE_256K,MP3BITRATE_288K,MP3BITRATE_320K,MP3BITRATE_352K,MP3BITRATE_384K,MP3BITRATE_416K,MP3BITRATE_448K,MP3BITRATE_FALSE}, // MPEG 1, LAYER I
       {MP3BITRATE_NONE,MP3BITRATE_32K,MP3BITRATE_48K,MP3BITRATE_56K,MP3BITRATE_64K,MP3BITRATE_80K,MP3BITRATE_96K,MP3BITRATE_112K,MP3BITRATE_128K,MP3BITRATE_160K,MP3BITRATE_192K,MP3BITRATE_224K,MP3BITRATE_256K,MP3BITRATE_320K,MP3BITRATE_384K,MP3BITRATE_FALSE},    // MPEG 1, LAYER II
       {MP3BITRATE_NONE,MP3BITRATE_32K,MP3BITRATE_40K,MP3BITRATE_48K,MP3BITRATE_56K,MP3BITRATE_64K,MP3BITRATE_80K,MP3BITRATE_96K,MP3BITRATE_112K,MP3BITRATE_128K,MP3BITRATE_160K,MP3BITRATE_192K,MP3BITRATE_224K,MP3BITRATE_256K,MP3BITRATE_320K,MP3BITRATE_FALSE}      // MPEG 1, LAYER III
      },{
       {MP3BITRATE_NONE,MP3BITRATE_32K,MP3BITRATE_48K,MP3BITRATE_56K,MP3BITRATE_64K,MP3BITRATE_80K,MP3BITRATE_96K,MP3BITRATE_112K,MP3BITRATE_128K,MP3BITRATE_144K,MP3BITRATE_160K,MP3BITRATE_176K,MP3BITRATE_192K,MP3BITRATE_224K,MP3BITRATE_256K,MP3BITRATE_FALSE},    // MPEG 2 or 2.5, LAYER I
       {MP3BITRATE_NONE,MP3BITRATE_8K,MP3BITRATE_16K,MP3BITRATE_24K,MP3BITRATE_32K,MP3BITRATE_40K,MP3BITRATE_48K,MP3BITRATE_56K,MP3BITRATE_64K,MP3BITRATE_80K,MP3BITRATE_96K,MP3BITRATE_112K,MP3BITRATE_128K,MP3BITRATE_144K,MP3BITRATE_160K,MP3BITRATE_FALSE},         // MPEG 2 or 2.5, LAYER II
       {MP3BITRATE_NONE,MP3BITRATE_8K,MP3BITRATE_16K,MP3BITRATE_24K,MP3BITRATE_32K,MP3BITRATE_40K,MP3BITRATE_48K,MP3BITRATE_56K,MP3BITRATE_64K,MP3BITRATE_80K,MP3BITRATE_96K,MP3BITRATE_112K,MP3BITRATE_128K,MP3BITRATE_144K,MP3BITRATE_160K,MP3BITRATE_FALSE}          // MPEG 2 or 2.5, LAYER III
     }};

    FileIsOK = false;
    switch (Header->layer)
     {
      case 3:    // MPEGLAYER_I
      case 2:    // MPEGLAYER_II
      case 1:    // MPEGLAYER_III
        break;
      default: return;   // Something wrong !
     }
    switch (Header->id)
     {
      case 3:    // MPEGVERSION_1
        BRateIndex = 0;
        break;
      case 2:    // MPEGVERSION_2
        BRateIndex = 1;
        break;
      case 0:    // MPEGVERSION_2_5
        BRateIndex = 1;
        break;
      default: return;   // Something wrong !
     }
    switch (Header->mode)
     {
      case 3:     // MP3CHANNELMODE_SINGLE_CHANNEL
        AChannels = 1;
        break;
      case 2:     // MP3CHANNELMODE_DUAL_CHANNEL
      case 1:     // MP3CHANNELMODE_JOINT_STEREO
      case 0:     // MP3CHANNELMODE_STEREO
        AChannels = 2;
        break;
      default: return;   // Something wrong !
     }

    if((BRateIndex = MP3_BRate[BRateIndex][3-Header->layer][Header->bitrate_index])==MP3BITRATE_FALSE)return;
    if((FreqIndex  = MP3_Freqs[Header->id][Header->frequency])==MP3FREQUENCIES_Reserved)return;
    ABitRate   = BRateIndex;
    AFrequency = FreqIndex;
    FileIsOK   = true;  
   }
//-------------------------------------
  void GetAudioInfoOGG(void)
   {
    FileIsOK = false;
   }
//-------------------------------------
  CSpeechFile(LPSTR FilePath)
   {
    DWORD  Result;
    HANDLE hDefHeap;
    HANDLE hSpeechFile;

    ZeroMemory(this,sizeof(CSpeechFile));
    if((hSpeechFile = CreateFile(FilePath,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL))==INVALID_HANDLE_VALUE)return;
    hDefHeap = GetProcessHeap();
    FileSize = GetFileSize(hSpeechFile, NULL);
    FileData = (PBYTE)VirtualAlloc(NULL,FileSize,MEM_COMMIT,PAGE_EXECUTE_READWRITE);
    ReadFile(hSpeechFile,FileData,FileSize,&Result,NULL);
    if(Result == FileSize)
     {
      lstrcpy((LPSTR)&FullPath,FilePath);
      if(this->CheckFileMP3()){FileFormat = 1;DataLength = (FileSize - this->LoadInfoMP3());}
        else {if(this->CheckFileOGG()){FileFormat = 2;DataLength = (FileSize - this->LoadInfoOGG());}}
     }
    CloseHandle(hSpeechFile);
    VirtualFree(FileData,0,MEM_RELEASE);   // Do not keep file in memory
    FileData = NULL;
   }
//-------------------------------------
  ~CSpeechFile(void)
   {
    HANDLE hDefHeap = GetProcessHeap();
    if(FTitle)HeapFree(hDefHeap,0,FTitle);
    if(FAlbum)HeapFree(hDefHeap,0,FAlbum);
    if(FArtist)HeapFree(hDefHeap,0,FArtist);
    if(FLyrics)HeapFree(hDefHeap,0,FLyrics);
    if(FComments)HeapFree(hDefHeap,0,FComments);
    if(FCopyRight)HeapFree(hDefHeap,0,FCopyRight);
    if(FileData)VirtualFree(FileData,0,MEM_RELEASE);
   }
};
//---------------------------------------------------------------------------
#endif
