//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fMainForm.h"
#include "fHelpForm.h"
#include "fSettingsForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfmMainForm *fmMainForm;
//===========================================================================
//                      ADDITIONAL MAIN FORM FUNCTIONS
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::twActorsSpeechWndProc(TMessage &Message)
{
 TWndMethod  method;
 if(Message.Msg == WM_RBUTTONDOWN)Splitter3->Tag = 1; // No tree node changing when popup menu called

 ((DWORD*)(&(method)))[0] = (DWORD)Panel1->Tag;
 ((DWORD*)(&(method)))[1] = (DWORD)twActorsSpeech;
 method(Message);
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::LogMessage(AnsiString Message)
{
 fmSettings->meMessages->Lines->Add(Message);
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::LoadConfiguration(void)
{
 DelConfirm     = Config->ReadBool(CFGSECBASE,"DelConfirm",DelConfirm);
 DelToRecycle   = Config->ReadBool(CFGSECBASE,"DelToRecycle",DelToRecycle);
 ResolveRepl    = Config->ReadBool(CFGSECBASE,"ResolveRepl",ResolveRepl);
 AskOverwrite   = Config->ReadBool(CFGSECBASE,"AskOverwrite",AskOverwrite);
 LoadAnyFormats = Config->ReadBool(CFGSECBASE,"LoadAnyFormats",LoadAnyFormats);
 OrigSubtitles  = Config->ReadBool(CFGSECBASE,"OrigSubtitles",OrigSubtitles);
 CSEmptyDlgAsCr = Config->ReadBool(CFGSECBASE,"CSEmptyDlgAsCr",CSEmptyDlgAsCr);
 int Lang       = Config->ReadInteger(CFGSECBASE,"FileTextLng",fmSettings->cmbFileLang->ItemIndex);
 fmSettings->cmbFileLang->ItemIndex      = (Lang < 0)?(0):(Lang);
 fmSettings->chbDelConfirm->Checked      = DelConfirm;
 fmSettings->chbDelToRecycle->Checked    = DelToRecycle;
 fmSettings->chbResolveRepl->Checked     = ResolveRepl;
 fmSettings->chbAskOverwrite->Checked    = AskOverwrite;
 fmSettings->chbLoadAnyFormat->Checked   = LoadAnyFormats;
 fmSettings->chbOrigSubtitles->Checked   = OrigSubtitles;
 fmSettings->chbEmptyActInfAsCr->Checked = CSEmptyDlgAsCr;

 fmSettings->edDataDir->Text     = Config->ReadString(CFGSECBASE,"DataDirectory","");
 fmSettings->edFileAlbum->Text   = Config->ReadString(CFGSECFILE,"FileDescr",fmSettings->edFileAlbum->Text.Trim());
 fmSettings->edFileCopyR->Text   = Config->ReadString(CFGSECFILE,"FileCopyright",fmSettings->edFileCopyR->Text.Trim());
 fmSettings->meFileComment->Text = Config->ReadString(CFGSECFILE,"FileComment",fmSettings->meFileComment->Text.Trim());

 fmSettings->cmbLanguage->ItemIndex = Config->ReadInteger(CFGSECBASE,"AppLangIndex",fmSettings->cmbLanguage->ItemIndex);
 fmSettings->trbCSRefresh->Position = Config->ReadInteger(CFGSECBASE,"CSRefreshMs",fmSettings->trbCSRefresh->Position);
 tRefreshCS->Interval = fmSettings->trbCSRefresh->Position;
 LangIndex = fmSettings->cmbLanguage->ItemIndex;

 meCalcText->Height = Config->ReadInteger(CFGSECBASE,"RTxtWndHeight",meCalcText->Height);
 meOrigText->Height = Config->ReadInteger(CFGSECBASE,"OTxtWndHeight",meOrigText->Height);
 Config->UpdateFile();
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::SaveConfiguration(void)
{
 AnsiString temps = fmSettings->edDataDir->Text.Trim();
 if(!temps.IsEmpty()&&(temps[temps.Length()]!=PATHDLML)&&(temps[temps.Length()]!=PATHDLMR))temps += "\\";

 DelConfirm     = fmSettings->chbDelConfirm->Checked;
 DelToRecycle   = fmSettings->chbDelToRecycle->Checked;
 ResolveRepl    = fmSettings->chbResolveRepl->Checked;
 AskOverwrite   = fmSettings->chbAskOverwrite->Checked;
 OrigSubtitles  = fmSettings->chbOrigSubtitles->Checked;
 CSEmptyDlgAsCr = fmSettings->chbEmptyActInfAsCr->Checked;
 LoadAnyFormats = fmSettings->chbLoadAnyFormat->Checked;
 Config->WriteBool(CFGSECBASE,"DelConfirm",DelConfirm);
 Config->WriteBool(CFGSECBASE,"DelToRecycle",DelToRecycle);
 Config->WriteBool(CFGSECBASE,"ResolveRepl",ResolveRepl);
 Config->WriteBool(CFGSECBASE,"AskOverwrite",AskOverwrite);
 Config->WriteBool(CFGSECBASE,"OrigSubtitles",OrigSubtitles);
 Config->WriteBool(CFGSECBASE,"LoadAnyFormats",LoadAnyFormats);
 Config->WriteBool(CFGSECBASE,"CSEmptyDlgAsCr",CSEmptyDlgAsCr);
 Config->WriteInteger(CFGSECBASE,"AppLangIndex",fmSettings->cmbLanguage->ItemIndex);
 Config->WriteInteger(CFGSECBASE,"FileTextLng",fmSettings->cmbFileLang->ItemIndex);
 Config->WriteString(CFGSECFILE,"FileDescr",fmSettings->edFileAlbum->Text.Trim());
 Config->WriteString(CFGSECFILE,"FileCopyright",fmSettings->edFileCopyR->Text.Trim());
 Config->WriteString(CFGSECFILE,"FileComment",fmSettings->meFileComment->Text.Trim());
 Config->WriteString(CFGSECBASE,"DataDirectory",temps);

 Config->WriteInteger(CFGSECBASE,"CSRefreshMs",fmSettings->trbCSRefresh->Position);
 Config->WriteInteger(CFGSECBASE,"RTxtWndHeight",meCalcText->Height);
 Config->WriteInteger(CFGSECBASE,"OTxtWndHeight",meOrigText->Height);
 tRefreshCS->Interval = fmSettings->trbCSRefresh->Position;
 Config->UpdateFile();
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::SetActorByFile(CSpeechFile* File)
{
 if(!File)return;
 int   Index  = 0;
 LPSTR ATypes = File->GetFileTitle();
 AnsiString AType = ExtractActorValue(ATypes, 'T');
 AnsiString ARace = ExtractActorValue(ATypes, 'R');
 AnsiString AGend = ExtractActorValue(ATypes, 'G');
 AnsiString AIden = ExtractActorValue(ATypes, 'I');

 cmbGender->Tag         = 1;
 meOrigText->Text       = File->GetFileLyrics();
 cmbType->ItemIndex     = cmbType->Items->IndexOf(AType);
 cmbType->OnChange(cmbType);
 cmbRace->ItemIndex     = cmbRace->Items->IndexOf(ARace);
 cmbGender->ItemIndex   = cmbGender->Items->IndexOf(AGend);
 cmbObjectID->ItemIndex = cmbObjectID->Items->IndexOf(AIden);
 if((cmbObjectID->ItemIndex <= 0) && !AIden.IsEmpty())cmbObjectID->Text = AIden;
 cmbGender->Tag         = 0;

 //cmbObjectID->OnChange(cmbObjectID);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TfmMainForm::CreateActorPath(void)
{
 AnsiString DstPath;
 if(cmbType->ItemIndex   > 0)DstPath += (SDIR_PREFIX+cmbType->Text.Trim()+SDIR_PREFIX+"\\");
 if(cmbRace->ItemIndex   > 0)DstPath += (SDIR_PREFIX+cmbRace->Text.Trim()+SDIR_PREFIX+"\\");
 if(cmbGender->ItemIndex > 0)DstPath += (SDIR_PREFIX+cmbGender->Text.Trim()+SDIR_PREFIX+"\\");
 if(!cmbObjectID->Text.Trim().IsEmpty())DstPath += cmbObjectID->Text.Trim()+"\\";
 return DstPath;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TfmMainForm::GetPathForFileNode(TTreeNode *Node)
{
 if(!Node || !Node->Data)return "";
 AnsiString temps = GetPathForNode(Node);
 if(temps.Length() > 0)
  {
   temps = temps.SetLength(temps.Length()-1);
   return (SpeechDir+temps+((CSpeechFile*)Node->Data)->GetFileExt());
  }
 return "";
}
//---------------------------------------------------------------------------
CSpeechFile* __fastcall TfmMainForm::GetSafeAudioFormat(LPSTR FilePath)
{
 bool  FileOK;
 DWORD BitRate;
 DWORD Channels;
 DWORD Frequency;
 static bool SkipAll=false;

 if(!IsFileExist(FilePath))return NULL;
 CSpeechFile* Speech = new CSpeechFile(FilePath);
 FileOK = (Speech->GetFileInfo(&BitRate, &Frequency, &Channels)&&(Speech->IsFileFormatOGG() || LoadAnyFormats ||(Speech->IsFileFormatMP3()&&(Channels==1)&&((BitRate==40000)||(BitRate==48000)||(BitRate==56000)||(BitRate==64000)))));
 AnsiString FileType = "UNKNOW";
 AnsiString BRate    = "UNKNOW";
 AnsiString Freq     = "UNKNOW";
 AnsiString Chan     = "UNKNOW";

 if(BitRate)BRate  = IntToStr(BitRate)+" Bit/Sec";
 if(Channels)Chan  = IntToStr(Channels);
 if(Frequency)Freq = IntToStr(Frequency)+" Hz";
 if(Channels == 1)Chan += " - MONO";
   else {if(Channels == 2)Chan += " - STEREO";}
 if(Speech->IsFileFormatOGG())FileType = "Ogg Vorbis";
   else {if(Speech->IsFileFormatMP3())FileType = "MPEG Layer 3";}

 if(FileOK)
  {
   LogMessage((AnsiString)"Found speech file: "+Speech->GetFileTitle());
   LogMessage((AnsiString)"Path: "+FilePath);
   LogMessage((AnsiString)"File type: "+FileType);
   LogMessage((AnsiString)"Frequency: "+Freq);
   LogMessage((AnsiString)"Bit rate: "+BRate);
   LogMessage((AnsiString)"Channels: "+Chan);
   LogMessage(LOGLINEDEL);
   return Speech;
  }
 if(!SkipAll)
  {
   SkipAll = (IDOK == MessageBox(this->Handle,
   ((AnsiString)"").sprintf(Localizer->GetLocString(LangIndex,"MBT_BADFORMAT"),FileType,BRate,Freq,Chan).c_str(),
   Localizer->GetLocString(LangIndex,"MBC_ERROR"),MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON1|MB_APPLMODAL));
  }
 LogMessage((AnsiString)"Unsupported audio file: "+FilePath);
 delete(Speech);
 return NULL;
}
//---------------------------------------------------------------------------
CSpeechFile* __fastcall TfmMainForm::PlaceSpeechFile(LPSTR DstPath, CSpeechFile* SrcFile)
{
 CRaceItem*   Race;
 CActorItem*  Actor;
 CSpeechFile* Speech;
 AnsiString   Title;
 AnsiString   Artist;
 AnsiString   Lyrics;

 if(!SrcFile || !DstPath || !DstPath[0])return NULL;
 if(!(Speech = GetSafeAudioFormat(SrcFile->GetFilePath())))return NULL;
 CreateDirectoryPath(ExtractFilePath(DstPath).c_str());
 Actor  = NULL;
 Race   = NULL;
 if(OrigSubtitles)Lyrics = meOrigText->Text.Trim();
   else Lyrics = meClearText->Text.Trim();

 if(cmbType->ItemIndex > 0)Title += "T:"+cmbType->Text.Trim();
 if(cmbRace->ItemIndex   > 0)Title += ((AnsiString)AINFODELIM+"R:"+cmbRace->Text.Trim());
 if(cmbGender->ItemIndex > 0)Title += ((AnsiString)AINFODELIM+"G:"+cmbGender->Text.Trim());
 if(!cmbObjectID->Text.Trim().IsEmpty())
  {
   Title += ((AnsiString)AINFODELIM+"I:"+cmbObjectID->Text.Trim());
   int index = cmbObjectID->Items->IndexOf(cmbObjectID->Text.Trim());
   if(index > 0)Actor = (CActorItem*)cmbObjectID->Items->Objects[index];  // First item is EMPTY
  }
 if(Actor)
  {
   if(!Actor->IsCreature())Artist = (AnsiString)Actor->GetObjectName()+AINFODELIM+Actor->GetRaceName()+AINFODELIM+Actor->GetClassName()+AINFODELIM+Actor->GetFactionName()+AINFODELIM+Actor->GetFactionRank()+AINFODELIM+Actor->GetCellID();
     else Artist = (AnsiString)Actor->GetObjectName()+AINFODELIM+Actor->GetCreatureType();
  }
   else
    {
     if(cmbType->ItemIndex == 1)    // NPC
      {
       int index  = cmbRace->Items->IndexOf(cmbRace->Text.Trim());
       if(index > 0)Race = (CRaceItem*)cmbRace->Items->Objects[index];  // First item is EMPTY
       if(Race)Artist = Race->GetRaceName();
      }
     if(cmbType->ItemIndex == 2)   // CREATURE
      {
       Artist = cmbRace->Text.Trim();
      }
	}
 // TODO: Get Class, Faction, Rank names for unknow actors from CS dialogue window
 if(!Artist.IsEmpty())
  {
   for(int pos;(pos = Artist.Pos((AnsiString)" "+AINFODELIM));)if(pos)Artist.Delete(pos,2);
   if(Artist.Length() >= 2){if(lstrcmpi(&Artist[Artist.Length()-1],AINFODELIM)==0)Artist = Artist.SetLength(Artist.Length()-2);}
  }
 Speech->SetTextLngIndex((int)fmSettings->cmbFileLang->Items->Objects[fmSettings->cmbFileLang->ItemIndex]);
 Speech->ChangeInformation(Title.Trim().c_str(), fmSettings->edFileAlbum->Text.Trim().c_str(), Artist.Trim().c_str(), Lyrics.Trim().c_str(), fmSettings->meFileComment->Text.Trim().c_str(),fmSettings->edFileCopyR->Text.Trim().c_str());
 if(Speech->SaveFile(DstPath)){Beep(500,100);delete(Speech);return NULL;}
 delete(Speech);
 return GetSafeAudioFormat(DstPath);
}
//===========================================================================
//                           MAIN FORM FUNCTIONS
//---------------------------------------------------------------------------
__fastcall TfmMainForm::TfmMainForm(TComponent* Owner) : TForm(Owner)
{
 StartupDir     = ExtractFilePath(Application->ExeName);
 PMenuNode      = NULL;
 CurrentCRC     = 0;
 CSThreadID     - -1;
 CSProcessID    = -1;
 LangIndex      = -1;
 HintShowDel    = 3000;
 DelConfirm     = true;
 DelToRecycle   = true;
 ResolveRepl    = true;
 AskOverwrite   = true;
 OrigSubtitles  = true;
 CSEmptyDlgAsCr = false;   // When no ID, Race, Gender  specified, it is a Creature or Global text?
 LoadAnyFormats = false;
 FirstStart     = !IsFileExist((StartupDir+CFGFILENAME).c_str());
 Config         = new TIniFile(StartupDir+CFGFILENAME);
 Localizer      = new CLocalizer();
 RaceList       = new TStringList;
 DefActor       = new CActorItem();
 SelActor       = DefActor;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::FormCreate(TObject *Sender)
{
 Panel1->Tag                = ((DWORD*)(&(twActorsSpeech->WindowProc)))[0];
 twActorsSpeech->WindowProc = TfmMainForm::twActorsSpeechWndProc;

 Application->HintHidePause = Application->HintPause+HintShowDel;
 hDlg=hCbID=hCbRace=hCbGender=hTopicTxt=NULL;
 FormTitle  = fmMainForm->Caption;
 tbPlaceFile->Enabled  = false;
 tbPlaySpeech->Enabled = false;
 cmbType->ItemIndex    = 0;
 Localizer->SetLocDocument((LPSTR)GetDataFromResource("LOCALIZE"));
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::FormShow(TObject *Sender)
{
 //SaveAppLangFile((StartupDir+"Localize.xml").c_str(), "ENG", "English", LANG_ENGLISH, "1251", "cmbType,cmbRace,cmbGender,cmbObjectID,meCalcText,meOrigText,meClearText,cmbLanguage,edDataDir,edFileAlbum,meFileComment,edFileCopyR,meMessages,N1,N2,reHelpInfo");
 for(int ctr=0;ctr < Localizer->GetLangCount();ctr++)fmSettings->cmbLanguage->Items->Add(Localizer->GetLangDescription(ctr));
 LoadConfiguration();

 if(LangIndex < 0)LangIndex = Localizer->GetLangIndexByID((GetUserDefaultLangID()&0x00FF));
 fmSettings->cmbLanguage->ItemIndex = (LangIndex < 0)?(0):(LangIndex);
 fmSettings->cmbLanguageSelect(NULL);

 SpeechDir = fmSettings->edDataDir->Text.Trim();
 if(!IsDirectoryValid(SpeechDir.c_str()))
  {
   BYTE PathBuf[MAX_PATH];
   if(FindDirectoryPath((StartupDir+"Data Files\\").c_str(),(LPSTR)&PathBuf))SpeechDir = (LPSTR)&PathBuf;
     else
      {
       SpeechDir = StartupDir;
       MessageBox(this->Handle,((AnsiString)"").sprintf(Localizer->GetLocString(LangIndex,"MBT_NOPATH"),SpeechDir).c_str(), Localizer->GetLocString(LangIndex,"MBC_NOPATH"),MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL);
      }
   fmSettings->edDataDir->Text = SpeechDir;
   SaveConfiguration();
  }
 SpeechDir += "Speech\\";
 CreateDirectoryPath(SpeechDir.c_str());
 LoadSpeechTree(SpeechDir.c_str(), twActorsSpeech, NULL);
 cmbType->OnChange(NULL);
 if(FirstStart){fmHelpForm->Show();fmHelpForm->BringToFront();}
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
 SaveConfiguration();
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
 if(Key == VK_F1)tlbMainToolBarDblClick(NULL);
}
//===========================================================================
//                          INFO PANEL FUNCTIONS
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::cmbTypeChange(TObject *Sender)
{
 cmbRace->Clear();
 switch(cmbType->ItemIndex)
  {
    case 1:
      if(RaceList->Count <= 0)
       {
        cmbRace->Items->Add("");
        cmbRace->Items->Add(BaseRaces[0]);
        cmbRace->Items->Add(BaseRaces[1]);
        cmbRace->Items->Add(BaseRaces[2]);
        cmbRace->Items->Add(BaseRaces[3]);
        cmbRace->Items->Add(BaseRaces[4]);
        cmbRace->Items->Add(BaseRaces[5]);
        cmbRace->Items->Add(BaseRaces[6]);
        cmbRace->Items->Add(BaseRaces[7]);
        cmbRace->Items->Add(BaseRaces[8]);
		cmbRace->Items->Add(BaseRaces[9]);
       }
        else cmbRace->Items->Assign(RaceList);
      cmbRace->ItemIndex   = 0;
      cmbGender->ItemIndex = 0;
      cmbGender->Enabled   = true;
      cmbRace->Enabled     = true;
      break;
    case 2:
      cmbRace->Items->Add("");
      cmbRace->Items->Add(CreatureTypes[0]);
      cmbRace->Items->Add(CreatureTypes[1]);
      cmbRace->Items->Add(CreatureTypes[2]);
      cmbRace->Items->Add(CreatureTypes[3]);
      cmbRace->ItemIndex   = 0;
      cmbGender->ItemIndex = -1;
      cmbGender->Enabled   = false;
      cmbRace->Enabled     = true;
      break;
    case 0:
      cmbGender->ItemIndex = -1;
      cmbGender->Enabled   = false;
	  cmbRace->Enabled     = false;
      break;
  }
 cmbRace->OnChange(cmbRace);
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::cmbGenderChange(TObject *Sender)
{
 AnsiString temps    = CreateActorPath();
 TTreeNode *FileNode = ExpandNodePath(twActorsSpeech->Items->GetFirstNode(),temps.c_str());
 if(FileNode && IsDirectoryValid((SpeechDir+temps).c_str()))
  {
   temps = IntToHex((int)CurrentCRC, 8);
   if(FileNode->Parent)FileNode = GetChildNode(FileNode->Parent, temps.c_str());
     else FileNode = GetSiblingNode(FileNode, temps.c_str());
   if(FileNode && FileNode->Data)
    {
     twActorsSpeech->Tag      = 1;
     twActorsSpeech->TopItem  = FileNode;
     twActorsSpeech->Selected = FileNode;
     twActorsSpeech->Tag      = 0;
     SetNodeState(FileNode, TVIS_BOLD);
     return;
    }
  }
 if(!cmbGender->Tag && twActorsSpeech->Selected){SetNodeState(twActorsSpeech->Selected, 0);twActorsSpeech->Selected = NULL;}
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::cmbObjectIDChange(TObject *Sender)
{
 CActorItem* Actor = (cmbObjectID->ItemIndex > 0)?((CActorItem*)cmbObjectID->Items->Objects[cmbObjectID->ItemIndex]):(NULL);
 if(Actor)SelActor = Actor;
  else SelActor = DefActor;
 cmbGenderChange(cmbGender);
 meOrigTextChange(meOrigText);
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::cmbObjectIDSelect(TObject *Sender)
{
 if(cmbObjectID->ItemIndex < 0){cmbObjectID->Hint="";cmbObjectIDChange(cmbObjectID);return;}
 CActorItem* Actor = (CActorItem*)cmbObjectID->Items->Objects[cmbObjectID->ItemIndex];

 if(!Actor->IsCreature())
  {
   cmbType->ItemIndex = 1;
   cmbType->OnChange(cmbType);
   if(Actor->IsFemale())cmbGender->ItemIndex = 2;
     else cmbGender->ItemIndex = 1;
   int Index = cmbRace->Items->IndexOf(Actor->GetRaceID());
   cmbRace->ItemIndex = (Index >= 0)?(Index):(0);
  }
   else
    {
     cmbType->ItemIndex   = 2;
     cmbGender->ItemIndex = 0;
     cmbType->OnChange(cmbType);
     int Index = cmbRace->Items->IndexOf(Actor->GetCreatureType());
     cmbRace->ItemIndex = (Index >= 0)?(Index):(0);
     cmbRace->Hint = "";
    }
 cmbRace->OnChange(cmbRace);
 cmbObjectID->Hint = Actor->GetObjectName();
 cmbObjectIDChange(cmbObjectID);
 LogMessage("Actor Selected:");
 LogMessage((AnsiString)"ID="+Actor->GetObjectID());
 LogMessage((AnsiString)"NAME="+Actor->GetObjectName());
 if(!Actor->IsCreature())
  {
   LogMessage((AnsiString)"RACE ID="+Actor->GetRaceID());
   LogMessage((AnsiString)"RACE NAME="+Actor->GetRaceName());
   if(Actor->IsFemale())LogMessage("GENDER=Female");
     else LogMessage("GENDER=Male");
  }
   else LogMessage((AnsiString)"TYPE="+Actor->GetCreatureType());
 LogMessage((AnsiString)"CS ADDRESS=0x"+IntToHex((int)Actor->GetCSAddress(),8));
 LogMessage(LOGLINEDEL);
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::cmbRaceChange(TObject *Sender)
{
 if(cmbRace->ItemIndex > 0)
  {
   CRaceItem* Race = (CRaceItem*)cmbRace->Items->Objects[cmbRace->ItemIndex];
   if(Race){cmbRace->Hint = Race->GetRaceName();cmbGenderChange(cmbGender);return;}
  }
 cmbRace->Hint = "";
 cmbGenderChange(cmbGender);
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::edSrcFileChange(TObject *Sender)
{
 bool PathValid = IsFileExist((edSrcFile->Text.Trim()).c_str());
 tbPlaySpeech->Enabled = PathValid||(!MediaPlayer1->FileName.IsEmpty());
 tbPlaceFile->Enabled  = (tbPlaySpeech->Enabled && !meCalcText->Text.IsEmpty());
 if(edSrcFile->Text.Trim().IsEmpty() || PathValid)edSrcFile->Color = clWindow;
   else edSrcFile->Color = clYellow;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::meOrigTextChange(TObject *Sender)
{
 AnsiString temps = meOrigText->Text.Trim();
 if(ResolveRepl && SelActor && meOrigText->ReadOnly)   // Do not allow mess up data - replace only from CS
  {
   if(SelActor->GetObjectName()) temps = StringReplace(temps,((AnsiString)"%"+DlgReplacers[0]),SelActor->GetObjectName(),TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
   if(SelActor->GetRaceName())   temps = StringReplace(temps,((AnsiString)"%"+DlgReplacers[1]),SelActor->GetRaceName(),TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
   if(SelActor->GetClassName())  temps = StringReplace(temps,((AnsiString)"%"+DlgReplacers[2]),SelActor->GetClassName(),TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
   if(SelActor->GetFactionName())temps = StringReplace(temps,((AnsiString)"%"+DlgReplacers[3]),SelActor->GetFactionName(),TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
   if(SelActor->GetFactionRank())temps = StringReplace(temps,((AnsiString)"%"+DlgReplacers[4]),SelActor->GetFactionRank(),TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
   //if(SelActor->GetCellName())   temps = StringReplace(temps,((AnsiString)"%"+DlgReplacers[5]),SelActor->GetCellName(),TReplaceFlags()<<rfReplaceAll);    // Will be current cell in geme
  }
 NormalizeTextString(temps.c_str(), temps.c_str());
 meClearText->Text = temps;
 CurrentCRC = MakeRawTextAndCRC(temps.c_str());
 meCalcText->Text  = temps;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::meCalcTextChange(TObject *Sender)
{
 edSrcFile->OnChange(edSrcFile);
 cmbGender->OnChange(cmbGender);
}
//===========================================================================
//                        TIMER FUNCTIONS
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tRefreshCSTimer(TObject *Sender)
{
 bool GetInfo   = false;
 bool UpdateInf = false;
 BYTE Buffer[1024];

 if(tbCaptureCS->ImageIndex < 3)tbCaptureCS->ImageIndex++;
   else tbCaptureCS->ImageIndex = 0;
 if(GetWindowThreadProcessId(hMainCS, NULL) != CSThreadID){hMainCS=hDlg=NULL;tbCaptureCS->Down = false;LogMessage("TES3 CS is closed.");tbCaptureCSClick(tbCaptureCS);return;} // Exit if CS closed
 if(hMainCS){hDlg = FindWindow("#32770","Dialogue");hCbID=hCbRace=hCbGender=hTopicTxt=NULL;}  // hMainCS not parent for it !   // May be many dialogue windows
 if(hDlg){hCbID = GetDlgItem(hDlg,1000);hCbRace = GetDlgItem(hDlg,1083);hCbGender = GetDlgItem(hDlg,1084);hTopicTxt = GetDlgItem(hDlg,1002);}
 if(!hCbID||!hCbRace||!hCbGender||!hTopicTxt)hDlg = NULL;

 tRefreshCS->Tag = 1;
 if(hTopicTxt)
  {
   ZeroMemory(&Buffer,sizeof(Buffer));
   SendMessage(hTopicTxt,WM_GETTEXT,sizeof(Buffer),(LPARAM)&Buffer);
   meOrigText->Text = (LPSTR)&Buffer;
  }
 if(hCbID)
  {
   ZeroMemory(&Buffer,sizeof(Buffer));
   SendMessage(hCbID,WM_GETTEXT,sizeof(Buffer),(LPARAM)&Buffer);
   int Index = cmbObjectID->Items->IndexOf((LPSTR)&Buffer);
   if(Index >= 0)
    {
     if(cmbObjectID->Text.AnsiCompareIC((LPSTR)&Buffer)!=0){cmbObjectID->ItemIndex = Index;cmbObjectID->Text = (LPSTR)&Buffer;cmbObjectID->OnSelect(cmbObjectID);}
     GetInfo=false;             // ID present - all remaining information was taked from this ID
    }
    else {cmbObjectID->Text = (LPSTR)&Buffer;GetInfo=true;}   // This ID not in list
  }
 if(hCbRace && GetInfo)
  {
   int LastInd = cmbRace->ItemIndex;
   ZeroMemory(&Buffer,sizeof(Buffer));
   SendMessage(hCbRace,WM_GETTEXT,sizeof(Buffer),(LPARAM)&Buffer);
   if(Buffer[0])
    {
     if(cmbType->ItemIndex != 1){cmbType->ItemIndex = 1;cmbType->OnChange(NULL);}    // Actor is NPC if 'RACE' present
     int Index = cmbRace->Items->IndexOf((LPSTR)&Buffer);
     if(Index >= 0)cmbRace->ItemIndex = Index;
       else cmbRace->ItemIndex = 0;
    }
     else cmbRace->ItemIndex = 0;
   if(LastInd != cmbRace->ItemIndex)UpdateInf = true;
  }
 if(hCbGender && GetInfo)
  {
   int LastInd = cmbGender->ItemIndex;
   ZeroMemory(&Buffer,sizeof(Buffer));
   SendMessage(hCbGender,WM_GETTEXT,sizeof(Buffer),(LPARAM)&Buffer);
   if(Buffer[0])
    {
     if(cmbType->ItemIndex != 1){cmbType->ItemIndex = 1;cmbType->OnChange(NULL);}    // Actor is NPC if 'GENDER' present
     if((Buffer[0]=='M')||(Buffer[0]=='m'))cmbGender->ItemIndex = 1;
       else cmbGender->ItemIndex = 2;
    }
     else cmbGender->ItemIndex = 0;
   if(LastInd != cmbGender->ItemIndex)UpdateInf = true;
  }

 if((cmbGender->ItemIndex <= 0) && (cmbRace->ItemIndex <= 0)){if(cmbType->ItemIndex > 0){cmbType->ItemIndex = (CSEmptyDlgAsCr)?(2):(0);cmbType->OnChange(NULL);}}
   else {if(cmbType->ItemIndex <= 0){cmbType->ItemIndex = 1;cmbType->OnChange(NULL);}}

 if(UpdateInf)cmbRace->OnChange(cmbRace);
 tRefreshCS->Tag = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tPlayProgrTimer(TObject *Sender)
{
 switch(MediaPlayer1->Mode)
  {
   case mpPlaying:
     tPlayProgr->Enabled = true;
     edSrcFile->OnChange(edSrcFile);
     stbAppStatus->Panels->Items[0]->Text = ((AnsiString)"").sprintf(Localizer->GetLocString(LangIndex,"PLAYFILE"),ExtractFileName(MediaPlayer1->FileName),(_NUMTOPERC((MediaPlayer1->Position), (MediaPlayer1->Length))));//   "Playing file: "+ExtractFileName(MediaPlayer1->FileName)+" - "+IntToStr((_NUMTOPERC((MediaPlayer1->Position), (MediaPlayer1->Length))))+" %";
     tbPlaySpeech->ImageIndex = 9;
     break;
   case mpStopped:
     MediaPlayer1->Close();
     MediaPlayer1->FileName   = "";
     stbAppStatus->Panels->Items[0]->Text = "";
     tbPlaySpeech->ImageIndex = 8;
     edSrcFile->OnChange(edSrcFile);
     tPlayProgr->Enabled = false;
     break;
  }
}
//===========================================================================
//                         TOOLBAR FUNCTIONS
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tlbMainToolBarDblClick(TObject *Sender)
{
 POINT    Point;
 TControl *Control;

 fmHelpForm->reHelpInfo->SelLength = 0;
 fmHelpForm->reHelpInfo->SelStart  = 0;
 SendMessage(fmHelpForm->reHelpInfo->Handle, SB_TOP, 0, 0);  // fmHelpForm->reHelpInfo->Perform(SB_TOP,0,0);
 SendMessage(fmHelpForm->reHelpInfo->Handle, EM_SCROLLCARET, 0, 0);

 GetCursorPos(&Point);
 ::ScreenToClient(this->Handle,&Point);
 Control = fmMainForm->ControlAtPos(Point, true, true, true);
 if(Control && Control->HelpKeyword.IsEmpty() && Control->InheritsFrom(__classid(TWinControl)))
	{
	 GetCursorPos(&Point);
	 ::ScreenToClient(((TWinControl*)Control)->Handle,&Point);
	 Control = ((TWinControl*)Control)->ControlAtPos(Point, true, true, true);
	}
 if(!Control)Control = FindControlUnderMouse(this);
 if(Control && !Control->HelpKeyword.IsEmpty())
	{
	 AnsiString find = Control->HelpKeyword;
	 int Position    = fmHelpForm->reHelpInfo->Text.Pos(find);

	 fmHelpForm->reHelpInfo->SelStart  = (Position > 0)?(Position-1):(0);  // fmHelpForm->reHelpInfo->Text.Length()-1;
	 fmHelpForm->reHelpInfo->SelLength = 300;
	 SendMessage(fmHelpForm->reHelpInfo->Handle, EM_SCROLLCARET, 0, 0);    // fmHelpForm->reHelpInfo->Perform(EM_SCROLLCARET, 0, 0);
	 fmHelpForm->reHelpInfo->SelLength = (fmHelpForm->reHelpInfo->SelStart)?(find.Trim().Length()):(0);
	}
 fmHelpForm->Show();
 this->BringToFront();
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tbSettingsClick(TObject *Sender)
{
 fmSettings->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tbStayOnTopClick(TObject *Sender)
{
 tbStayOnTop->ImageIndex = (11+(bool)tbStayOnTop->Down);
 if(tbStayOnTop->Down)fmMainForm->FormStyle = fsStayOnTop;
   else fmMainForm->FormStyle = fsNormal;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tbSelectFileClick(TObject *Sender)
{
 if(odSelectMP3->Execute())
  {
   CSpeechFile *NewSpeech = GetSafeAudioFormat(odSelectMP3->FileName.c_str());
   if(NewSpeech){edSrcFile->Text = odSelectMP3->FileName;delete(NewSpeech);}
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tbPlaceFileClick(TObject *Sender)
{
 while(tRefreshCS->Tag);  // Wait for finising info refresh
 cmbType->Refresh();
 cmbRace->Refresh();
 cmbGender->Refresh();
 cmbObjectID->Refresh();
 AnsiString DstPath     = CreateActorPath();
 AnsiString FileName    = IntToHex((int)CurrentCRC,8);
 CSpeechFile *NewSpeech = GetSafeAudioFormat(edSrcFile->Text.Trim().c_str());

 DstPath += FileName+NewSpeech->GetFileExt();
 AnsiString FilePath    = (SpeechDir+DstPath);

 if(AskOverwrite && IsFileExist(FilePath.c_str()))
  {
   if(IDCANCEL == MessageBox(this->Handle,((AnsiString)"").sprintf(Localizer->GetLocString(LangIndex,"MBT_CONFOVERWR"),FilePath).c_str(), Localizer->GetLocString(LangIndex,"MBC_CONFOVERWR"),MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2|MB_APPLMODAL))
    {
     if(NewSpeech)delete(NewSpeech);
     return;
    }
  }
 CSpeechFile* Speech = PlaceSpeechFile(FilePath.c_str(), NewSpeech);
 if(Speech)
  {
   TTreeNode* ChildNode = NULL;
   TTreeNode* NewNode   = CreateNodeForPath(DstPath.c_str(), twActorsSpeech, twActorsSpeech->Items->GetFirstNode());
   if(NewNode)ChildNode = GetChildNode(NewNode, FileName.c_str());
     else ChildNode = GetSiblingNode(twActorsSpeech->Items->GetFirstNode(), FileName.c_str());

   if(!ChildNode)ChildNode = twActorsSpeech->Items->AddChild(NewNode,FileName);
     else delete((CSpeechFile*)ChildNode->Data);

   twActorsSpeech->Tag   = 1;
   ChildNode->Data       = NULL;
   ChildNode->StateIndex = 1;
   twActorsSpeech->TopItem  = ChildNode;
   twActorsSpeech->Selected = ChildNode;       // First select to do not allow text window updating
   ChildNode->Data = (PVOID)Speech;
   twActorsSpeech->Tag   = 0;
   LogMessage((AnsiString)"File Saved: "+FilePath);
   Beep(1000,100);
  }
   else {Beep(100,100);Beep(50,100);LogMessage((AnsiString)"Nothing to save as: "+FilePath);}
 if(NewSpeech)delete(NewSpeech);
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tbPasteClbClick(TObject *Sender)
{
 OpenClipboard(NULL);
 if(IsClipboardFormatAvailable(CF_TEXT))
  {
   HANDLE hBufferTxt  = GetClipboardData(CF_UNICODETEXT);
   PVOID  DataPointer = GlobalLock(hBufferTxt);
   WideString tempW   = (wchar_t*)DataPointer;
   GlobalUnlock(hBufferTxt);

   hBufferTxt  = GetClipboardData(CF_TEXT);
   DataPointer = GlobalLock(hBufferTxt);
   AnsiString tempsA  = (LPSTR)DataPointer;
   GlobalUnlock(hBufferTxt);

   if(CharCount(tempsA.c_str(),0x3F) > (tempsA.Length()/2))meOrigText->Text = tempW;
     else meOrigText->Text = tempsA;
  }
 CloseClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tbPlaySpeechClick(TObject *Sender)
{
 if(MediaPlayer1->Mode != mpPlaying)
  {
   if(MediaPlayer1->FileName.IsEmpty())MediaPlayer1->FileName = edSrcFile->Text.Trim();
   if(!IsFileExist(MediaPlayer1->FileName.c_str())){MediaPlayer1->FileName="";return;}
   if(!MediaPlayer1->DeviceID)MediaPlayer1->Open();
   MediaPlayer1->TimeFormat = tfMilliseconds;
   tPlayProgr->Enabled = true;
   MediaPlayer1->Play();
   LogMessage((AnsiString)"Playing: "+MediaPlayer1->FileName);
  }
   else {MediaPlayer1->Stop();LogMessage("Playing finished.");}
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::tbCaptureCSClick(TObject *Sender)
{
 bool CSLoaded = hMainCS;

 hMainCS = FindWindow("TES3 Editor Class", NULL);  // Window name may have '*' at end of 'TES Construction Set'
 if(((TToolButton*)Sender)->Down)
  {
   if(hMainCS)
	{
	 if(GetWindowThreadProcessId(hMainCS, NULL)!=CSThreadID)
	  {
	   LogMessage("TES3 CS is running. Loading objects...");
	   stbAppStatus->Panels->Items[0]->Text = Localizer->GetLocString(LangIndex, "LOADOBJECTS");
	   for(int ctr=0;ctr<RaceList->Count;ctr++)if(RaceList->Objects[ctr])delete((CRaceItem*)RaceList->Objects[ctr]);
	   for(int ctr=0;ctr<cmbObjectID->Items->Count;ctr++)if(cmbObjectID->Items->Objects[ctr])delete((CRaceItem*)cmbObjectID->Items->Objects[ctr]);
	   RaceList->Clear();
	   RaceList->Add("");
	   cmbObjectID->Clear();
	   cmbObjectID->Items->Add("");
	   CSThreadID = GetWindowThreadProcessId(hMainCS, &CSProcessID);
	   LogMessage((AnsiString)"Races loaded: "+IntToStr(LoadRacesList(RaceList, CSProcessID)));
	   LogMessage((AnsiString)"Actors loaded: "+IntToStr(LoadActorsList(cmbObjectID->Items, CSProcessID)));
       tRefreshCSTimer(NULL);
	   stbAppStatus->Panels->Items[0]->Text = "";
	   if(cmbObjectID->ItemIndex <= 0)LogMessage(LOGLINEDEL);
	  }
	}
	 else {((TToolButton*)Sender)->Down = false; LogMessage("TES3 CS is NOT running!");}
  }
 Panel3->Enabled         = !((TToolButton*)Sender)->Down;
 Panel4->Enabled         = Panel3->Enabled;
 tbPasteClb->Enabled     = Panel3->Enabled;
 tRefreshCS->Enabled     = !Panel3->Enabled;
 meOrigText->ReadOnly    = !Panel3->Enabled;
 tbCaptureCS->ImageIndex = 0;
 meOrigTextChange(meOrigText);
}
//===========================================================================
//                        SPEECH TREE FUNCTIONS
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::twActorsSpeechDeletion(TObject *Sender, TTreeNode *Node)
{
 if(Node->Data)delete((CSpeechFile*)Node->Data);    // Delete MP3 speech info associated with the nodes
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::twActorsSpeechClick(TObject *Sender)
{
 twActorsSpeech->OnChange(twActorsSpeech,GetTreeItemUnderMouse(twActorsSpeech));
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::twActorsSpeechChanging(TObject *Sender, TTreeNode *Node, bool &AllowChange)
{
 if(Node)
  {
   if((AllowChange = (!Splitter3->Tag && (!tRefreshCS->Enabled || twActorsSpeech->Tag) && !(Node->StateIndex > 1))))
    {
     if(twActorsSpeech->Selected)SetNodeState(twActorsSpeech->Selected, 0);
     SetNodeState(Node, TVIS_BOLD);
    }
   Splitter3->Tag = 0;    // Restore popup reaction
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::twActorsSpeechChange(TObject *Sender, TTreeNode *Node)
{
 if(Node && Node->Data)
  {
   if(!twActorsSpeech->Tag)edSrcFile->Text = GetPathForFileNode(Node); // If the NODE path is wrong - text will be highlated
   if(!tRefreshCS->Enabled)SetActorByFile((CSpeechFile*)Node->Data);
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::twActorsSpeechExpanding(TObject *Sender, TTreeNode *Node, bool &AllowExpansion)
{
 TTreeNode *DummyNode = GetChildNode(Node, DUMMYNODE);
 if(DummyNode)
  {
   DummyNode->Delete();
   LoadSpeechTree((SpeechDir+GetPathForNode(Node)).c_str(), (TTreeView*)Sender, Node);
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::twActorsSpeechContextPopup(TObject *Sender, TPoint &MousePos, bool &Handled)
{
 PMenuNode = twActorsSpeech->GetNodeAt(MousePos.x,MousePos.y);
 if(!PMenuNode)PMenuNode = twActorsSpeech->Selected;
 if(!PMenuNode){Handled=true;return;}
 N1->Visible = (PMenuNode->Data);
 miPlaySpeech->Visible = N1->Visible;
 miExternPlay->Visible = N1->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::twActorsSpeechMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
 // Only these hint operations forces the hints !
 TTreeNode* TmpNode = GetTreeItemUnderMouse((TTreeView*)Sender);  //twActorsSpeech->GetNodeAt(X,Y);
 if(TmpNode && TmpNode->Data && twActorsSpeech->Hint.IsEmpty())
  {
   LPSTR Year      = ((CSpeechFile*)TmpNode->Data)->GetFileYear();
   LPSTR Title     = ((CSpeechFile*)TmpNode->Data)->GetFileTitle();
   LPSTR Album     = ((CSpeechFile*)TmpNode->Data)->GetFileAlbum();
   LPSTR Artist    = ((CSpeechFile*)TmpNode->Data)->GetFileArtist();
   LPSTR Lyrics    = ((CSpeechFile*)TmpNode->Data)->GetFileLyrics();
   LPSTR Comments  = ((CSpeechFile*)TmpNode->Data)->GetFileComments();
   LPSTR CopyRight = ((CSpeechFile*)TmpNode->Data)->GetFileCopyRight();
   AnsiString temps;

   if(Artist)temps    += (AnsiString)"ACTOR: "+Artist+"\r\n";
   if(Title)temps     += (AnsiString)"TYPES: "+Title+"\r\n";
   if(Album)temps     += (AnsiString)"DESCRIPTION: "+Album+"\r\n";
   if(CopyRight)temps += (AnsiString)"COPYRIGHT: "+CopyRight+"\r\n";
	 else {if(Year)temps += (AnsiString)"YEAR: "+Year+"\r\n";}
   if(Comments)temps  += (AnsiString)"COMMENT: "+Comments+"\r\n";
   if(Lyrics)temps    += (AnsiString)"TEXT: "+WrapText(Lyrics, "\r\n", TSysCharSet()<<','<<'.'<<'-'<<' ', 80);

   twActorsSpeech->Hint       = temps;
   Application->HintHidePause = Application->HintPause+(temps.Length()*40);
   Application->CancelHint();
   Application->ActivateHint(TPoint(X,Y));
  }
 if(!TmpNode || !TmpNode->Data){twActorsSpeech->Hint = "";Application->HintHidePause = Application->HintPause+HintShowDel;Application->CancelHint();}
}
//===========================================================================
//                      TREE POPUP MENU FUNCTIONS
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::miPlaySpeechClick(TObject *Sender)
{
 if(!PMenuNode)PMenuNode = twActorsSpeech->Selected;   // If key shortcut used
 if(!PMenuNode)return;
 MediaPlayer1->FileName = GetPathForFileNode(PMenuNode);
 tbPlaySpeechClick(tbPlaySpeech);
 PMenuNode = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::miExternPlayClick(TObject *Sender)
{
 if(!PMenuNode)PMenuNode = twActorsSpeech->Selected;   // If key shortcut used
 if(!PMenuNode)return;
 ShellExecute(Handle,"Open",GetPathForFileNode(PMenuNode).c_str(),NULL,NULL,SW_SHOWNORMAL); // If the NODE path is wrong - nothing will be played
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::miExpandAllClick(TObject *Sender)
{
 if(!PMenuNode)twActorsSpeech->FullExpand();  // If key shortcut used
   else PMenuNode->Expand(true);
 PMenuNode = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::miCollapseAllClick(TObject *Sender)
{
 if(!PMenuNode)twActorsSpeech->FullCollapse();  // If key shortcut used
   else PMenuNode->Collapse(true);
 PMenuNode = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::miExpandClick(TObject *Sender)
{
 if(!PMenuNode)return;
 PMenuNode->Expand(false);
 PMenuNode = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::miCollapseClick(TObject *Sender)
{
 if(!PMenuNode)return;
 PMenuNode->Collapse(false);
 PMenuNode = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::miDeleteSpeechClick(TObject *Sender)
{
 AnsiString temps;

 if(!PMenuNode)PMenuNode = twActorsSpeech->Selected;   // If key shortcut used
 if(!PMenuNode)return;
 stbAppStatus->Panels->Items[0]->Text = Localizer->GetLocString(LangIndex,"DELETEFILES");
 if(PMenuNode->Data)
  {
   temps = GetPathForFileNode(PMenuNode);
   if(DelConfirm && (IDOK == MessageBox(this->Handle,((AnsiString)"").sprintf(Localizer->GetLocString(LangIndex,"MBT_FILEDEL"),PMenuNode->Text).c_str(), Localizer->GetLocString(LangIndex,"MBC_CONFDELETE"),MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2|MB_APPLMODAL)))
    {
     SetFileAttributes(temps.c_str(),FILE_ATTRIBUTE_NORMAL);
     if(DelToRecycle)DeleteToRecycleBin(temps.c_str());
       else DeleteFile(temps.c_str());
    }
  }
   else
    {
     temps = GetPathForNode(PMenuNode);
     temps = temps.SetLength(temps.Length()-1);
     if(DelConfirm && (IDOK == MessageBox(this->Handle,((AnsiString)"").sprintf(Localizer->GetLocString(LangIndex,"MBT_DIRDEL"),temps).c_str(), Localizer->GetLocString(LangIndex,"MBC_CONFDELETE"),MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2|MB_APPLMODAL)))
      {
	   temps = SpeechDir+temps;
       if(DelToRecycle)DeleteToRecycleBin(temps.c_str());
         else DeleteFolder(temps.c_str());
      }
       else temps = SpeechDir+temps;
    }

 if(!IsPathNameExist(temps.c_str())){PMenuNode->Delete();edSrcFile->OnChange(edSrcFile);}     // If file deleted - delete node
   else LogMessage("Deleting FAILED!");
 stbAppStatus->Panels->Items[0]->Text = "";
 PMenuNode = NULL;
}
//---------------------------------------------------------------------------

