//---------------------------------------------------------------------------

#ifndef fmMainFormH
#define fmMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <XPMan.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <MPlayer.hpp>
#include <Menus.hpp>
#include <IniFiles.hpp>

#include "HelperFuncs.h"
//---------------------------------------------------------------------------
class TfmMainForm : public TForm
{
__published:	// IDE-managed Components
    TOpenDialog *odSelectMP3;
    TPanel *Panel2;
    TToolBar *tlbMainToolBar;
    TToolButton *tbSelectFile;
    TToolButton *tbPlaceFile;
    TToolButton *tbSettings;
    TPanel *Panel1;
    TEdit *edSrcFile;
    TMemo *meCalcText;
    TSplitter *Splitter2;
    TMemo *meOrigText;
    TStatusBar *stbAppStatus;
    TSplitter *Splitter3;
    TTreeView *twActorsSpeech;
    TXPManifest *XPManifest1;
    TToolButton *tbCaptureCS;
    TTimer *tRefreshCS;
    TToolButton *ToolButton5;
    TMemo *meClearText;
    TSplitter *Splitter1;
    TImageList *ilTB_Normal;
    TImageList *ilST_State;
    TToolButton *ToolButton1;
    TToolButton *tbPlaySpeech;
    TPanel *Panel3;
    TComboBox *cmbType;
    TPanel *Panel4;
    TComboBox *cmbObjectID;
    TComboBox *cmbRace;
    TComboBox *cmbGender;
    TToolButton *tbPasteClb;
    TMediaPlayer *MediaPlayer1;
    TTimer *tPlayProgr;
    TPopupMenu *pmSpeechMenu;
	TToolButton *tbShowHelp;
    TMenuItem *miDeleteSpeech;
    TMenuItem *miPlaySpeech;
    TMenuItem *N1;
    TMenuItem *N2;
    TMenuItem *miExpand;
    TMenuItem *miCollapse;
    TMenuItem *miExpandAll;
    TMenuItem *miCollapseAll;
    TImageList *ilTB_Disabled;
    TImageList *il_PMenu;
    TMenuItem *miExternPlay;
    TToolButton *tbStayOnTop;
    TToolButton *ToolButton2;
    void __fastcall cmbTypeChange(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall meOrigTextChange(TObject *Sender);
    void __fastcall edSrcFileChange(TObject *Sender);
    void __fastcall tRefreshCSTimer(TObject *Sender);
    void __fastcall tbCaptureCSClick(TObject *Sender);
    void __fastcall tbSelectFileClick(TObject *Sender);
    void __fastcall tbPlaceFileClick(TObject *Sender);
    void __fastcall twActorsSpeechChanging(TObject *Sender, TTreeNode *Node, bool &AllowChange);
    void __fastcall tbPasteClbClick(TObject *Sender);
    void __fastcall tbPlaySpeechClick(TObject *Sender);
    void __fastcall cmbObjectIDSelect(TObject *Sender);
    void __fastcall cmbRaceChange(TObject *Sender);
    void __fastcall twActorsSpeechChange(TObject *Sender, TTreeNode *Node);
    void __fastcall twActorsSpeechContextPopup(TObject *Sender, TPoint &MousePos, bool &Handled);
    void __fastcall tPlayProgrTimer(TObject *Sender);
    void __fastcall miDeleteSpeechClick(TObject *Sender);
    void __fastcall twActorsSpeechDeletion(TObject *Sender, TTreeNode *Node);
    void __fastcall miExpandAllClick(TObject *Sender);
    void __fastcall miCollapseAllClick(TObject *Sender);
    void __fastcall miExpandClick(TObject *Sender);
    void __fastcall miCollapseClick(TObject *Sender);
    void __fastcall miPlaySpeechClick(TObject *Sender);
    void __fastcall tbSettingsClick(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall twActorsSpeechExpanding(TObject *Sender, TTreeNode *Node, bool &AllowExpansion);
    void __fastcall miExternPlayClick(TObject *Sender);
    void __fastcall cmbObjectIDChange(TObject *Sender);
    void __fastcall cmbGenderChange(TObject *Sender);
	void __fastcall twActorsSpeechMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall tbStayOnTopClick(TObject *Sender);
    void __fastcall meCalcTextChange(TObject *Sender);
    void __fastcall twActorsSpeechClick(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall tlbMainToolBarDblClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    HWND  hDlg;
    HWND  hCbID;
    HWND  hCbRace;
    HWND  hCbGender;
    HWND  hTopicTxt;
    HWND  hMainCS;
	DWORD CSThreadID;
	DWORD CSProcessID;
	DWORD CurrentCRC;
    bool  ResolveRepl;
    bool  AskOverwrite;
    bool  OrigSubtitles;
    bool  CSEmptyDlgAsCr;
    bool  LoadAnyFormats;
	bool  DelToRecycle;
	bool  DelConfirm;
	bool  FirstStart;
	int   HintShowDel;
    int   LangIndex;
	TIniFile    *Config;
    TTreeNode   *PMenuNode;
	TStringList *RaceList;
    PCLocalizer Localizer;
    CActorItem  *SelActor;
    CActorItem  *DefActor;
    AnsiString  FormTitle;
    AnsiString  StartupDir;
    AnsiString  SpeechDir;

     void         __fastcall twActorsSpeechWndProc(TMessage &Message);
	 void         __fastcall LoadConfiguration(void);
	 void         __fastcall SaveConfiguration(void);
	 void         __fastcall LogMessage(AnsiString Message);
     void         __fastcall SetActorByFile(CSpeechFile* File);
     AnsiString   __fastcall GetPathForFileNode(TTreeNode *Node);
     AnsiString   __fastcall CreateActorPath(void);
     CSpeechFile* __fastcall GetSafeAudioFormat(LPSTR FilePath);
     CSpeechFile* __fastcall PlaceSpeechFile(LPSTR DstPath, CSpeechFile* SrcFile);

    __fastcall TfmMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMainForm *fmMainForm;
//---------------------------------------------------------------------------
#endif
